function mstat

if (isunix==1)
	feature('DefaultCharacterSet','CP1250');
	
	font_name='Helvetica';
	if (ismac==0)
		font_size=8;
	else
		font_size=10;
	end;

	set(0,'defaultUicontrolFontName',font_name);
	set(0,'defaultUicontrolFontSize',font_size);
	set(0,'defaultUitableFontName',font_name);
	set(0,'defaultUitableFontSize',font_size);
	set(0,'defaultUipanelFontName',font_name);
	set(0,'defaultUipanelFontSize',font_size);
	set(0,'defaultAxesFontName',font_name);
	set(0,'defaultAxesFontSize',font_size);
	set(0,'defaultTextFontName',font_name);
	set(0,'defaultTextFontSize',font_size);
end;

screen=get(0,'Screensize');
screen_x=screen(3);
screen_y=screen(4);

size_x=774;
size_y=495;
pos_x=floor((screen_x-size_x)/2);
pos_y=floor((screen_y-size_y-70)/2);

if (pos_y+size_y+70>screen_y)
	pos_y=max(screen_y-size_y-70,0);
end;
	
Array_id=findobj('Tag','ArrayView');
if isempty(Array_id)==0
	figure(Array_id);
	set(Array_id,'Position',[pos_x pos_y size_x size_y]);
else
	config=read_config();

	Array_id=figure('Units','pixels', ...
		'Position',[pos_x pos_y size_x size_y],...
		'Color',config.bg_color,...
		'Visible','on',...
		'MenuBar','none', ...
		'Colormap',config.view_struct.cmap,...
		'NumberTitle','off', ...
		'Doublebuffer','on',...
		'DeleteFcn','mstat_cb(''exit'')',...
		'ResizeFcn',@mstat_resize_cb,...
		'KeyPressFcn',@mstat_kb_cb,...
		'Name','MStat', ...
		'Tag','ArrayView');

	%%%%%%
	%Menu%
	%%%%%%
	FileMenu_id=uimenu('Label','&Plik','Tag','File');
	uimenu(FileMenu_id,'Label','&Otwrz','Accelerator','O','CallBack','mstat_cb(''open'')','UserData',config,'Tag','FileOpen');
	uimenu(FileMenu_id,'Label','Zapi&sz','Accelerator','S','Enable','off','CallBack','mstat_cb(''save'')','Tag','FileSave');
	FileImportMenu_id=uimenu(FileMenu_id,'Label','Importuj','Separator','on','Enable','off','Tag','FileImport');
	uimenu(FileImportMenu_id,'Label','&Wartoci','CallBack','import_cb(''import_values'')','Tag','FileImportValues');
	uimenu(FileImportMenu_id,'Label','P&rbki','Separator','on','CallBack','import_cb(''import_arrays'')','Tag','FileImportArryas');
	uimenu(FileImportMenu_id,'Label','C&echy','Enable','on','CallBack','import_cb(''import_genes'')','Tag','FileImportGenes');
	uimenu(FileImportMenu_id,'Label','Podzia &prbek','Separator','on','CallBack','import_cb(''import_aorder'')','Tag','FileImportAorder');
	uimenu(FileImportMenu_id,'Label','Podzia &cech','CallBack','import_cb(''import_gorder'')','Tag','FileImportGorder');
	uimenu(FileImportMenu_id,'Label','&Nazwy prbek','Separator','on','CallBack','import_cb(''import_anames'')','Tag','FileImportAnames');
	uimenu(FileImportMenu_id,'Label','N&azwy cech','CallBack','import_cb(''import_gnames'')','Tag','FileImportGnames');
	uimenu(FileImportMenu_id,'Label','&Opis cech','Separator','on','CallBack','import_cb(''import_gin'')','Tag','FileChip');
	FileExportMenu_id=uimenu(FileMenu_id,'Label','Eksportuj','Enable','off','Tag','FileExport');
	uimenu(FileExportMenu_id,'Label','&Raport','CallBack','export_cb(''export_raport'')','Tag','FileExportRaport');
	uimenu(FileExportMenu_id,'Label','Podzia &prbek','Separator','on','CallBack','export_cb(''export_aorder'')','Tag','FileExportAorder');
	uimenu(FileExportMenu_id,'Label','Podzia &cech','CallBack','export_cb(''export_gorder'')','Tag','FileExportGorder');
	uimenu(FileExportMenu_id,'Label','&Nazwy prbek','Separator','on','CallBack','export_cb(''export_anames'')','Tag','FileExportAnames');
	uimenu(FileExportMenu_id,'Label','N&azwy cech','CallBack','export_cb(''export_gnames'')','Tag','FileExportGnames');
	uimenu(FileExportMenu_id,'Label','Nazwy &klas prbek','Separator','on','CallBack','export_cb(''export_acnames'')','Tag','FileExportACnames');
	uimenu(FileExportMenu_id,'Label','Nazwy g&rup cech','CallBack','export_cb(''export_gcnames'')','Tag','FileExportGCnames');
	uimenu(FileExportMenu_id,'Label','&Obraz','Separator','on','CallBack','export_cb(''image'')','Tag','FileExportImage');
	uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','delete(findobj(0,''Tag'',''ArrayView''))','Tag','FileExit');

	EditMenu_id=uimenu('Label','&Edycja','Enable','off');
	EditFindSubMenu_id=uimenu(EditMenu_id,'Label','Znajd');
	uimenu(EditFindSubMenu_id,'Label','&Cech','Accelerator','F','CallBack','mstat_cb(''find_gene'')','Tag','FindGene');
	uimenu(EditFindSubMenu_id,'Label','&Prbk','Accelerator','G','CallBack','mstat_cb(''find_array'')','Tag','FindArray');

	uimenu(EditMenu_id,'Label','&Zapamitaj','Accelerator','A','Separator','on','CallBack','mstat_cb(''savestate'')');
	uimenu(EditMenu_id,'Label','&Przywr','Accelerator','Z','CallBack','mstat_cb(''restore'')');

	ViewMenu_id=uimenu('Label','&Widok','Enable','off');
	uimenu(ViewMenu_id,'Label','&Powikszenie','CallBack','mstat_cb(''zoom_in'')');
	uimenu(ViewMenu_id,'Label','&Zmniejszenie','CallBack','mstat_cb(''zoom_out'')');
	ViewModeSubMenu_id=uimenu(ViewMenu_id,'Label','&Sposb wywietlania','Separator','on','Tag','ViewModeSubMenu','UserData',0);
	uimenu(ViewModeSubMenu_id,'Label','Wzgldny','Checked','on','CallBack','mstat_cb(''set_viewmode'')','Tag','relative','UserData',0);
	uimenu(ViewModeSubMenu_id,'Label','Bezwzgldny','CallBack','mstat_cb(''set_viewmode'')','Tag','absolute','UserData',1);
	ViewLUTSubMenu_id=uimenu(ViewMenu_id,'Label','&Paleta','Tag','ViewLUTSubMenu');
	uimenu(ViewLUTSubMenu_id,'Label','Red&&Green','Checked','on','Tag','red_green','CallBack','mstat_cb(''set_lut'')');
	uimenu(ViewLUTSubMenu_id,'Label','Hot','Tag','hot','Separator','on','CallBack','mstat_cb(''set_lut'')');
	uimenu(ViewLUTSubMenu_id,'Label','Jet','Tag','jet','CallBack','mstat_cb(''set_lut'')');
	uimenu(ViewLUTSubMenu_id,'Label','Gray','Tag','gray','Separator','on','CallBack','mstat_cb(''set_lut'')');
	uimenu(ViewLUTSubMenu_id,'Label','Red','Tag','red','CallBack','mstat_cb(''set_lut'')');
	uimenu(ViewLUTSubMenu_id,'Label','Green','Tag','green','CallBack','mstat_cb(''set_lut'')');
	uimenu(ViewLUTSubMenu_id,'Label','Blue','Tag','blue','CallBack','mstat_cb(''set_lut'')');
	uimenu(ViewLUTSubMenu_id,'Label','Invert','Separator','on','CallBack','mstat_cb(''invert_lut'')');
	uimenu(ViewMenu_id,'Label','&Odwie','Separator','on','CallBack','mstat_cb(''update_view'')');
	uimenu(ViewMenu_id,'Label','&Usu zaznaczenie','Separator','on','Enable','off','Tag','UnselectMenu','CallBack','mstat_cb(''unselect'')');

	DataMenu_id=uimenu('Label','&Dane','Enable','off');
	uimenu(DataMenu_id,'Label','Wartoci','Enable','on','CallBack','values_table;');
	uimenu(DataMenu_id,'Label','Prbki','Enable','on','Separator','on','CallBack','arrays_table;');
	uimenu(DataMenu_id,'Label','Cechy','Enable','on','CallBack','genes_table;');
	uimenu(DataMenu_id,'Label','Klasy prbek','Enable','on','Separator','on','CallBack','classes_table;');
	uimenu(DataMenu_id,'Label','Grupy cech','Enable','on','CallBack','groups_table;');

	InfoMenu_id=uimenu('Label','&Informacje','Enable','off');
	uimenu(InfoMenu_id,'Label','&Opis cechy','Enable','off','CallBack','mstat_cb(''gene_info'')','UserData',[],'Tag','GeneInfo');
	InfoPCAMenu_id=uimenu(InfoMenu_id,'Label','&PCA','Separator','on');
	uimenu(InfoPCAMenu_id,'Label','&Prbek','CallBack','plot_pca','Tag','ArrayPCA');
	uimenu(InfoPCAMenu_id,'Label','&Cech','CallBack','plot_pca','Tag','GenePCA');
	InfoCorrMenu_id=uimenu(InfoMenu_id,'Label','&Macierz korelacji');
	uimenu(InfoCorrMenu_id,'Label','&Prbek','Tag','ACorrMtx','CallBack','plot_corrmtx');
	uimenu(InfoCorrMenu_id,'Label','&Cech','Tag','GCorrMtx','CallBack','plot_corrmtx');
	InfoTestMenu_id=uimenu(InfoMenu_id,'Label','&Testy istotnoci','Enable','off');
	uimenu(InfoTestMenu_id,'Label','&Jednowymiarowe','Accelerator','T','CallBack','tst1D');
	InfoProfileMenu_id=uimenu(InfoMenu_id,'Label','&Profil ekspresji');
	uimenu(InfoProfileMenu_id,'Label','&Cechy','Accelerator','P','CallBack','plot_profile');
	uimenu(InfoProfileMenu_id,'Label','Cech w &grupie','Separator','on','CallBack','plot_profiles');
	uimenu(InfoProfileMenu_id,'Label','&Centroidw grup','CallBack','plot_centroids');
	InfoBoxPlotMenu_id=uimenu(InfoMenu_id,'Label','&Box plot');
	uimenu(InfoBoxPlotMenu_id,'Label','&Cech','Accelerator','B','CallBack','mstat_cb(''gboxplot'')');	
	uimenu(InfoBoxPlotMenu_id,'Label','&Prbek','CallBack','mstat_cb(''aboxplot'')');
	InfoBoxPlotMenu_id=uimenu(InfoMenu_id,'Label','&Histogram');
	uimenu(InfoBoxPlotMenu_id,'Label','&Cechy','Accelerator','H','CallBack','plot_hist','Tag','GeneHist');	
	uimenu(InfoBoxPlotMenu_id,'Label','&Prbki','CallBack','plot_hist','Tag','ArrayHist');	
	uimenu(InfoBoxPlotMenu_id,'Label','&Zbioru danych','separator','on','CallBack','plot_hist','Tag','DataHist');
	uimenu(InfoMenu_id,'Label','&CV plot','CallBack','mstat_cb(''cv_plot'')');
	uimenu(InfoMenu_id,'Label','&Scatterplot','CallBack','plot_scatterplot');
	uimenu(InfoMenu_id,'Label','&Sammon plot','CallBack','plot_sammon');
	uimenu(InfoMenu_id,'Label','&SVD','CallBack','svdec');
	uimenu(InfoMenu_id,'Label','&ICA','CallBack','ica');

	DataMenu_id=uimenu('Label','&Obrbka','Enable','off');
	%uimenu(DataMenu_id,'Label','&Kontrola jakoci','CallBack','qc');
	uimenu(DataMenu_id,'Label','&Brakujce wartoci','CallBack','missing');
	uimenu(DataMenu_id,'Label','&Zmiana zakresu','CallBack','adjust');
	DataMenuFilter_id=uimenu(DataMenu_id,'Label','&Filtracja','Enable','off');
	uimenu(DataMenuFilter_id,'Label','&Prbek','CallBack','filter_arrays');
	uimenu(DataMenuFilter_id,'Label','&Cech','CallBack','filter_genes');
	uimenu(DataMenuFilter_id,'Label','&Klas prbek','Separator','on','CallBack','filter_classes');
	uimenu(DataMenuFilter_id,'Label','G&rup cech','CallBack','filter_groups');
	uimenu(DataMenu_id,'Label','O&dszumianie','CallBack','denoise');
	DataMenuMean_id=uimenu(DataMenu_id,'Label','&Urednianie','Enable','off');
	uimenu(DataMenuMean_id,'Label','&Prbek','CallBack','rollup','Tag','RollupSamples');
	uimenu(DataMenuMean_id,'Label','&Cech','CallBack','rollup','Tag','RollupFeatures');
	DataMenuNorm_id=uimenu(DataMenu_id,'Label','&Normalizacja','Enable','off');
	uimenu(DataMenuNorm_id,'Label','&Prbek','CallBack','normalize_arrays');
	uimenu(DataMenuNorm_id,'Label','&Cech','CallBack','normalize_genes');
	DataMenuClust_id=uimenu(DataMenu_id,'Label','&Klasteryzacja','Enable','off');
	uimenu(DataMenuClust_id,'Label','&Prbek','CallBack','clustering','Tag','ClusterSamples');
	uimenu(DataMenuClust_id,'Label','&Cech','CallBack','clustering','Tag','ClusterFeatures');
	DataMenuSelect_id=uimenu(DataMenu_id,'Label','&Selekcja','Enable','off');
	uimenu(DataMenuSelect_id,'Label','&Jednowymiarowa','CallBack','sel1D','UserData',[],'Tag','Select1D');
	uimenu(DataMenuSelect_id,'Label','&Wielowymiarowa','CallBack','selND','Tag','SelectND');
	uimenu(DataMenuSelect_id,'Label','&Korelacyjna','separator','on','CallBack','sel1D_corr');
	uimenu(DataMenuSelect_id,'Label','&SVD','CallBack','sel1D_svd');
	uimenu(DataMenuSelect_id,'Label','&ICA','CallBack','sel1D_ica');

	HelpMenu_id=uimenu('Label','Pomo&c');
	uimenu(HelpMenu_id,'Label','O &programie...','CallBack','mstat_cb(''info'')');
    
	%%%%%%%%%
	%Toolbar%
	%%%%%%%%%
	ToolBar_id=uitoolbar(Array_id);
	button_hnd=uipushtool(ToolBar_id,'TooltipString','Otwrz','Tag','ToolbarFileOpen','ClickedCallback','mstat_cb(''open'')');
	set(button_hnd,'CData',imread( fullfile(config.ui_images_path,'open.png'),'BackgroundColor',config.bg_color));
	button_hnd=uipushtool(ToolBar_id,'TooltipString','Zapisz','Tag','ToolbarFileSave','ClickedCallback','mstat_cb(''save'')');
	set(button_hnd,'CData',imread( fullfile(config.ui_images_path,'save_g.png'),'BackgroundColor',config.bg_color));
	button_hnd=uipushtool(ToolBar_id,'TooltipString','Zapamitaj','Separator','on','Tag','ToolbarSaveState','ClickedCallback','mstat_cb(''savestate'')');
	set(button_hnd,'CData',imread( fullfile(config.ui_images_path,'redo_g.png'),'BackgroundColor',config.bg_color));
	button_hnd=uipushtool(ToolBar_id,'TooltipString','Przywr','Tag','ToolbarUndo','ClickedCallback','mstat_cb(''restore'')');
	set(button_hnd,'CData',imread( fullfile(config.ui_images_path,'undo_g.png'),'BackgroundColor',config.bg_color));
	button_hnd=uipushtool(ToolBar_id,'TooltipString','Powikszenie','Separator','on','Tag','ToolbarZoomIn','ClickedCallback','mstat_cb(''zoom_in'')');
	set(button_hnd,'CData',imread( fullfile(config.ui_images_path,'zoomin_g.png'),'BackgroundColor',config.bg_color));
	button_hnd=uipushtool(ToolBar_id,'TooltipString','Zmniejszenie','Tag','ToolbarZoomOut','ClickedCallback','mstat_cb(''zoom_out'')');
	set(button_hnd,'CData',imread( fullfile(config.ui_images_path,'zoomout_g.png'),'BackgroundColor',config.bg_color));

	%%%%%%%%%%%%
	%Popup menu%
	%%%%%%%%%%%%
	PopupMenu_id=uicontextmenu;
	uimenu(PopupMenu_id,'Label','&Waciwoci','CallBack','mstat_cb(''gene_info'')','Tag','GeneInfoPopup');
	uimenu(PopupMenu_id,'Label','Profil ekspresji','Separator','on','Tag','GeneProfileMenu','Callback','plot_profile');
	uimenu(PopupMenu_id,'Label','Boxplot','Tag','GeneBoxplotMenu','Callback','mstat_cb(''gboxplot'')');
	uimenu(PopupMenu_id,'Label','Testy istotnoci','Separator','on','CallBack','tst1D');
	PopupMenuDelete_id=uimenu(PopupMenu_id,'Label','Usu','Separator','on','Tag','DeleteMenu');
	uimenu(PopupMenuDelete_id,'Label','Cech','Tag','GeneDeleteMenu','Callback','mstat_cb(''delete_gene'')');
	uimenu(PopupMenuDelete_id,'Label','Prbk','Tag','ArrayDeleteMenu','Callback','mstat_cb(''delete_array'')');

	%%%%%%%%%%%%%%%%%%
	%Obrazek i suwaki%
	%%%%%%%%%%%%%%%%%%
	
	%stale
	plot_axis_size=[360 412];
	plot_axis_pos=[25 30];
	order_axis_size=15;
	scroll_size=19;
	
	%panel
	plot_panel_size=[plot_axis_size(1)+plot_axis_pos(1)+scroll_size+10 plot_axis_size(2)+plot_axis_pos(2)+scroll_size+20];
	plot_panel_pos=[10 size_y-plot_panel_size(2)-6];

	PlotPanel_id=uipanel('Parent',Array_id, ...
		'Title','Dane:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[plot_panel_pos(1) plot_panel_pos(2) plot_panel_size(1) plot_panel_size(2)], ...
		'Tag','PlotPanel');

	%obraz
	axes_id=axes('Parent',PlotPanel_id,...
		'Units','pixels',...
		'Color',[0 0 0], ...
		'XTick',[],...
		'YTick',[],...
		'XLim',[0 plot_axis_size(1)]+0.5,...
		'YLim',[0 plot_axis_size(2)]+0.5,...
		'YDir','reverse',...
		'Tag','ArrayAxes',...
		'Position',[plot_axis_pos(1) plot_axis_pos(2) plot_axis_size(1) plot_axis_size(2)]);

	image_id=image('Parent',axes_id,...
		'CData', [], ...
		'BusyAction','Queue',...
		'CDataMapping', 'Direct', ...
		'Interruptible','off',...
		'Xdata', [1 plot_axis_size(1)],...
		'Ydata', [1 plot_axis_size(2)],...
		'EraseMode', 'none',...
		'Clipping','off',...
		'Tag','ArrayImage',...
		'UIContextMenu',PopupMenu_id,...
		'ButtonDownFcn','mstat_cb(''click'')');

	%przypisanie probek
	axes2_id=axes('Parent',PlotPanel_id,...
		'Units','pixels',...
		'Color',[0 0 0], ...
		'XTick',[],...
		'YTick',[],...
		'XLim',[0 96],...
		'YLim',[0 1],...
		'YDir','reverse',...
		'Tag','ArrayClassAxes',...
		'ButtonDownFcn','axes(findobj(findobj(0,''Tag'',''ArrayView''),''Tag'',''ArrayAxes''));',...
		'Position',[plot_axis_pos(1) plot_axis_pos(2)+plot_axis_size(2)+5 plot_axis_size(1) order_axis_size]);

	%przypisanie genow
	axes3_id=axes('Parent',PlotPanel_id,...
		'Units','pixels',...
		'Color',[0 0 0], ...
		'XTick',[],...
		'YTick',[],...
		'XLim',[0 1],...
		'YLim',[0 96],...
		'YDir','reverse',...
		'Tag','GeneClassAxes',...
		'ButtonDownFcn','axes(findobj(findobj(0,''Tag'',''ArrayView''),''Tag'',''ArrayAxes''));',...
		'Position',[5 plot_axis_pos(2) order_axis_size plot_axis_size(2)]);

	%suwaki
	vscroll_id=uicontrol('Parent',PlotPanel_id, ...
		'BackgroundColor',[0.752941 0.752941 0.752941], ...
		'Units','pixels', ...
		'Position',[plot_axis_pos(1)+plot_axis_size(1) plot_axis_pos(2) scroll_size plot_axis_size(2)],...
		'Style','Slider', ...
		'Value',1,...
		'Enable','off',...
		'Tag','VerticalScroll',...
		'CallBack','mstat_cb(''scroll'')');

	hscroll_id=uicontrol('Parent',PlotPanel_id, ...
		'BackgroundColor',[0.752941 0.752941 0.752941], ...
		'Units','pixels', ...
		'Position',[plot_axis_pos(1) plot_axis_pos(2)-scroll_size-1 plot_axis_size(1) scroll_size],...
		'Style','Slider', ...
		'Value',0,...
		'Enable','off',...
		'Tag','HorizontalScroll',...
		'CallBack','mstat_cb(''scroll'')');

	uicontrol('Parent',PlotPanel_id,...
		'Units','pixels',...
		'Position',[plot_axis_pos(1)+plot_axis_size(1) plot_axis_pos(2)-scroll_size-1 scroll_size scroll_size],...
		'Style','pushbutt', ...
		'String','+',...
		'Enable','off',...
		'Tag','UnselectButton',...
		'CallBack','mstat_cb(''unselect'')');

	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%Informacje o zbiorze danych%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	InfoPanel_id=uipanel('Parent',Array_id, ...
		'Title','', ...
		'Units','pixels', ...
		'BorderWidth',0,...
		'BackgroundColor',config.bg_color, ...
		'Position',[450 69 340 481], ...
		'Tag','InfoPanel');

	%%%%%%%%%%%%%%
	%Zbior danych%
	%%%%%%%%%%%%%%
	DatasetPanel_id=uipanel('Parent',InfoPanel_id, ...
		'Title','Zbir danych:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[1 431 340 50], ...
		'Tag','DatasetPanel');

	uicontrol('Parent',DatasetPanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 10 80 18], ...
		'HorizontalAlignment','left', ...
		'String','Liczba cech: ', ...
		'Style','text', ...
		'Tag','GeneNrText');

	uicontrol('Parent',DatasetPanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[90 10 50 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(1),...
		'Style','edit', ...
		'Tag','GeneNrEdit');

	uicontrol('Parent',DatasetPanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[150 10 80 18], ...
		'HorizontalAlignment','left', ...
		'String','Liczba prbek: ', ...
		'Style','text', ...
		'Tag','ArrayNrText');

	uicontrol('Parent',DatasetPanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[230 10 50 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(1),...
		'Style','edit', ...
		'Tag','ArrayNrEdit');

	%%%%%%%
	%Cechy%
	%%%%%%%
	GenePanel_id=uipanel('Parent',InfoPanel_id, ...
		'Title','Cechy:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[1 201 340 230], ...
		'Tag','GenePanel');

	uicontrol('Parent',GenePanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 190 120 18], ...
		'HorizontalAlignment','left', ...
		'String','Zakres wywietlania: ', ...
		'Style','text', ...
		'Tag','GeneRangeText1');

	uicontrol('Parent',GenePanel_id, ...
		'Style','edit', ...
		'Units','pixels', ...
		'Position',[140 190 50 20], ...
		'BackgroundColor',[1 1 1], ...
		'HorizontalAlignment','right', ...
		'String',num2str(1),...
		'UserData',1,...
		'Tag','GeneRangeEdit1',...
		'Callback','mstat_cb(''goto_gene'')');

	uicontrol('Parent',GenePanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[230 190 50 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(1),...
		'Style','edit', ...
		'Tag','GeneRangeEdit2');

	uicontrol('Parent',GenePanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 160 120 18], ...
		'HorizontalAlignment','left', ...
		'String','Numer wybranej cechy: ', ...
		'Style','text', ...
		'Tag','SelectedGeneText');

	uicontrol('Parent',GenePanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[140 160 50 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'Tag','SelectedGeneEdit',...
		'Callback','mstat_cb(''select_gene'')');

	uicontrol('Parent',GenePanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 130 130 18], ...
		'HorizontalAlignment','left', ...
		'String','Nazwa wybranej cechy: ', ...
		'Style','text', ...
		'Tag','SelectedGeneNameText');
	
	uicontrol('Parent',GenePanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[140 130 170 20], ...
		'HorizontalAlignment','left', ...
		'Style','edit', ...
		'Tag','SelectedGeneNameEdit');

	button_hnd=uicontrol('Parent',GenePanel_id,...
		'Units','pixels',...
		'Position',[310 130 20 20],...
		'Style','pushbutt', ...
		'String','',...
		'Tag','FindGeneButt',...
		'CallBack','mstat_cb(''find_gene'')');
	set(button_hnd,'CData',imread(fullfile(config.ui_images_path,'search.png'),'BackgroundColor',config.bg_color));

	uicontrol('Parent',GenePanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 100 100 18], ...
		'HorizontalAlignment','left', ...
		'String','Warto cechy: ', ...
		'Style','text', ...
		'Tag','ValueText');

	uicontrol('Parent',GenePanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[140 100 50 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'Tag','ValueEdit',...
		'CallBack','mstat_cb(''set_gene_value'')');

	uicontrol('Parent',GenePanel_id, ...
		'Units','pixels', ...
		'Position',[10 70 120 18], ...
		'BackgroundColor',config.bg_color, ...
		'HorizontalAlignment','left', ...
		'String','Grupa wybranej cechy: ', ...
		'Style','text', ...
		'Tag','GeneClassNameText');

	GeneClassPopId=uicontrol('Parent',GenePanel_id, ...
		'Units','pixels', ...
		'Position',[140 70 190 20], ...
		'BackgroundColor',[1 1 1], ...
		'String',{'Brak podziau na grupy'}, ...
		'Style','popupmenu',...
		'HorizontalAlignment','right', ...
		'Value',1, ...
		'Enable','off',...
		'Tag','GeneClassPop', ...
		'Callback','');

	uicontrol('Parent',GenePanel_id,...
		'Units','pixels',...
		'Position',[10 40 120 20],...
		'Style','pushbutt', ...
		'String','Usu cech',...
		'Enable','off',...
		'Tag','GeneDeleteButt',...
		'CallBack','mstat_cb(''delete_gene'')');

	uicontrol('Parent',GenePanel_id,...
		'Units','pixels',...
		'Position',[140 40 90 20],...
		'Style','pushbutt', ...
		'String','Przypisz',...
		'Enable','off',...
		'Tag','GeneClassAssignButt',...
		'CallBack','mstat_cb(''assign_gene'')');

	uicontrol('Parent',GenePanel_id,...
		'Units','pixels',...
		'Position',[240 40 90 20],...
		'Style','pushbutt', ...
		'String','Pocz',...
		'Enable','off',...
		'Tag','GeneClassJoinButt',...
		'CallBack','mstat_cb(''join_gclass'')');

	uicontrol('Parent',GenePanel_id,...
		'Units','pixels',...
		'Position',[10 10 120 20],...
		'Style','pushbutt', ...
		'String','Usu grup',...
		'Enable','off',...
		'Tag','GeneClassDeleteButt',...
		'CallBack','mstat_cb(''delete_gclass'')');
	
	uicontrol('Parent',GenePanel_id,...
		'Units','pixels',...
		'Position',[140 10 190 20],...
		'Style','pushbutt', ...
		'String','Uporzdkuj cechy',...
		'Enable','off',...
		'Tag','GeneReorderButt',...
		'CallBack','mstat_cb(''gene_reorder'')');

	%%%%%%%%
	%Prbki%
	%%%%%%%%
	ArrayPanel_id=uipanel('Parent',InfoPanel_id, ...
		'Title','Prbki:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[1 1 340 200], ...
		'Tag','ArrayPanel');

	uicontrol('Parent',ArrayPanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 160 120 18], ...
		'HorizontalAlignment','left', ...
		'String','Zakres wywietlania: ', ...
		'Style','text', ...
		'Tag','ArrayRangeText1');

	uicontrol('Parent',ArrayPanel_id, ...
		'Style','edit', ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[140 160 50 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(1),...
		'UserData',1,...
		'Tag','ArrayRangeEdit1',...
		'Callback','mstat_cb(''goto_array'')');

	uicontrol('Parent',ArrayPanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[240 160 50 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(1),...
		'Style','edit', ...
		'Tag','ArrayRangeEdit2');

	uicontrol('Parent',ArrayPanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 130 120 18], ...
		'HorizontalAlignment','left', ...
		'String','Numer wybranej prbki: ', ...
		'Style','text', ...
		'Tag','SelectedArrayText');

	uicontrol('Parent',ArrayPanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[140 130 50 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'Tag','SelectedArrayEdit',...
		'Callback','mstat_cb(''select_array'')');

	uicontrol('Parent',ArrayPanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 100 120 18], ...
		'HorizontalAlignment','left', ...
		'String','Nazwa wybranej prbki: ', ...
		'Style','text', ...
		'Tag','SelectedArrayNameText');

	uicontrol('Parent',ArrayPanel_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[140 100 170 20], ...
		'HorizontalAlignment','left', ...
		'Style','edit', ...
		'Tag','SelectedArrayNameEdit');

	button_hnd=uicontrol('Parent',ArrayPanel_id,...
		'Units','pixels',...
		'Position',[310 100 20 20],...
		'Style','pushbutt', ...
		'String','',...
		'Tag','FindArrayButt',...
		'CallBack','mstat_cb(''find_array'')');
	set(button_hnd,'CData',imread(fullfile(config.ui_images_path,'search.png'),'BackgroundColor',config.bg_color));

	uicontrol('Parent',ArrayPanel_id, ...
		'Units','pixels', ...
		'Position',[10 70 120 18], ...
		'BackgroundColor',config.bg_color, ...
		'HorizontalAlignment','left', ...
		'String','Klasa wybranej prbki: ', ...
		'Style','text', ...
		'Tag','ClassNameText');

	ArrayClassPopId=uicontrol('Parent',ArrayPanel_id, ...
		'Units','pixels', ...
		'Position',[140 70 190 20], ...
		'BackgroundColor',[1 1 1], ...
		'String',{'Brak podziau na klasy'}, ...
		'Style','popupmenu',...
		'HorizontalAlignment','right', ...
		'Value',1, ...
		'Enable','off',...
		'Tag','ArrayClassPop', ...
		'Callback','');

	uicontrol('Parent',ArrayPanel_id,...
		'Units','pixels',...
		'Position',[10 40 120 20],...
		'Style','pushbutt', ...
		'String','Usu prbk',...
		'Enable','off',...
		'Tag','ArrayDeleteButt',...
		'CallBack','mstat_cb(''delete_array'')');

	uicontrol('Parent',ArrayPanel_id,...
		'Units','pixels',...
		'Position',[140 40 90 20],...
		'Style','pushbutt', ...
		'String','Przypisz',...
		'Enable','off',...
		'Tag','ArrayClassAssignButt',...
		'CallBack','mstat_cb(''assign_array'')');

	uicontrol('Parent',ArrayPanel_id,...
		'Units','pixels',...
		'Position',[240 40 90 20],...
		'Style','pushbutt', ...
		'String','Pocz',...
		'Enable','off',...
		'Tag','ArrayClassJoinButt',...
		'CallBack','mstat_cb(''join_aclass'')');

	uicontrol('Parent',ArrayPanel_id,...
		'Units','pixels',...
		'Position',[10 10 120 20],...
		'Style','pushbutt', ...
		'String','Usu klas',...
		'Enable','off',...
		'Tag','ArrayClassDeleteButt',...
		'CallBack','mstat_cb(''delete_aclass'')');

	uicontrol('Parent',ArrayPanel_id,...
		'Units','pixels',...
		'Position',[140 10 190 20],...
		'Style','pushbutt', ...
		'String','Uporzdkuj prbki',...
		'Enable','off',...
		'Tag','ArrayReorderButt',...
		'CallBack','mstat_cb(''array_reorder'')');

	if isVersion(7.5)>=0
		jCombo=findjobj(GeneClassPopId,'nomenu');
		jCombo.setEditable(1);

		jCombo=findjobj(ArrayClassPopId,'nomenu');
		jCombo.setEditable(1);
	end;

	%pause(1);
	%jMenu=findjobj(EditMenu_id)
	%methods(jMenuItem)
	drawnow;
	%jf = get(Array_id,'JavaFrame');
	%jmb=jf.fFigureClient.getMenuBar
	%jmb.getMenu(1).

%	jFileMenu = jmb.getComponent(1)
%	jSave = jFileMenu.getMenuComponent(0)
% Save menu item is the 5th menu item (separators included)
%
%inspect(jSave) => just to be sure: label='Save' => good!
% Set a new accelerator key
%jAccel = javax.swing.KeyStroke.getKeyStroke('alt shift S'));
%jSave.setAccelerator(jAccel);

end;
return;

%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function mstat_resize_cb(src,evnt)

Array_id=gcbf;
fig_pos=get(Array_id,'Position');

panel=findobj(Array_id,'Tag','InfoPanel');
panel_pos=get(panel,'Position');
set(panel,'Position',[fig_pos(3)-5-panel_pos(3),fig_pos(4)-5-panel_pos(4),panel_pos(3),panel_pos(4)]);

mstat_cb('prepare_axis');
mstat_cb('redraw');
return;

%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function mstat_kb_cb(~,evnt)

Array_id=gcbf;
data=get(Array_id,'UserData');
config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

if ~isempty(data) && config.view_struct.lock~=1
	if strcmp(evnt.Key,'downarrow')==1 || strcmp(evnt.Key,'uparrow')==1 || strcmp(evnt.Key,'pagedown')==1 || strcmp(evnt.Key,'pageup')==1
		gene_range=[config.view_struct.position_y config.view_struct.position_y+config.view_struct.max_y];
		gene_nr=config.view_struct.selected_gene;

		switch evnt.Key
			case 'downarrow'
				gene_delta=1;
			case 'uparrow'
				gene_delta=-1;
			case 'pagedown'
				gene_delta=(gene_range(2)-gene_range(1)+1);
			case 'pageup'
				gene_delta=-(gene_range(2)-gene_range(1)+1);
		end;
		if gene_nr+gene_delta>size(data,1)
			gene_delta=size(data,1)-gene_nr;
		end;
		if gene_nr+gene_delta<1
			gene_delta=-(gene_nr)+1;
		end;
		gene_nr=gene_nr+gene_delta;

		if gene_nr>0 && gene_nr<=size(data,1)
			config.view_struct.selected_gene=gene_nr;
			config.view_struct.selected_array=min(max(1,config.view_struct.selected_array),size(data,2));
			if gene_nr<gene_range(1) || gene_nr>gene_range(2)
				gene_range(1)=min(max(gene_range(1)+gene_delta,1),size(data,1)-config.view_struct.max_y);
				config.view_struct.position_y=gene_range(1);

				set(findobj(Array_id,'Tag','FileOpen'),'UserData',config);

				set(findobj(Array_id,'Tag','VerticalScroll'),'Value',min(max(1-(config.view_struct.position_y-1)/(size(data,1)-config.view_struct.max_y),0),1));
				mstat_cb('redraw');
			else
				set(findobj(Array_id,'Tag','FileOpen'),'UserData',config);
				mstat_cb('redraw_selection');
			end;
			mstat_cb('do_gui');
		end;

	elseif strcmp(evnt.Key,'rightarrow')==1 || strcmp(evnt.Key,'leftarrow')==1 || strcmp(evnt.Key,'home')==1 || strcmp(evnt.Key,'end')==1
		array_range=[config.view_struct.position_x config.view_struct.position_x+config.view_struct.max_x];
		array_nr=config.view_struct.selected_array;

		switch evnt.Key
			case 'rightarrow'
				array_delta=1;
			case 'leftarrow'
				array_delta=-1;
			case 'end'
				array_delta=(array_range(2)-array_range(1)+1);
			case 'home'
				array_delta=-(array_range(2)-array_range(1)+1);
		end;
		if array_nr+array_delta>size(data,2)
			array_delta=size(data,2)-array_nr;
		end;
		if array_nr+array_delta<1
			array_delta=-(array_nr)+1;
		end;
		array_nr=array_nr+array_delta;

		if array_nr>0 && array_nr<=size(data,2)
			config.view_struct.selected_array=array_nr;
			config.view_struct.selected_gene=min(max(1,config.view_struct.selected_gene),size(data,1));

			if array_nr<array_range(1) || array_nr>array_range(2)
				array_range(1)=min(max(array_range(1)+array_delta,1),size(data,2)-config.view_struct.max_x);
				config.view_struct.position_x=array_range(1);

				set(findobj(Array_id,'Tag','FileOpen'),'UserData',config);

				set(findobj(Array_id,'Tag','HorizontalScroll'),'Value',min(max((config.view_struct.position_x-1)/(size(data,2)-config.view_struct.max_x),0),1));
				mstat_cb('redraw');
			else
				set(findobj(Array_id,'Tag','FileOpen'),'UserData',config);
				mstat_cb('redraw_selection');
			end;
			mstat_cb('do_gui');
		end;
	end;
end;
return;

%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function config=read_config(filename)

config.mstat_install=fileparts(which('mstat'));

if nargin==0
	filename=fullfile(config.mstat_install,'mstat.cfg');
end;

config.ui_path=fullfile(config.mstat_install,'toolbox','ui');
config.ui_images_path=fullfile(config.ui_path,'images');

matlab_ext={'fastica','matlab','data','stat','io','smooth','missing','ezyfit','cluster','plots','tables','dialogs','cb','libsvm'};	%,'stat/outliers'};

config.ext_path={config.ui_path};
for i=1:length(matlab_ext)
	config.ext_path{end+1}=fullfile(config.mstat_install,'toolbox',matlab_ext{i});
end;
for i=1:length(config.ext_path)
	addpath(config.ext_path{i});
end;

java_ext={'commons-collections-3.2.1.jar'};
for i=1:length(java_ext)
	config.java_path{i}=fullfile(config.mstat_install,'toolbox','java',java_ext{i});
	javaaddpath(config.java_path{i});
end;

config.bg_color=get(0,'defaultUicontrolBackgroundColor');

config.gstr='';
config.astr='';

config.open_path=[pwd filesep];
config.export_path=[pwd filesep];
config.import_path=[pwd filesep];
config.chip_path=[pwd filesep];

config.pval_thr=0.01;
config.fc_thr=2.0;
config.test='ANOVA';

%odczyt configu
%%%%%%%%%%%%%%%%%%%%%%%
fid=fopen(filename,'r');
if fid~=-1
	line=fgets(fid);
	while line~=-1
		line=strtrim(line);
		if line(1)~='#'
			if strfind(line,'OPEN_DIR=')
				line=strtrim(line(strfind(line,'=')+1:end));
				config.open_path=getdir(line,config.mstat_install);
			end;
			if strfind(line,'EXPORT_DIR=')
				line=strtrim(line(strfind(line,'=')+1:end));
				config.export_path=getdir(line,config.mstat_install);
			end;
			if strfind(line,'IMPORT_DIR=')
				line=strtrim(line(strfind(line,'=')+1:end));
				config.import_path=getdir(line,config.mstat_install);
			end;
			if strfind(line,'CHIP_DIR=')
				line=strtrim(line(strfind(line,'=')+1:end));
				config.chip_path=getdir(line,config.mstat_install);
			end;
			if strfind(line,'PVAL_THR=')
				line=strtrim(line(strfind(line,'=')+1:end));
				num=str2num(line);
				if ~isempty(num) && num>0 && num<=1
					config.pval_thr=num;
				end;
			end;
			if strfind(line,'FC_THR=')
				line=strtrim(line(strfind(line,'=')+1:end));
				num=str2num(line);
				if ~isempty(num) && num>=1
					config.fc_thr=num;
				end;
			end;
			if strfind(line,'TEST=')
				line=strtrim(line(strfind(line,'=')+1:end));
				config.test=line;
			end;
		end;
		line=fgets(fid);
	end;
	fclose(fid);
end;

%view_struct
%%%%%%%%%%%%%%%%%%%%%%%
view_struct.max_x=1;
view_struct.max_y=1;

view_struct.position_x=1;
view_struct.position_y=1;
	
view_struct.selected_gene=0;
view_struct.selected_array=0;

view_struct.view_mode=0;
view_struct.view_relative_range=3;

view_struct.zoom=4;
view_struct.zoom_range=[2 32];

view_struct.ctable=ctable;
view_struct.ctable_len=length(view_struct.ctable);
view_struct.cmap=lut('red_green',256,256);
view_struct.lock=0;
	
config.view_struct=view_struct;

return;

%
%
%%%%%%%
function path=getdir(dirname,mstat_install)

path=[dirname filesep];
if exist(path,'dir')==0 && exist(fullfile(mstat_install,dirname),'dir')
	path=[fullfile(mstat_install,dirname) filesep];
end;
return;
