function export(param);

Array_id=findobj(0,'Tag','ArrayView');
name=get(Array_id,'Name');
name=name(strfind(name,'-')+2:length(name));

path=[];
config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

set(Array_id,'Pointer','watch');
pause(0.01);

switch param
	case 'image'
		format_str={'png';'bmp';'jpg';'tiff'};
		ext_str={'png';'bmp';'jpg';'tif'};
		[name,path,format]=uiputfile({'*.png','Plik PNG (*.png)';'*.bmp','Plik BMP (*.bmp)';'*.jpg','Plik JPEG (*.jpg)';'*.tif','Plik TIFF (*.tif)';'*.*','Wszystkie pliki (*.*)'},'Zapisz obraz do pliku',[config.export_path name]);
		if isequal(name,0) || isequal(path,0)
            return;
        else
			[filename,format]=getfname(name,path,format,ext_str);

			set(Array_id,'Pointer','watch');
			pause(0.01);

			data=get(findobj(Array_id,'Tag','ArrayAxes'),'UserData');
			cmap=get(Array_id,'Colormap');
			
			array_image=ind2rgb(data,cmap);

			aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
			gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');

			genes_count=size(array_image,1);
			arrays_count=size(array_image,2);

			color=ctable;
			colors_count=size(color,1);

			aorder_image=zeros(1,arrays_count,3);
			for i=1:max(aorder)
				cindex=mod(i,colors_count);
				if cindex==0
					cindex=colors_count;
				end;

				ind=find(aorder==i);
				for j=1:3
					aorder_image(1,ind,j)=color(cindex,j);
				end;
			end;
			aorder_image=repmat(aorder_image,6,1);

			gorder_image=zeros(genes_count,1,3);
			for i=1:max(gorder)
				cindex=mod(i,colors_count);
				if cindex==0
					cindex=colors_count;
				end;

				ind=find(gorder==i);
				for j=1:3
					gorder_image(ind,1,j)=color(cindex,j);
				end;
			end;
			gorder_image=repmat(gorder_image,1,6);

			image=ones(genes_count+9,arrays_count+9,3);
			image(9:genes_count+8,9:arrays_count+8,1:3)=array_image;
			image(2:7,9:arrays_count+8,1:3)=aorder_image;
			image(9:genes_count+8,2:7,1:3)=gorder_image;
				
%			image=imresize(image,4,'nearest');
			image=im_scale(image,4);

			hnd=findobj(0,'Tag','PlotGHierClust');
			if ~isempty(hnd)
				PlotGHierClust_id=figure(hnd(1));
				set(PlotGHierClust_id,'Renderer','painters'); 
				PlotAxes_id=findobj(PlotGHierClust_id,'Tag','PlotAxes');
				OrderAxes_id=findobj(PlotGHierClust_id,'Tag','OrderAxes');

				config_struct=get(PlotGHierClust_id,'UserData');
				vectors_count=config_struct.vectors_count;

				if vectors_count==genes_count
					min_range=config_struct.min_range;
					range=config_struct.range;
					zoom=config_struct.zoom;
					scroller=config_struct.scroller;

					if scroller==1
						regions_count=ceil(vectors_count/range);
						plot_position=get(PlotAxes_id,'Position');
						size_x=plot_position(3);
						gclust_image=zeros(zoom*regions_count*range,size_x,3);

						for i=0:regions_count-1
							current_min_range=i*range;
							set(PlotAxes_id,'YLim',[current_min_range+0.5 current_min_range+range+0.5],'XTick',[],'YTick',[],'XColor',[1 1 1],'YColor',[1 1 1]);
							set(OrderAxes_id,'XLim',[0 1],'YLim',[current_min_range current_min_range+range],'XTick',[],'YTick',[]);

							fig=getframe(PlotAxes_id);
							gclust_image(zoom*(current_min_range)+1:zoom*(current_min_range+range),1:size_x,:)=fig.cdata(1:end-1,1:end-1,:);
						end;
						gclust_image=gclust_image(1:zoom*vectors_count+1,:,:);

						set(PlotAxes_id,'YLim',[min_range+0.5 min_range+range+0.5],'XTick',[],'YTick',[],'XColor',[1 1 1],'YColor',[1 1 1]);
						set(OrderAxes_id,'XLim',[0 1],'YLim',[min_range min_range+range],'XTick',[],'YTick',[]);
					else
						fig=getframe(PlotAxes_id);
						gclust_image=fig.cdata(:,1:end-1,:);
					end;
				end;
				image=[ones(size(image,1),size(gclust_image,2),3) image];
				image(33:end-4,5:size(gclust_image,2)+4,:)=gclust_image(1:end-1,:,:);
			end;

			hnd=findobj(0,'Tag','PlotAHierClust');
			if ~isempty(hnd)
				PlotAHierClust_id=figure(hnd(1));
				set(PlotAHierClust_id,'Renderer','painters'); 
				PlotAxes_id=findobj(PlotAHierClust_id,'Tag','PlotAxes');
				OrderAxes_id=findobj(PlotAHierClust_id,'Tag','OrderAxes');

				config_struct=get(PlotAHierClust_id,'UserData');
				vectors_count=config_struct.vectors_count;

				if vectors_count==arrays_count
					min_range=config_struct.min_range;
					range=config_struct.range;
					zoom=config_struct.zoom;
					scroller=config_struct.scroller;

					if scroller==1
						size_y=plot_position(4);
						aclust_image=zeros(size_y,zoom*regions_count*range,3);

						for i=0:regions_count-1
							current_min_range=i*range;
							set(PlotAxes_id,'XLim',[current_min_range+0.5 current_min_range+range+0.5],'XTick',[],'YTick',[],'XColor',[1 1 1],'YColor',[1 1 1]);
							set(OrderAxes_id,'YLim',[0 1],'XLim',[current_min_range current_min_range+range],'XTick',[],'YTick',[]);
	
							fig=getframe(PlotAxes_id);
							aclust_image(1:size_y,zoom*(current_min_range)+1:zoom*(current_min_range+range),:)=fig.cdata(1:size_y,2:end-1,:);
						end;

						aclust_image=aclust_image(:,1:zoom*vectors_count+zoom/2,:);

						set(PlotAxes_id,'XLim',[min_range+0.5 min_range+range+0.5],'XTick',[],'YTick',[],'XColor',[1 1 1],'YColor',[1 1 1]);
						set(OrderAxes_id,'YLim',[0 1],'XLim',[min_range min_range+range],'XTick',[],'YTick',[]);
					else
						fig=getframe(PlotAxes_id);
						aclust_image=fig.cdata;
%						imwrite(aclust_image,'aa.bmp',format_str{format});
					end;
					aclust_image=aclust_image(1:end-2,:,:);
				end;

				image=[ones(size(aclust_image,1),size(image,2),3) ; image];
				image(5:size(aclust_image,1)+4,end-size(aclust_image,2)-1:end-3,:)=aclust_image(:,2:end,:);
			end;			
			imwrite(image,filename,format_str{format});
		end;

	case 'export_qc_raport'
		spikedin_ids={'AFFX-r2-Ec-bioB-3_at','AFFX-r2-Ec-bioC-3_at','AFFX-r2-Ec-bioD-3_at','AFFX-r2-P1-cre-3_at'};
		spikedin_names={'BioB','BioC','BioD','CreX'};

		ratios35_ids={'AFFX-HSAC07/X00351_3_at','AFFX-HSAC07/X00351_5_at','AFFX-HUMGAPDH/M33197_3_at','AFFX-HUMGAPDH/M33197_5_at'};
		ratios35_names={'BACT3/5','GAPDH3/5'};

		[name,path,format]=uiputfile({'*.qc','Plik QC (*.qc)';'*.*','Wszystkie pliki (*.*)'},'Zapisz do pliku',[config.export_path name '.qc']);
		if isequal(name,0) || isequal(path,0)
			return;
		end;
		[filename,format]=getfname(name,path,format,{'qc'});

		switch questdlg('Czy wartoci s zlogarytmowane?','MStat','Tak','Nie','Anuluj','Tak')
			case 'Tak'
				switch questdlg('Podaj podstaw logarytmu','MStat','log_2','log_10','log_e','log_2')
					case 'log_2'
						logbase=2;
					case 'log_10'
						logbase=10;
					case 'log_e'
						logbase=exp(1);
				end;
			case 'Nie'
				logbase=0;
			otherwise
				return;
		end;

		set(Array_id,'Pointer','watch');
		pause(0.01);

		data=get(Array_id,'UserData');
		anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
		gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');

		spikedin=zeros(size(data,2),length(spikedin_ids));

		for i=1:length(spikedin_ids)
			index=find_str(spikedin_ids{i},gnames);
			if index>0
				spikedin(:,i)=data(index,:)';
			end;
		end;
		
		counter=1;
		retios35=zeros(size(data,2),length(ratios35_names));
		for i=1:2:length(ratios35_ids)
			index1=find_str(ratios35_ids{i},gnames);
			index2=find_str(ratios35_ids{i+1},gnames);
			if index1>0 & index2>0
				if logbase~=0
					ratios35(:,counter)=logbase.^(data(index1,:)-data(index2,:))';
				else
					ratios35(:,counter)=(data(index1,:)./data(index2,:))';
				end;
			end;
			counter=counter+1;
		end;

		percent=zeros(size(data,2));

		fid=fopen(filename,'w');
		if fid==-1 
			beep;
			set(Array_id,'Pointer','arrow');
			worndlg('Bd podczas zapisu pliku','MStat');
			return;
		else
			str='NAME';
			for i=1:length(spikedin_names)
				str=sprintf('%s\t%s',str,spikedin_names{i});
			end;
			for i=1:length(ratios35_names)
				str=sprintf('%s\t%s',str,ratios35_names{i});
			end;
			str=sprintf('%s\n',str);

			for i=1:size(data,2)
				str=sprintf('%s%s',str,anames{i});
				for j=1:size(spikedin,2)
					str=sprintf('%s\t%0.2f',str,spikedin(i,j));
				end;
				for j=1:size(ratios35,2)
					str=sprintf('%s\t%0.2f',str,ratios35(i,j));
				end;
				str=sprintf('%s\n',str);
			end;

			fprintf(fid,'%s',str);
			fclose(fid);
		end;

	case 'export_raport'
		[name,path,format]=uiputfile({'*.tst','Plik TST (*.tst)';'*.*','Wszystkie pliki (*.*)'},'Zapisz do pliku',[config.export_path name '.tst']);
		if isequal(name,0) || isequal(path,0)
			return;
		end;
		[filename,format]=getfname(name,path,format,{'tst'});

		switch questdlg('Czy wartoci s zlogarytmowane?','MStat','Tak','Nie','Anuluj','Tak')
			case 'Tak'
				switch questdlg('Podaj podstaw logarytmu','MStat','log_2','log_10','log_e','log_2')
					case 'log_2'
						logbase=2;
					case 'log_10'
						logbase=10;
					case 'log_e'
						logbase=exp(1);
					otherwise
						return;
				end;
			case 'Nie'
				logbase=0;
			otherwise
				return;
		end;

		set(Array_id,'Pointer','watch');
		pause(0.01);

		data=get(Array_id,'UserData');
		dimension=size(data,1);

		aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
		acnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'String');

		class_count=max(aorder);
		class_index=1:class_count;
		if class_count==1 & strcmp(acnames{1},'Brak podziau na klasy')
			acnames{1}='Wszystkie_prbki';
		end;


		gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
		gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
		gcnames=get(findobj(Array_id,'Tag','GeneClassPop'),'String');

		groups_count=max(gorder);
		if groups_count==1 & strcmp(gcnames{1},'Brak podziau na grupy')
			gcnames=[];
		end;

		stat_struct=get(findobj(Array_id,'Tag','Select1D'),'UserData');
		p=stat_struct.pval;
		f=stat_struct.fdr;
		fc=stat_struct.fc;
		test_name=stat_struct.test;

		%rednie i S
		if logbase~=0
			data=logbase.^data;
		end;
		data=data';

		m=zeros(dimension,class_count);
		s=zeros(dimension,1);
		for j=1:class_count
			index=find(aorder==j);
%			m(:,j)=trimmean(data(index,:),4)';
			m(:,j)=mean(data(index,:))';
			s=s+sqrt(var(data(index,:))')./abs(m(:,j));
		end;
		s=100*s/class_count;
		
%		if class_count==2
%			min_vals=min(data);
%			if ~isempty(find(min_vals<0))
%				fc=repmat(NaN,dimension,1);
%			else
%				fc=m(:,class_index(1))./m(:,class_index(2));
%			end;
%		end;

		%zapis
		fid=fopen(filename,'w');
		if fid==-1
			beep;
			return;
		else
			baseclass=1;
			
			str=sprintf('');
			if ~isempty(gcnames)
				str=sprintf('%s\tGROUP',str);
			end;
			
			for i=1:class_count
				str=sprintf('%s\t%s',str,remove_whitechar(acnames{class_index(i)}));
			end;
			switch class_count
				case 1
					str=sprintf('%s\tCV',str);
					if strcmp(test_name,'SVD') || strcmp(test_name,'ICA') || strcmp(test_name,'CORR')
						str=sprintf('%s\t%s',str,test_name);
					end;
				case 2
					str=sprintf('%s\tFC\tCV\tREG\t%s\tFDR',str,test_name);
				otherwise
					for i=1:class_count
						if i~=baseclass
							str=sprintf('%s\t%s/%s',str,remove_whitechar(acnames{class_index(i)}),remove_whitechar(acnames{class_index(baseclass)}));
						end;
					end;
					str=sprintf('%s\tCV\t%s\tFDR',str,test_name);
			end;
			fprintf(fid,'%s\n',str);

			for i=1:dimension
				str=sprintf('%s',gnames{i});
				if ~isempty(gcnames)
					str=sprintf('%s\t%s',str,gcnames{gorder(i)});
				end;

				for j=1:class_count
					str=sprintf('%s\t%.3f',str,m(i,class_index(j)));
				end;

				switch class_count
					case 1
						str=sprintf('%s\t%.2f',str,s(i));
						if strcmp(test_name,'SVD') || strcmp(test_name,'ICA') || strcmp(test_name,'CORR')
							str=sprintf('%s\t%.3g',str,p(i));
						end;
					case 2
						str=sprintf('%s\t%.5g',str,fc(i));
						str=sprintf('%s\t%.2f',str,s(i));
						if fc(i)>1 
							str=sprintf('%s\tU',str);
						else
							str=sprintf('%s\tD',str);
						end;
						str=sprintf('%s\t%0.5g\t%0.5g',str,p(i),f(i));

					otherwise
						for j=1:class_count
							if j~=baseclass
								str=sprintf('%s\t%.5g',str,m(i,class_index(j))/m(i,class_index(baseclass)));
							end;
						end;
						str=sprintf('%s\t%.2f',str,s(i));
						str=sprintf('%s\t%0.5g\t%0.5g',str,p(i),f(i));
				end;
				fprintf(fid,'%s\n',str);
			end;
			fclose(fid);
		end;
	
	case 'export_aorder'
		ext_str={'ads';'acl'};
		[name,path,format]=uiputfile({'*.ads','Plik ADS (*.ads)';'*.acl','Plik ACL (*.acl)'},'Zapisz do pliku',[config.open_path name]);
		if isequal(name,0) || isequal(path,0)
            return;
        else
			[filename,format]=getfname(name,path,format,ext_str);

			aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
			anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
			cnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'UserData');

			if format==2
				%zapisanie podzialu na klasy
				order=cell(length(aorder),1);
				for i=1:length(order)
					line=cell(1,2);
					line{1}=anames{i};
					line{2}=num2str(aorder(i));
					order{i}=line;
				end;
				save_cell(order,filename);

				%zapisanie nazw klas
				if length(cnames)>1
					save_cell(cnames,[filename(1:strfind(filename,'.')-1) '.acn']);
				end;
			else
				order=cell(length(aorder)+1,1);
				line=cell(1,2);
				line{1}='';
				line{2}='Klasa';
				order{1}=line;
				for i=1:length(anames)
					line=cell(1,2);
					line{1}=anames{i};
					line{2}=cnames{aorder(i)};
					order{i+1}=line;
				end;
				save_cell(order,filename);
			end;
		end;

	case 'export_anames'
		[name,path,format]=uiputfile({'*.anm','Plik ANM (*.anm)';'*.*','Wszystkie pliki (*.*)'},'Zapisz do pliku',[config.open_path name '.anm']);
		if isequal(name,0) || isequal(path,0)
            return;
        else
			[filename,format]=getfname(name,path,format,{'anm'});

			anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
			save_cell(anames,filename);
		end;

	case 'export_gorder'
		ext_str={'gcl';'gds'};
		[name,path,format]=uiputfile({'*.dsc','Plik GDS (*.gds)';'*.gcl','Plik GCL (*.gcl)'},'Zapisz do pliku',[config.open_path name]);
		if isequal(name,0) || isequal(path,0)
			return;
		else
			[filename,format]=getfname(name,path,format,ext_str);

			gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
			gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
			cnames=get(findobj(Array_id,'Tag','GeneClassPop'),'UserData');

			if format==2
				%zapisanie podzialu na grupy
				order=cell(length(gorder),1);
				for i=1:length(order)
					line=cell(1,2);
					line{1}=gnames{i};
					line{2}=num2str(gorder(i));
					order{i}=line;
				end;
				save_cell(order,filename);
			
				%zapisanie nazw grup
				if length(cnames)>1
					save_cell(cnames,[filename(1:strfind(filename,'.')-1) '.gcn']);
				end;
			else
				order=cell(length(gorder)+1,1);
				line=cell(1,2);
				line{1}='';
				line{2}='Grupa';
				order{1}=line;
				for i=1:length(gnames)
					line=cell(1,2);
					line{1}=gnames{i};
					line{2}=cnames{gorder(i)};
					order{i+1}=line;
				end;
				save_cell(order,filename);
			end;
		end;

	case 'export_gnames'
		[name,path,format]=uiputfile({'*.gnm','Plik GNM (*.gnm)';'*.*','Wszystkie pliki (*.*)'},'Zapisz do pliku',[config.export_path name '.gnm']);
		if isequal(name,0) || isequal(path,0)
			return;
		else
			[filename,format]=getfname(name,path,format,{'gnm'});

			gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
			save_cell(gnames,filename);
		end;

	case 'export_acnames'
		[name,path,format]=uiputfile({'*.acn','Plik ACN (*.acn)';'*.*','Wszystkie pliki (*.*)'},'Zapisz do pliku',[config.open_path name '.acn']);
		if isequal(name,0) || isequal(path,0)
            return;
        else
			[filename,format]=getfname(name,path,format,{'acn'});

			acnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'UserData');
			save_cell(acnames,filename);
		end;

	case 'export_gcnames'
		[name,path,format]=uiputfile({'*.gcn','Plik GCN (*.gcn)';'*.*','Wszystkie pliki (*.*)'},'Zapisz do pliku',[config.open_path name '.gcn']);
		if isequal(name,0) || isequal(path,0)
            return;
        else
			[filename,format]=getfname(name,path,format,{'gcn'});

			gcnames=get(findobj(Array_id,'Tag','GeneClassPop'),'UserData');
			save_cell(gcnames,filename);
		end;
end;

if ~isempty(path) && ~isequal(path,0) && strcmp(param,'export_gorder')~=1 && strcmp(param,'export_aorder')~=1 && strcmp(param,'export_anames')~=1 && strcmp(param,'export_acnames')~=1 && strcmp(param,'export_gcnames')~=1
	config.export_path=path;
	set(findobj(Array_id,'Tag','FileOpen'),'UserData',config);
end;
set(Array_id,'Pointer','arrow');
return;

%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function nowhite_str=remove_whitechar(str)

nowhite_str='';
if ~isempty(str) && isstr(str)
	counter=1;
	for i=1:length(str)
		if isspace(str(i))==0
			nowhite_str(counter)=str(i);
			counter=counter+1;
		end;
	end;
%	nowhite_str=char(nowhite_str);
end;
return;