function import(param);

Array_id=findobj(0,'Tag','ArrayView');

axis_id=findobj(Array_id,'Tag','ArrayAxes');
image_id=findobj(get(axis_id,'Children'),'Tag','ArrayImage');

dimension=str2num(get(findobj(Array_id,'Tag','GeneNrEdit'),'String'));
vectors_count=str2num(get(findobj(Array_id,'Tag','ArrayNrEdit'),'String'));

path=[];
config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

set(Array_id,'WindowButtonMotionFcn','');
set(Array_id,'Pointer','watch');
pause(0.01);

switch param
	case 'import_values'
		[fname,path]=uigetfile({'*.txt';'*.*'},'Otwrz plik',config.open_path);
		if fname~=0
			new_dataset=load_table([path fname]);
			if ~isempty(new_dataset.data)
				name=get(Array_id,'Name');
				dataset.name=name(strfind(name,'-')+2:length(name));
				dataset.data=get(Array_id,'UserData');
				dataset.column_names=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
				dataset.row_names=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
				dataset.column_classes=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
				dataset.class_names=get(findobj(Array_id,'Tag','ArrayClassPop'),'String');

				rdataset=replace_features(dataset,new_dataset);
				if ~isempty(rdataset)
					data=rdataset.data;
					set(Array_id,'UserData',data);
					
					mstat_cb('update_missing');	
					mstat_cb('do_menu');
					mstat_cb('do_gui');
					mstat_cb('prepare_data');
					mstat_cb('prepare_axis');
					mstat_cb('redraw');
				end;
			end;
		end;

	case 'import_arrays'
		[new_data,new_gorder,new_aorder,new_gnames,new_anames,new_gcnames,new_acnames,new_glist,new_fname,path]=load_raw(config.open_path);
		if ~isempty(new_data)
			data=get(Array_id,'UserData');
			anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
			acnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'UserData');
			aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
			gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');

			if size(new_data,1)>=size(data,1)
				new_index=name2index(gnames,new_gnames);

				if length(new_index)==size(data,1)
					switch questdlg('Czy utworzy nowe klasy?','MStat','Tak','Nie','Tak')
						case 'Tak'
							new_aorder=new_aorder+max(aorder);
							acnames=[acnames;new_acnames];
					end;

					data=[data new_data(new_index,:)];
					anames=[anames;new_anames];
					aorder=[aorder;new_aorder];

					missing_info=zeros(1,2);
					[missing_info(1),missing_info(2)]=missing_percent(data);
					missing_info(2)=size(data,1)-missing_info(2);
					set(findobj(Array_id,'Tag','ValueEdit'),'UserData',missing_info);

					set(Array_id,'UserData',data);
					set(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData',anames);
					set(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData',aorder);
					set(findobj(Array_id,'Tag','ArrayClassPop'),'String',acnames,'UserData',acnames);

					mstat_cb('do_menu');
					mstat_cb('do_gui');
					mstat_cb('prepare_data');
					mstat_cb('prepare_axis');
					mstat_cb('redraw');
				else
					beep;
				end;
			else
				%new_index=name2index(new_gnames,gnames)
				%gnames(new_index)
				beep;
			end;
			set(Array_id,'Pointer','arrow');
		end;

	case 'import_genes'
		[new_data,new_gorder,new_aorder,new_gnames,new_anames,new_gcnames,new_acnames,new_glist,new_fname,path]=load_raw(config.open_path);
		if ~isempty(new_data)
			data=get(Array_id,'UserData');
			anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
			acnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'UserData');
			aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');

			gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
			gcnames=get(findobj(Array_id,'Tag','GeneClassPop'),'UserData');
			gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
			glist=get(findobj(Array_id,'Tag','DatasetPanel'),'UserData');
			stat_struct=get(findobj(Array_id,'Tag','Select1D'),'UserData');

			if size(new_data,2)>=size(data,2)

				new_aindex=name2index(anames,new_anames);
				new_gindex=1:size(new_data,1);
				new_gindex(name2index(gnames,new_gnames))=[];
				
				if length(new_aindex)==size(data,2) & ~isempty(new_gindex)
					new_data=new_data(new_gindex,new_aindex);
					new_gnames=new_gnames(new_gindex);
					new_gorder=new_gorder(new_gindex);
					gcnames_index=zeros(1,length(new_gcnames));

					for i=1:length(new_gcnames)
						if isempty(find(new_gorder==i))
							gcnames_index(i)=1;
						end;
					end;
					new_gcnames(find(gcnames_index==1))=[];
					new_gorder=reorder_labels(new_gorder);
					
					switch questdlg('Czy utworzy nowe klasy?','MStat','Tak','Nie','Tak')
						case 'Tak'
							new_gorder=new_gorder+max(gorder);
							gcnames=[gcnames;new_gcnames];
						case 'Nie'
							classes_count=length(gcnames);

							gcnames_index=name2index(new_gcnames,gcnames);
							common_gcnames=gcnames(gcnames_index);
							gcnames_index2=name2index(common_gcnames,new_gcnames);
							
							ordered_new_gorder=new_gorder+classes_count;
							for i=1:length(common_gcnames)
								ordered_new_gorder(find(new_gorder==gcnames_index2(i)))=gcnames_index(i);
							end;
							new_gorder=ordered_new_gorder;

							new_gcnames(gcnames_index2)=[];
							gcnames=[gcnames;new_gcnames];
					end;
					
					new_genes_count=length(new_gnames);
					data=[data;new_data(:,new_aindex)];
					gnames=[gnames;new_gnames];
					gorder=reorder_labels([gorder;new_gorder]);
					glist=[glist;([1:new_genes_count]+max(glist))'];

					stat_struct.fc=[stat_struct.fc;NaN*ones(new_genes_count,1)];
					stat_struct.pval=[stat_struct.pval;NaN*ones(new_genes_count,1)];
					stat_struct.fdr=[stat_struct.fdr;NaN*ones(new_genes_count,1)];
					stat_struct.n=[stat_struct.n;ones(new_genes_count,1)];
					
					missing_info=zeros(1,2);
					[missing_info(1),missing_info(2)]=missing_percent(data);
					missing_info(2)=size(data,1)-missing_info(2);
					set(findobj(Array_id,'Tag','ValueEdit'),'UserData',missing_info);

					set(Array_id,'UserData',data);
					set(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData',gnames);
					set(findobj(Array_id,'Tag','GeneClassAxes'),'UserData',gorder);
					set(findobj(Array_id,'Tag','GeneClassPop'),'String',acnames,'UserData',gcnames);
					set(findobj(Array_id,'Tag','DatasetPanel'),'UserData',glist);
					set(findobj(Array_id,'Tag','Select1D'),'UserData',stat_struct);

					mstat_cb('do_menu');
					mstat_cb('do_gui');
					mstat_cb('prepare_data');
					mstat_cb('prepare_axis');
					mstat_cb('redraw');
				else
					beep;
				end;
			else
				beep;
			end;
			set(Array_id,'Pointer','arrow');
		end;

	case 'import_anames'
		[fname,path,format]=uigetfile({'*.anm';'*.*'},'Otwrz plik',config.open_path);
		if fname~=0
			records=load_cell([path fname]);
			if length(records)==vectors_count
				set(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData',records);
				mstat_cb('do_gui');
			else
				beep;
				set(Array_id,'Pointer','arrow');
				pause(0.01);
				
				warndlg('Liczba etykiet rna od liczby prbek','MStat');
			end;
		end;

	case 'import_aorder'
		[fname,path,format]=uigetfile({'*.ads','Plik ADS (*.ads)';'*.acl','Plik ACL (*.acl)'},'Otwrz plik',config.open_path);
		if fname~=0
			anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
			
			if format==2
				records=load_cell2([path fname]);
				records_count=length(records);

				if records_count>=vectors_count
					names=cell(records_count,1);
					order=zeros(records_count,1);
					for i=1:records_count
						record=records{i};
						if length(record)<2
							beep;
							set(Array_id,'Pointer','arrow');
							pause(0.01);
							
							warndlg(sprintf('Nieprawidowy format pliku w linii %d:',i),'MStat');
							return;
						end;
						names{i}=record{1};
						order(i)=str2num(record{2});
					end;

					order=order-min(order)+1;

					index=name2index(anames,names);
					aorder=order(index);

					if length(aorder)==vectors_count
						classes=unique(aorder);
						classes_count=length(classes);
						aorder=reorder_labels(aorder);

						if ~isempty(strfind(fname,'.'))
							fname=fname(1:strfind(fname,'.')-1);
						end;
						acnames=load_cell([path fname '.acn']);

						if isempty(acnames) || classes_count>length(acnames)
							acnames=cell(classes_count,1);
							if classes_count==1
								acnames{1}='Brak podziau na klasy';
							else
								for i=1:classes_count
									acnames{i}=['Klasa' num2str(i)];
								end;
							end;
						else
							acnames=acnames(classes);
						end;

						set(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData',aorder);
						set(findobj(Array_id,'Tag','ArrayClassPop'),'Value',1);
						set(findobj(Array_id,'Tag','ArrayClassPop'),'UserData',acnames);

						mstat_cb('do_gui');
						mstat_cb('do_menu');
						mstat_cb('redraw');
					else
						beep;
						set(Array_id,'Pointer','arrow');
						pause(0.01);
						warndlg('Nie znaleziono etykiet dla wszystkich prbek','MStat');
					end;
				else
					beep;
					set(Array_id,'Pointer','arrow');
					pause(0.01);
					warndlg('Nie znaleziono etykiet dla wszystkich prbek','MStat');
				end;
			else
				[new_anames,ids,column]=load_description([path fname]);
				
				if column<1
					beep;
					set(Array_id,'Pointer','arrow');
					pause(0.01);
					if column==0
						warndlg('Brak podziau na klasy','MStat');
					end;
					return;
				end;
	
				index=name2index(anames,new_anames);
				
				if length(index)==vectors_count
					ids=ids(index);
					
					[b,index]=unique(ids,'first');
					new_acnames=ids(sort(index));
					
					new_aorder=zeros(vectors_count,1);
					
					%zamienic na cos madrzejszego niz przeszukiwanie liniowe
					for i=1:length(ids)
						for j=1:length(new_acnames)
							if strcmp(new_acnames{j},ids{i})==1
								new_aorder(i)=j;
								break;
							end;
						end;
					end;

					set(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData',new_aorder);
					set(findobj(Array_id,'Tag','ArrayClassPop'),'Value',1);
					set(findobj(Array_id,'Tag','ArrayClassPop'),'UserData',new_acnames);

					mstat_cb('do_gui');
					mstat_cb('do_menu');
					mstat_cb('redraw');
				else
					beep;
					set(Array_id,'Pointer','arrow');
					pause(0.01);
					
					warndlg('Nie znaleziono etykiet dla wszystkich prbek','MStat');
				end;
			end;
		end;

	case 'import_gnames'
		[fname,path,format]=uigetfile({'*.gnm';'*.*'},'Otwrz plik',config.open_path);
		if fname~=0
			records=load_cell([path fname]);
			if length(records)==dimension
				set(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData',records);
				mstat_cb('do_gui');
			else
				beep;
				set(Array_id,'Pointer','arrow');
				pause(0.01);
							
				warndlg('Liczba etykiet rna od liczby cech','MStat');
			end;
		end;

	case 'import_gorder'
		[fname,path,format]=uigetfile({'*.gds','Plik GDS (*.gds)';'*.gcl','Plik GCL (*.gcl)'},'Otwrz plik',config.open_path);
		if fname~=0
			gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');

			if format==2
				records=load_cell2([path fname]);
				records_count=length(records);

				if records_count>=dimension
					names=cell(records_count,1);
					order=zeros(records_count,1);
					for i=1:records_count
						record=records{i};
						if length(record)<2
							beep;
							set(Array_id,'Pointer','arrow');
							pause(0.01);
							
							warndlg(sprintf('Nieprawidowy format pliku w linii %d:',i),'MStat');
							return;
						end;					
						names{i}=record{1};
						order(i)=str2num(record{2});
					end;

					order=order-min(order)+1;
					
					index=name2index(gnames,names)
					gorder=order(index);

					if length(gorder)==dimension
						classes=unique(gorder);
						classes_count=length(classes);
						gorder=reorder_labels(gorder);

						if ~isempty(strfind(fname,'.'))
							fname=fname(1:strfind(fname,'.')-1);
						end;
						gcnames=load_cell([path fname '.gcn']);
						
						if isempty(gcnames) || classes_count>length(gcnames)
							gcnames=cell(classes_count,1);
							if classes_count==1
								gcnames{1}='Brak podziau na grupy';
							else
								for i=1:classes_count
									gcnames{i}=['Grupa' num2str(i)];
								end;
							end;
						else
							gcnames=gcnames(classes);
						end;

						set(findobj(Array_id,'Tag','GeneClassAxes'),'UserData',gorder);
						set(findobj(Array_id,'Tag','GeneClassPop'),'Value',1);
						set(findobj(Array_id,'Tag','GeneClassPop'),'UserData',gcnames);

						mstat_cb('do_gui');
						mstat_cb('do_menu');
						mstat_cb('redraw');
					else
						beep;
						set(Array_id,'Pointer','arrow');
						pause(0.01);
							
						warndlg('Nie znaleziono etykiet dla wszystkich cech','MStat');
					end;
				else
					beep;
					set(Array_id,'Pointer','arrow');
					pause(0.01);
					warndlg('Nie znaleziono etykiet dla wszystkich cech','MStat');
				end;
			else
				[new_gnames,ids,column]=load_description([path fname]);
				
				if column<1
					beep;
					set(Array_id,'Pointer','arrow');
					pause(0.01);
					if column==0
						warndlg('Brak podziau na grupy','MStat');
					end;
					return;
				end;
				
				index=name2index(gnames,new_gnames);
				%[n, bin] = histc(new_gnames(index), unique(new_gnames(index)));
				%multiple = find(n > 1);
				%ii    = find(ismember(bin, multiple))
				
				if length(index)==dimension;
					ids=ids(index);
					
					[b,index]=unique(ids,'first');
					new_gcnames=ids(sort(index));

					%zamienic na cos madrzejszego niz przeszukiwanie liniowe
					new_gorder=zeros(dimension,1);
					for i=1:length(ids)
						for j=1:length(new_gcnames)
							if strcmp(new_gcnames{j},ids{i})==1
								new_gorder(i)=j;
								break;
							end;
						end;
					end;

					set(findobj(Array_id,'Tag','GeneClassAxes'),'UserData',new_gorder);
					set(findobj(Array_id,'Tag','GeneClassPop'),'Value',1);
					set(findobj(Array_id,'Tag','GeneClassPop'),'UserData',new_gcnames);

					mstat_cb('do_gui');
					mstat_cb('do_menu');
					mstat_cb('redraw');
				else
					beep;
					set(Array_id,'Pointer','arrow');
					pause(0.01);
					
					warndlg('Nie znaleziono etykiet dla wszystkich cech','MStat');
				end;
			end;
		end;

	case 'import_gin'
		[fname,path]=uigetfile({'*.gin';'*.*'},'Otwrz plik',config.chip_path);
		if fname~=0
			records=load_cell2([path fname]);
			gin.ProbeSetName=java.util.Hashtable;
			gin.Symbol=cell(length(records),1);
			gin.Name=cell(length(records),1);
			gin.Description=cell(length(records),1);
			for i=1:length(records)
				record=records{i};
				record_len=length(record);
				if record_len>1
					gin.ProbeSetName.put(record{1},double(i)); 
					gin.Symbol{i}=record{2};
					if record_len>2
						gin.Name{i}=record{3};
						if record_len>3
							gin.Description{i}=record{4};
						end;
					end;
				end;
			end;

			set(findobj(Array_id,'Tag','GeneInfo'),'UserData',gin);
			selected_nr=get(findobj(Array_id,'Tag','SelectedGeneEdit'),'UserData');
			if selected_nr>0
				set(findobj(Array_id,'Tag','GeneInfo'),'Enable','on');
				set(findobj(Array_id,'Tag','GeneInfoPopup'),'Enable','on');
			end;
		end;
end;
set(Array_id,'Pointer','arrow');
set(Array_id,'WindowButtonMotionFcn','mstat_mf');
pause(0.01);

return;

%
%%%%%%%%%%%%%%%%%%%%%%%%%
function tokens=tokenize_line(line)

tokens={};
counter=1;
token='0';
while ~isempty(token)
	[token,line]=strtok(line);
	if ~isempty(token)
		tokens{counter}=token;
		counter=counter+1;
	end;
end;
return;

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function rtarget=replace_features(target,source)

target_data=target.data;
source_data=source.data;

target_anames=target.column_names;
source_anames=source.column_names;

target_aindex=name2index(source_anames,target_anames);
source_aindex=name2index(target_anames(target_aindex),source_anames);

rtarget=[];
if (length(target_aindex)==length(source_aindex))
	target_gnames=target.row_names;
	source_gnames=source.row_names;

	target_index=name2index(source_gnames,target_gnames);
	source_index=name2index(target_gnames(target_index),source_gnames);

	if (length(target_index)==length(source_index))
		target_data(target_index,target_aindex)=source_data(source_index,source_aindex);

		rtarget=target;
		rtarget.data=target_data;
	end;
end;
return;