function [labels,optimal_d]=cluster_lvq(data,k,dist_metric,eta,epochs,iterations)

if nargin<2
	error('Missing input data');
elseif nargin==2
	dist_metric='euclidean';
    eta=0.1;
    epochs=10;    
	iterations=1;
elseif nargin==3
    eta=0.1;
    epochs=10;    
	iterations=1;
elseif nargin==4
    epochs=10;    
	iterations=1;
elseif nargin==5
	iterations=1;
end

%parametry rysowania
plot_step=0;
plot_epoch=1;

vectors_count=size(data,2);

rng('default')

%TODO iteracje
%losowanie wag neuronow (pozycji centroidow)
C=cluster_init(data,k);

if plot_step==1 || plot_epoch==1
    figure();
    cluster_plot(data,cluster_centr2ord(data,C,dist_metric),C);
end

for i=1:epochs
    %losowanie kolejnosci podawania wektorow
    ind=randperm(vectors_count);

    for j=1:vectors_count
        
        %wybor wektora
        x=data(:,ind(j));

        %szukanie zwycieskiego neuronu (centroidu)
        d=pdist2(C',x',dist_metric);
        [~,w]=min(d);

        %aktualizacja wag zwycieskiego neuronu (centroidu)
        C(:,w) = eta*x + (1-eta)*C(:,w);
        
        if plot_step==1
            cluster_plot(data,cluster_centr2ord(data,C,dist_metric),C);
        end
    end
    
    if plot_epoch==1
        cluster_plot(data,cluster_centr2ord(data,C,dist_metric),C);
    end
end

labels=cluster_centr2ord(data,C,dist_metric);

optimal_d=0;
return