function cluster_optics_plot(labels,order,rd,epsilon,plot_type)

if (nargin<5)
    plot_type='bars';
end

labels=labels(order);
rd=rd(order);

clusters=unique(labels);
clusters_count=length(clusters);

x=1:length(order);

%%Plot
figure('Units','pixels', ...
	'Visible','on',...
	'MenuBar','none', ...
	'Color',get(0,'defaultUicontrolBackgroundColor'),...
	'NumberTitle','off', ...
	'Resize','off',...
	'Tag','PlotOptics',...
	'Name','OPTICS');

FileMenu_id=uimenu('Label','&Plik');
uimenu(FileMenu_id,'Label','&Zapisz...','CallBack','figsave_cb');
uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','delete(gcbf)');

colors=ctable();

hold on;
for i=1:clusters_count
    idx=find(labels==clusters(i));
    if (~isempty(idx))   
        cindex=mod(i-1,length(colors));
        if cindex==0
            cindex=length(colors);
        end;

        if strcmpi(plot_type,'points')==true
            h=plot(x(idx),rd(idx),'o','MarkerSize',5,'MarkerFaceColor',colors(cindex,:),'MarkerEdgeColor',colors(cindex,:));
        else
            h=bar(x(idx),rd(idx),1,'FaceColor',colors(cindex,:),'EdgeColor',colors(cindex,:));
            %h=bar(x(idx),rd(idx),1,'FaceColor',colors(cindex,:),'EdgeColor',[0 0 0]);
        end;
    end;
end;

plot([0 length(order)],[epsilon, epsilon],'LineStyle','--','Color',[0.5 0.5 0.5],'LineWidth',1.5);
hold off;

y_max=max(epsilon,max(rd(~isinf(rd))));
y_min=min(rd(~isinf(rd)));
y_range=y_max-y_min;

  
set(gca,'XLim',[0.5 length(order)+0.5],'XTick',[]);
if strcmpi(plot_type,'points')==true
    set(gca,'YLim',[y_min-(0.05)*y_range y_max+(0.05)*y_range]);
else
    set(gca,'YLim',[0 y_max+(0.05)*y_range]);
end
ylabel('Reachability distance')

return;
