function cluster_plot(X,order,centroids)

color=ctable;

for i=1:max(order)
	index=find(order==i);
	if ~isempty(index)
		h=plot(X(1,index),X(2,index),'o');
		set(h,'Color',color(i,:));
		hold on;
	end;
end;

range1=(max(X(1,:))-min(X(1,:)));
range2=(max(X(2,:))-min(X(2,:)));

for i=1:size(X,2)
	text(X(1,i)+0.02*range1,X(2,i)+0.02*range2,num2str(i));
end;

if ~isempty(centroids)
	for i=1:size(centroids,2)
		h=plot(centroids(1,i),centroids(2,i),'s');
		set(h,'Color',color(i,:));
	end;
end;

range1=(max(X(1,:))-min(X(1,:)));
range2=(max(X(2,:))-min(X(2,:)));

set(gca,'Xlim',[min(X(1,:))-0.1*range1 max(X(1,:))+0.1*range1]);
set(gca,'Ylim',[min(X(2,:))-0.1*range2 max(X(2,:))+0.1*range2]);
set(gca,'Box','on');
xlabel('X_1');
ylabel('X_2');
hold off;

waitforbuttonpress;
return;

function f=clusters_plot_dbscan(X,order,flag)

color=ctable;

vectors_count=size(X,2);

f=figure();
hold on;
core_index=find(flag==1);
for i=1:max(order)
	index=find(order==i);
	if ~isempty(index)
		h=plot(X(1,index),X(2,index),'o');
		set(h,'Color',color(i,:));

		cindex=intersect(index,core_index);
		if ~isempty(cindex)
			h=plot(X(1,cindex),X(2,cindex),'s');
			set(h,'Color',color(i,:));
		end;
	end;
end;
%index=find(flag==-1);
%if ~isempty(index)
%	h=plot(X(1,index),X(2,index),'o');
%	set(h,'Color',[0.5 0.5 0.5]);
%end;
index=find(order==0);
if ~isempty(index)
	h=plot(X(1,index),X(2,index),'ok');
end;


range1=(max(X(1,:))-min(X(1,:)));
range2=(max(X(2,:))-min(X(2,:)));

for i=1:vectors_count
	text(X(1,i)+0.02*range1,X(2,i)+0.02*range2,num2str(i));
end;
hold off;

set(gca,'Xlim',[min(X(1,:))-0.1*range1 max(X(1,:))+0.1*range1]);
set(gca,'Ylim',[min(X(2,:))-0.1*range2 max(X(2,:))+0.1*range2]);
return;