function [s,s_avrg]=cluster_silhouette(data,order,dist_metric,plt)

if nargin==2
	dist_metric='euclidean';
	plt=0;
end;
if nargin==3
	plt=0;
end;

distmtx=cluster_distmtx(data,dist_metric);

%TODO inaczej
vectors_count=size(data,2);

clusters_count=max(order);

s=zeros(1,vectors_count);
d=zeros(1,clusters_count);

a=0;
b=0;
for i=1:vectors_count
	for j=1:clusters_count
		cluster_vectors_list=find(order==j);
		cluster_vectors_nr=length(cluster_vectors_list);
		if j==order(i)
			a=sum(distmtx(i,cluster_vectors_list))/(cluster_vectors_nr-1);
			d(j)=Inf;
		else
			d(j)=sum(distmtx(i,cluster_vectors_list))/cluster_vectors_nr;
		end;
	end;
	b=min(d);
	s(i)=(b-a)/max(a,b);
end;

s_avrg=mean(s(~isnan(s)));

if plt==1
    color=ctable;
    
	figure('Units','pixels', ...
	'Visible','on',...
	'MenuBar','none', ...
	'Color',get(0,'defaultUicontrolBackgroundColor'),...
	'NumberTitle','off', ...
	'Resize','off',...
	'Tag','PlotSilhouette',...
	'Name','Silhouette');

	FileMenu_id=uimenu('Label','&Plik');
	uimenu(FileMenu_id,'Label','&Zapisz...','CallBack','figsave_cb');
	uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','delete(gcbf)');

	hold on;
	start_ptr=0;
	for i=1:clusters_count
		cluster_vectors_list=find(order==i);
		cluster_vectors_nr=length(cluster_vectors_list);
		sort_s=sort(s(cluster_vectors_list));
		sort_s=sort_s(cluster_vectors_nr:-1:1);
		for j=1:cluster_vectors_nr
			h=fill([start_ptr+j-0.5;start_ptr+j-0.5;start_ptr+j+0.5;start_ptr+j+0.5],[0;sort_s(j);sort_s(j);0],color(i,:));
			set(h,'EdgeColor',[0 0 0]);
		end;
		XTick(i)=start_ptr+cluster_vectors_nr/2+0.5;
		XTickLabel(i,:)=sprintf('%d',i);

		start_ptr=start_ptr+cluster_vectors_nr;
	end;

	text(vectors_count-0.25*vectors_count,-0.9,['s_m_e_a_n= ' num2str(s_avrg)]);
	hold off;
	set(gca,'XLim',[0.5 vectors_count+0.5],'YLim',[-1 1],'XTick',XTick,'XTickLabel',XTickLabel,'box','on');
end;
