function [filtered_data,list]=data_filter(data,method,param);

dimension=size(data,1);
vectors_count=size(data,2);

list=[];
switch method
	case 1
		max_same_nr=param;
		k=1;
		temp_list=1:dimension;
		for i=1:dimension
			for j=1:vectors_count
				if length(find(data(i,:)==data(i,j)))>=max_same_nr
					list(k)=i;
					k=k+1;
					break;
				end;
			end;
		end;

	case 2
		max_same_nr=param;
		index=zeros(1,dimension);
		for i=1:dimension
			for j=i+1:dimension
				d=sum(data(i,:)==data(j,:));
				if d>max_same_nr
					index(i)=1;
				end;
			end;
		end;
		list=find(index==1);

	case 3
		min_nr=param(1);
		min_val=param(2);

		list=find(sum(abs(data)>min_val,2)<min_nr);

	case 4
		k=1;
		threshold=log2(param(2));
		for i=1:dimension
			d=data(i,:)-median(data(i,:));
			index=find(d>threshold | d<-1*threshold);
			if length(index)<param(1)
				list(k)=i;
				k=k+1;
			end;
		end;

	case 5
		iqr_threshold=param;
		rows_iqr=iqr(data');
		list=find(rows_iqr<iqr_threshold);

	case 6
		sd_threshold=param;
		rows_sd=sqrt(var(data')')./mean(data,2);
		list=find(rows_sd<sd_threshold);

	case 7
		max_val=max(data,[],2);
		min_val=min(data,[],2);
		m1=max_val-min_val;
		m2=max_val./min_val;

		list=find(((m1<param(1))+(m2<param(2)))==2);
end;
data(list,:)=[];
filtered_data=data;
