function clustering_cb(action)

Array_id=findobj(0,'Tag','ArrayView');
ACluster_id=gcbf;

SAMPLES=1;
FEATURES=2;

%Data
GroupPop_id=findobj(ACluster_id,'Tag','GroupPop');
%Clustering
MethodPop_id=findobj(ACluster_id,'Tag','MethodPop');
DistPop_id=findobj(ACluster_id,'Tag','DistPop');
%Kmeans
KmeansClustersEdit_id=findobj(ACluster_id,'Tag','KmeansClustersEdit');
KmeansIterationsEdit_id=findobj(ACluster_id,'Tag','KmeansIterationsEdit');
KmeansCentroidPop_id=findobj(ACluster_id,'Tag','KmeansCentroidPop');
%Lvq
LvqClustersEdit_id=findobj(ACluster_id,'Tag','LvqClustersEdit');
LvqIterationsEdit_id=findobj(ACluster_id,'Tag','LvqIterationsEdit');
LvqEpochsEdit_id=findobj(ACluster_id,'Tag','LvqEpochsEdit');
LvqEtaEdit_id=findobj(ACluster_id,'Tag','LvqEtaEdit');
%Hierarchical
HierLinkagePop_id=findobj(ACluster_id,'Tag','HierLinkagePop');
HierClustersCheck_id=findobj(ACluster_id,'Tag','HierClustersCheck');
HierClustersPop_id=findobj(ACluster_id,'Tag','HierClustersPop');
HierClustersEdit_id=findobj(ACluster_id,'Tag','HierClustersEdit');
%Dbscan
DbscanMinPtsEdit_id=findobj(ACluster_id,'Tag','DbscanMinPtsEdit');
DbscanEtaEdit_id=findobj(ACluster_id,'Tag','DbscanEtaEdit');
%Optics
OpticsMinPtsEdit_id=findobj(ACluster_id,'Tag','OpticsMinPtsEdit');
OpticsEtaEdit_id=findobj(ACluster_id,'Tag','OpticsEtaEdit');
%J-P
JpKEdit_id=findobj(ACluster_id,'Tag','JpKEdit');
JpLEdit_id=findobj(ACluster_id,'Tag','JpLEdit');
%J-P
NbcKEdit_id=findobj(ACluster_id,'Tag','NbcKEdit');
%Preprocessing
NormalizeCheck_id=findobj(ACluster_id,'Tag','NormalizeCheck');
PcaCheck_id=findobj(ACluster_id,'Tag','PcaCheck');
PcaEdit_id=findobj(ACluster_id,'Tag','PcaEdit');
%PostProcessing
ReorderCheck_id=findobj(ACluster_id,'Tag','ReorderCheck');
%Quality
QualitySilEdit_id=findobj(ACluster_id,'Tag','QualitySilEdit');


%
%Data and variables
method_string=get(MethodPop_id,'String');
dist_string=get(DistPop_id,'String');
linkage_string=get(HierLinkagePop_id,'String');
kmeans_cmethod_string={'kmeans','kmedians'};

if strcmp(get(ACluster_id,'Tag'),'ACluster')
    ctype=SAMPLES;
    aorder_tag='ArrayClassAxes';
    anames_tag='SelectedArrayNameEdit';
    acnames_tag='ArrayClassPop';
    gorder_tag='GeneClassAxes';
    plot_tag='PlotAHierClust';
else
    ctype=FEATURES;   
    aorder_tag='GeneClassAxes';
    anames_tag='SelectedGeneNameEdit';
    acnames_tag='GeneClassPop';    
    gorder_tag='ArrayClassAxes';
    plot_tag='PlotGHierClust';    
end
aorder=get(findobj(Array_id,'Tag',aorder_tag),'UserData');    
anames=get(findobj(Array_id,'Tag',anames_tag),'UserData');
gorder=get(findobj(Array_id,'Tag',gorder_tag),'UserData');

dimension=length(gorder);
vectors_count=length(aorder);
clusters_count=length(unique(aorder));
            
if strcmp(action,'cluster')==1 || strcmp(action,'dbscan_plot')==1 || strcmp(action,'sil_plot')==1
    data=get(Array_id,'UserData');
	
    if ctype==FEATURES
        data=data';
    end
        
	group=get(GroupPop_id,'Value');
    if group~=1
		data=data((gorder==group-1),:);
    end

    if get(NormalizeCheck_id,'Value')==1
		data=data_normalize(data_center(data,'mean'),'std');
    end
    
    if get(PcaCheck_id,'Value')==1 
		pc_count=str2double(get(PcaEdit_id,'String'));
        if pc_count>0
            data=data-repmat(mean(data,2),1,size(data,2));
           
            [~,s,v]=svd(data,0);
            data=s(1:pc_count,1:pc_count)*v(:,1:pc_count)';
        end
    end
end


%
%Callbacks
switch action
	case 'group_pop'
		group=get(GroupPop_id,'Value');
		if group~=1
			dimension=length(find(gorder==group-1));
		end

		pc_count=min(dimension,vectors_count-1);
		set(PcaEdit_id,'String',num2str(pc_count));
		set(PcaEdit_id,'UserData',pc_count);

	case 'method_pop'
        set(ReorderCheck_id,'Enable','on');
                
        is_hier='off';
        is_kmeans='off';
        is_lvq='off';        
        is_dbscan='off';
        is_optics='off';        
        is_nbc='off';                        
        is_jp='off';
        
		switch lower(method_string{get(MethodPop_id,'Value')})
			case 'hierarchical'
				set(ReorderCheck_id,'Enable','off');
                is_hier='on';          
			case 'k-means'
                is_kmeans='on';
			case 'lvq'
                is_lvq='on';                
            case 'dbscan'
                is_dbscan='on';                
            case 'optics'                
                is_optics='on';                
            case 'nbc'
                is_nbc='on';                                
            case 'jarvis-patrick'
                is_jp='on';                
		end
        
        set(findobj(ACluster_id,'Tag','HierPanel'),'Visible',is_hier);
        set(findobj(ACluster_id,'Tag','KmeansPanel'),'Visible',is_kmeans);
        set(findobj(ACluster_id,'Tag','LvqPanel'),'Visible',is_lvq);        
        set(findobj(ACluster_id,'Tag','DbscanPanel'),'Visible',is_dbscan);
        set(findobj(ACluster_id,'Tag','OpticsPanel'),'Visible',is_optics);        
        set(findobj(ACluster_id,'Tag','NbcPanel'),'Visible',is_nbc);
        set(findobj(ACluster_id,'Tag','JpPanel'),'Visible',is_jp);                        

	case 'linkage_pop'
		dist_index=get(DistPop_id,'Value');
		switch linkage_string{get(HierLinkagePop_id,'Value')}
			case {'centroid','median','ward'}
				dist_string={'euclidean'};
			otherwise
				dist_string={'euclidean';'seuclidean';'correlation';'cosine';'spearman';'mahalanobis';'cityblock';'chebychev'};
		end
		if dist_index>length(dist_string)
			dist_index=1;
		end
		set(DistPop_id,'Value',dist_index);
		set(DistPop_id,'String',dist_string);

	case 'distance_pop'
		link_index=get(HierLinkagePop_id,'Value');
		switch dist_string{get(DistPop_id,'Value')}
			case {'euclidean'}
				linkage_string={'single';'complete';'average';'weighted';'ward';'centroid';'median'};
			otherwise
				linkage_string={'single';'complete';'average';'weighted'};
		end

		if link_index>length(linkage_string)
			link_index=3;
		end
		set(HierLinkagePop_id,'Value',link_index);
		set(HierLinkagePop_id,'String',linkage_string);

	case 'pca_check'
		if get(PcaCheck_id,'Value')==1
			set(PcaEdit_id,'Enable','on');
		else
			set(PcaEdit_id,'Enable','off');
		end

	case 'create_clusters_check'
		if get(gcbo,'Value')==1
			set(HierClustersPop_id,'Enable','on');
			set(HierClustersEdit_id,'Enable','on');
			clustering_cb('create_clusters_pop');
		else
			set(HierClustersPop_id,'Enable','off');
			set(HierClustersEdit_id,'Enable','off');
		end

	case 'create_clusters_pop'
        def_val=0.2;        
        if get(HierClustersPop_id,'Value')==1
			set(HierClustersEdit_id,'UserData',[0 inf def_val 0],'String','0.2');
        else
            def_val=num2str(max(clusters_count,2));
			set(HierClustersEdit_id,'UserData',[1 vectors_count def_val 1]);
        end
        set(HierClustersEdit_id,'String',num2str(def_val));
        
	case 'dbscan_plot'
		dist_metric=lower(dist_string{get(DistPop_id,'Value')});
		min_pts=str2double(get(DbscanMinPtsEdit_id,'String'));
        
		cluster_dbscan_plot(data,min_pts,dist_metric);
        
        %set(QualitySilEdit_id,'String',num2str(s_avg));
	
    case 'sil_plot'
		dist_metric=lower(dist_string{get(DistPop_id,'Value')});
		
		[~,s_avg]=cluster_silhouette(data,aorder,dist_metric,1);
        
        set(QualitySilEdit_id,'String',num2str(s_avg));
        
	case 'cluster'
		set(Array_id,'Pointer','watch');
		set(ACluster_id,'Pointer','watch');
		pause(0.01);

		method=lower(method_string{get(MethodPop_id,'Value')});
        dist_metric=dist_string{get(DistPop_id,'Value')};
		
        error_msg=[];
        labels=[];
        
		switch method
            %TODO wywalic PCA z klasteryzacji
                    
			case 'hierarchical'
                clusters_count=str2double(get(HierClustersEdit_id,'String'));        
                if get(HierClustersCheck_id,'Value')==0
					clusters_count=NaN;
                elseif get(HierClustersPop_id,'Value')==2
					clusters_count=-1*clusters_count;
                end

				z=cluster_hier(data,linkage_string{get(HierLinkagePop_id,'Value')},dist_metric,0);
				[order,clusters]=plot_hierclust(z,clusters_count);

    			org_data=get(Array_id,'UserData');              
				image_data=get(findobj(Array_id,'Tag','ArrayAxes'),'UserData');

                if ctype==SAMPLES
                    org_data=org_data(:,order);
                    image_data=image_data(:,order);
                elseif ctype==FEATURES
                    org_data=org_data(order,:);
                    image_data=image_data(order,:);
                    
                    glist=get(findobj(Array_id,'Tag','DatasetPanel'),'UserData');
                    glist=glist(order);
                    set(findobj(Array_id,'Tag','DatasetPanel'),'UserData',glist);
                
                    stat_struct=get(findobj(Array_id,'Tag','Select1D'),'UserData');
     				stat_struct.fc=stat_struct.fc(order);
                    stat_struct.pval=stat_struct.pval(order);
                    stat_struct.fdr=stat_struct.fdr(order);
                    stat_struct.n=stat_struct.n(order);
                    set(findobj(Array_id,'Tag','Select1D'),'UserData',stat_struct);
                end
				set(Array_id,'UserData',org_data);                
				set(findobj(Array_id,'Tag','ArrayAxes'),'UserData',image_data);
                
                if get(HierClustersCheck_id,'Value')==0
                    labels=aorder(order);
				else
					labels=clusters(order);
                end
                
                anames=anames(order);
                set(findobj(Array_id,'Tag',anames_tag),'UserData',anames);

                
			case 'k-means'
                k=str2double(get(KmeansClustersEdit_id,'String'));
                
                if k>1 && k<vectors_count
					iterations=str2double(get(KmeansIterationsEdit_id,'String'));
                    cmethod=kmeans_cmethod_string{get(KmeansCentroidPop_id,'Value')};
                    
					[labels,d]=cluster_kmeans(data,k,cmethod,dist_metric,0,iterations);
					%d
                else
                    error_msg='Nieprawidowa liczba klastrw';
                end
                
            case 'lvq'
                k=str2double(get(LvqClustersEdit_id,'String'));
                
                if k>1 && k<vectors_count
                    epochs=str2double(get(LvqEpochsEdit_id,'String'));
					eta=str2double(get(LvqEtaEdit_id,'String'));                
                    iterations=str2double(get(LvqIterationsEdit_id,'String'));
                    
					[labels,d]=cluster_lvq(data,k,dist_metric,eta,epochs,iterations);
					%d
                else
                    error_msg='Nieprawidowa liczba klastrw';
                end

            case 'dbscan'
                %TODO kwestia noise
				min_pts=str2double(get(DbscanMinPtsEdit_id,'String'));
				epsilon=str2double(get(DbscanEtaEdit_id,'String'));
                
				[labels,flags]=cluster_dbscan(data,min_pts,epsilon,dist_metric)

            case 'optics'
                %TODO kwestia noise
				min_pts=str2double(get(OpticsMinPtsEdit_id,'String'));
				epsilon=str2double(get(OpticsEtaEdit_id,'String'));
                
                [cd,rd,ord]=cluster_optics(data,min_pts,epsilon);
                labels=cluster_optics_extract(epsilon,ord,cd,rd)
                
                cluster_optics_plot(labels,ord,rd,epsilon,'bars');
                
			case 'jarvis-patrick'
				k=str2double(get(JpKEdit_id,'String'));
                if k>1 && k<=vectors_count
                    l=str2double(get(JpLEdit_id,'String'));
                    if l>1 && l<=k
                        labels=cluster_jp(data,k,l,dist_metric,0);
                    end
                end
                if isempty(labels)
                    error_msg='Nieprawidowe wartoci parametrw';
                end

			case 'nbc'
				k=str2double(get(NbcKEdit_id,'String'));
                if k>=1 && k<=vectors_count			
                    labels=cluster_nbc(data,k,dist_metric);
                end
                if isempty(labels)
                    error_msg='Nieprawidowa liczba ssiadw';
                end                
		end	
		
        if ~isempty(error_msg)
            beep;
			warndlg(error_msg);
			set(Array_id,'Pointer','arrow');
			set(ACluster_id,'Pointer','arrow');
			return
        end
		
        if size(labels,2)>size(labels,1)
			labels=labels';
        end
		set(findobj(Array_id,'Tag',aorder_tag),'UserData',labels);
       
		if (strcmp(method,'hierarchical')==0 || (strcmp(method,'hierarchical')==1 && get(HierClustersCheck_id,'Value')==1))
			clusters_count=length(unique(labels));
			cnames=cell(clusters_count,1);
			for i=1:clusters_count
				cnames{i}=['Grupa' num2str(i)];
			end
            
			set(findobj(Array_id,'Tag',acnames_tag),'Value',1,'UserData',cnames);
            
            [~,s_avg]=cluster_silhouette(data,labels,dist_metric,0);
            set(QualitySilEdit_id,'String',num2str(s_avg));
		end
		
        set(findobj(Array_id,'Tag','SelectedArrayEdit'),'UserData',0);
		set(findobj(Array_id,'Tag','SelectedGeneEdit'),'UserData',0);
        
		if strcmp(method,'hierarchical')==0 && get(ReorderCheck_id,'Value')==1
            if ctype==SAMPLES
                mstat_cb('array_reorder');
            elseif ctype==FEATURES
                mstat_cb('gene_reorder');
            end
        else
			mstat_cb('do_gui');
			mstat_cb('redraw');
		end
		mstat_cb('do_menu');

		figure(ACluster_id);
		if strcmp(method,'hierarchical')==1
			hnd=findobj(0,'Tag',plot_tag);
			figure(hnd(1));
		end
        
		set(Array_id,'Pointer','arrow');
		set(ACluster_id,'Pointer','arrow');
end
return
