function filter_genes_cb(action);

Array_id=findobj('Tag','ArrayView');
Filter_id=findobj('Tag','FilterArrays');
RadioHnd_id=findobj(Filter_id,'Style','radio');
radios_nr=length(RadioHnd_id);

config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

switch action
	case 'radio'
		CurrentRadio_id=gcbo;
		for i=1:radios_nr
			if (RadioHnd_id(i)~=CurrentRadio_id)
				set(RadioHnd_id(i),'Value',0);
			else
				set(RadioHnd_id(i),'Value',1);
			end;
		end;
		if strcmp(get(gcbo,'Tag'),'PairsRadio')
			set(findobj(gcbf,'Tag','ListButt'),'String','Wczytaj list par');
		else
			set(findobj(gcbf,'Tag','ListButt'),'String','Wczytaj list prbek');
		end;

	case 'load_list'
		list_struct=cell(1,2);
		if get(findobj(gcbf,'Tag','PairsRadio'),'Value')==0
			[fname,path,format]=uigetfile({'*.anm','Nazwy prbek (*.anm)'; '*.*','Wszystkie pliki'},'Otwrz plik',config.open_path);
			list_struct{1}=1;
		else
			[fname,path,format]=uigetfile({'*.prs','Nazwy prbek (*.prs)'; '*.*','Wszystkie pliki'},'Otwrz plik',config.open_path);
			list_struct{1}=2;
		end;
		file=[path,fname];
		if file~=0
			user_list=load_cell(file);
			if ~isempty(user_list) & min(size(user_list))==1
				list_struct{2}=user_list;
				set(Filter_id,'UserData',list_struct);
			end;
		end;

	case 'filter'
		set(Array_id,'Pointer','watch');
		set(Filter_id,'Pointer','watch');
		pause(0.01);

		data=get(Array_id,'UserData');
		image_data=get(findobj(Array_id,'Tag','ArrayAxes'),'UserData');
		anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
		aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
		acnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'UserData');

		for i=1:radios_nr
			if get(RadioHnd_id(i),'Value')==1
				method=radios_nr-i+1;
				break;
			end;
		end;
		
		list_struct=get(Filter_id,'UserData');
		if ~isempty(list_struct) & ((list_struct{1}==1 & method<3) | (list_struct{1}==2 & method==3))
			user_list=list_struct{2};		
			if method==3
				index=reorder_pairs(anames,user_list);
				data=data(:,index);
				image_data=image_data(:,index);
				anames=anames(index);
				aorder=aorder(index);
			else
				list=zeros(1,length(user_list));
				counter=0;
				for i=1:length(user_list)
					for j=1:length(aorder)
						if strcmp(user_list{i},anames{j})
							counter=counter+1;
							list(counter)=j;
							break;
						end;
					end;
				end;
				list(find(list==0))=[];

				if method==1
					data(:,list)=[];
					image_data(:,list)=[];
					anames(list)=[];
					aorder(list)=[];
				else
					data=data(:,list);
					image_data=image_data(:,list);
					anames=anames(list);
					aorder=aorder(list);
				end;
			end;
		else
			beep;
			if method==3
				warndlg('Lista par nie zostaa wczytana','MStat');
			else
				warndlg('Lista prbek nie zostaa wczytana','MStat');
			end;
			set(Array_id,'Pointer','arrow');
			set(Filter_id,'Pointer','arrow');
			return;
		end;

		if isempty(data)
			beep;
			warndlg('Usunite wszystkie prbki','MStat');
			set(Array_id,'Pointer','arrow');
			set(Filter_id,'Pointer','arrow');
			return;
		else
			switch questdlg(sprintf('Liczba prbek po filtacji: %d',size(data,2)),'MStat','Akceptuj','Anuluj','Akceptuj')
				case 'Anuluj'
					set(Array_id,'Pointer','arrow');
					set(Filter_id,'Pointer','arrow');
					return;
				case 'Akceptuj'
					clist=1:length(acnames);
					acnames=acnames(clist(unique(aorder)));
					aorder=reorder_labels(aorder);

					set(Array_id,'UserData',data);
					set(findobj(Array_id,'Tag','ArrayAxes'),'UserData',image_data);
					set(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData',anames);
					set(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData',aorder);
					set(findobj(Array_id,'Tag','ArrayClassPop'),'Value',1,'UserData',acnames);

					mstat_cb('reset_selection');
					mstat_cb('do_gui');
					mstat_cb('prepare_axis');
					mstat_cb('redraw');

					set(Array_id,'Pointer','arrow');
					set(Filter_id,'Pointer','arrow');
					delete(Filter_id);
			end;
		end;
end;
return;

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function index=reorder_pairs(anames,pairs_list);

vectors_count=length(anames);
pairs_count=length(pairs_list);

if mod(pairs_count,2)==0
	
	index=zeros(1,pairs_count);

	for i=1:2:pairs_count
		name1=pairs_list{i};
		name2=pairs_list{i+1};

		index1=0;
		index2=0;
	
		for j=1:vectors_count
			if strcmp(anames{j},name1)
				index1=j;
				break;
			end;
		end;
		for j=1:vectors_count
			if strcmp(anames{j},name2)
				index2=j;
				break;
			end;
		end;

		if index1~=0 & index2~=0
			index(i)=index1;
			index(i+pairs_count)=index2;
%			index(i+1)=index2;
		end;
	end;
	index=index(find(index~=0));
else
	index=[];
end;