function ica();

size_x=230;
size_y=270;

ICA_id=findobj('Tag','ICA');
if isempty(ICA_id)==0
	figure(ICA_id);
else
	Array_id=findobj(0,'Tag','ArrayView');
	config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

	ICA_id=figure('Units','pixels', ...
		'Position',[figpos(Array_id,size_x,size_y) size_x size_y],...
		'Color',config.bg_color, ...
		'Visible','on',...
		'MenuBar','none', ...
		'NumberTitle','off', ...
		'Resize','off',...
		'WindowStyle','modal',...
		'Name','ICA', ...
		'KeyPressFcn',@figure_kb_cb,...				
		'Tag','ICA');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 170 220 95], ...
		'HorizontalAlignment','left', ...
		'Enable','off',...
		'Style','frame', ...
		'Tag','ProcessingFrame');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 253 125 18], ...
		'HorizontalAlignment','left', ...
		'String',' Przetwarzanie wstpne: ', ...
		'Style','text', ...
		'Tag','ProcessingFrameText');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[160 235 60 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(4),...
		'Style','edit', ...
		'Tag','PCEdit');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 233 150 18], ...
		'HorizontalAlignment','left', ...
		'String','Liczba skadowych gwnych:',...
		'Style','text', ...
		'Tag','EnthropyEditText');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 215 130 18], ...
		'String','Centrowanie cech',...
		'Style','checkbox', ...
		'Value',1,...
		'Tag','GeneCenterCheck');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 195 130 18], ...
		'String','Centrowanie prbek',...
		'Style','checkbox', ...
		'Value',0,...
		'Tag','ArrayCenterCheck');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 175 130 18], ...
		'String','Standaryzacja cech',...
		'Style','checkbox', ...
		'Value',0,...
		'Tag','GeneStdCheck');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 105 220 55], ...
		'HorizontalAlignment','left', ...
		'Enable','off',...
		'Style','frame', ...
		'Tag','ICAFrame');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 148 115 18], ...
		'HorizontalAlignment','left', ...
		'String',' Ustawienia algorytmu: ', ...
		'Style','text', ...
		'Tag','ICAFrameText');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 130 130 18], ...
		'String','Stabilizacja',...
		'Style','checkbox', ...
		'Value',1,...
		'Tag','ICAStabilizationCheck');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 110 200 18], ...
		'String','Ustalenie stanu generatora',...
		'Style','checkbox', ...
		'Value',1,...
		'Tag','ICARandGenCheck');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 35 220 60], ...
		'HorizontalAlignment','left', ...
		'Enable','off',...
		'Style','frame', ...
		'Tag','ProfileFrame');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 83 115 18], ...
		'HorizontalAlignment','left', ...
		'String',' Skadowe niezalene: ', ...
		'Style','text', ...
		'Tag','ProfileFrameText');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[160 65 60 20], ...
		'String',{'IC1'}, ...
		'enable','off',...
		'Style','popupmenu',...
		'Value',1, ...
		'Tag','ProfilePop', ...
		'Callback','ica_cb(''pop'')');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 63 100 18], ...
		'HorizontalAlignment','left', ...
		'enable','off',...
		'String','Numer skadowej:',...
		'Style','text', ...
		'Tag','ProfilePopText');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'Position',[10 40 210 20], ...
		'String','Wywietl profil ekspresji', ...
		'enable','off',...
		'Tag','ProfileButt', ...
		'CallBack','ica_cb(''profile'')');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'Position',[5 5 70 25], ...
		'String','Wyznacz', ...
		'Tag','CancelButt', ...
		'Callback','ica_cb(''compute'');');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'Position',[80 5 70 25], ...
		'String','Zapisz', ...
		'enable','off',...
		'Tag','SaveButt', ...
		'Callback','ica_cb(''save'');');

	uicontrol('Parent',ICA_id, ...
		'Units','pixels', ...
		'Position',[155 5 70 25], ...
		'String','Zamknij', ...
		'Tag','CancelButt', ...
		'Callback','delete(gcbf);');
end;

