function normalize_arrays

Array_id=findobj(get(0,'Child'),'Tag','ArrayView');
config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

size_x=260;
size_y=365;
div_string={'redni arytm.','redni arytm. 96%','redni geom.','Median','Sum'};
regress_string={'A*x','A*x+B','LS'};
smooth_string={'lowess','rlowess','loess','rloess','cyclic loess','cyclic rloess','invset loess','invset rloess'};
log_string={'log_2','log_10','log_e','exp_2','exp_10','exp_e'};

selected_gene='';
selected_group='';
selected=get(findobj(Array_id,'Tag','SelectedGeneEdit'),'UserData');
if selected>0
	gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
	gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
	gcnames=get(findobj(Array_id,'Tag','GeneClassPop'),'UserData');
	
	selected_gene=gnames{selected};
	selected_group=gcnames{gorder(selected)};
end;

missing_info=get(findobj(Array_id,'Tag','ValueEdit'),'UserData');
if missing_info(1)==0
	missing_str='on';
else
	missing_str='off';
end;

ANorm_id=findobj('Tag','ANorm');
if isempty(ANorm_id)==0
	figure(ANorm_id);
else
	ANorm_id=figure('Units','pixels', ...
		'Position',[figpos(Array_id,size_x,size_y) size_x size_y],...
		'Color',config.bg_color, ...
		'Visible','on',...
		'MenuBar','none', ...
		'NumberTitle','off', ...
		'Resize','off',...
		'WindowStyle','modal',...
		'Name','Normalizacja prbek', ...
		'KeyPressFcn',@figure_kb_cb,...				
		'Tag','ANorm');

    %Features
    %%%%%%%%%%%%%
    hnd=uipanel('Parent',ANorm_id, ...
		'Title','Dane:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 325 250 40], ...
		'Tag','DataPanel');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 5 100 18], ...
		'String','Zamiana skali: ',...
		'Style','checkbox', ...
		'Value',0,...
		'Tag','LogCheck',...
		'Callback','normalize_arrays_cb(''log_check'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[120 5 120 20], ...
		'String',log_string, ...
		'Style','popupmenu',...
		'Value',5, ...	
		'Enable','off',...
		'Tag','LogPop', ...
		'Callback','');

    %Features
    %%%%%%%%%%%%%
    hnd=uipanel('Parent',ANorm_id, ...
		'Title','Wybr cech:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 205 250 115], ...
		'Tag','FeaturesPanel');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 80 200 18], ...
		'String','Wszystkie cechy w zbiorze danych',...
		'Style','radio', ...
		'Value',1,...
		'Tag','FullRangeRadio',...
		'Callback','normalize_arrays_cb(''radio'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 55 140 18], ...
		'String','Grupa cech',...
		'Style','radio', ...
		'Value',0,...
		'Tag','GroupRangeRadio',...
		'Callback','normalize_arrays_cb(''radio'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[120 55 120 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'String',selected_group, ...
		'Enable','off',...
		'Tag','GroupRangeEdit');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 30 140 18], ...
		'String','Pojedyncza cecha',...
		'Style','radio', ...
		'Value',0,...
		'Tag','SingleRangeRadio',...
		'Callback','normalize_arrays_cb(''radio'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[120 30 120 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'String',selected_gene, ...
		'Enable','off',...
		'Tag','SingleRangeEdit');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 5 100 18], ...
		'String','Lista cech ',...
		'Style','radio', ...
		'Value',0,...
		'Tag','ListRangeRadio',...
		'Callback','normalize_arrays_cb(''radio'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'Position',[120 5 120 20], ...
		'String','Wczytaj list', ...
		'Enable','off',...
		'Tag','ListRangeButt', ...
		'CallBack','normalize_arrays_cb(''load_list'')');

    %Method
    %%%%%%%%%%
    hnd=uipanel('Parent',ANorm_id, ...
		'Title','Metoda normalizacji:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 35 250 165], ...
		'Tag','MethodPanel');

%     bg = uibuttongroup('Parent',ANorm_id, ...
%         'Visible','on',...
%         'Position',[5 35 290 140], ...
%         'SelectionChangeFcn','',...
%         'Tag','MethodGroup');
% 
%     get(bg)
    
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 130 110 18], ...
		'String','Podzielenie przez: ',...
		'Style','radio', ...
		'Value',1,...
		'Tag','DivRadio',...
		'Callback','normalize_arrays_cb(''radio2'')');
   
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[120 130 120 20], ...
		'String',div_string, ...
		'Style','popupmenu',...
		'Value',1, ...	
		'Tag','DivPop', ...
		'Callback','');

  	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[22 105 140 18], ...
		'String','Normalizuj wspczynniki',...
		'Style','checkbox', ...
		'Value',1,...
		'Tag','DivNormCheck',...
		'Callback','');

   	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'Position',[190 105 50 20], ...
		'String','Poka', ...
		'Tag','DivViewButt', ...
		'CallBack','normalize_arrays_cb(''view_coeffs'')');
    
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 80 110 18], ...
		'String','Regresja liniowa:', ...
		'Value',0,...
		'Enable',missing_str,...
		'Style','radio', ...
		'Tag','RegressRadio',...
		'Callback','normalize_arrays_cb(''radio2'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[120 80 120 20], ...
		'String',regress_string, ...
		'Style','popupmenu',...
		'Value',1, ...	
		'Enable','off',...
		'Tag','RegressPop', ...
		'Callback','');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 55 110 18], ...
		'String','Regresja lokalna:', ...
		'Value',0,...
		'Style','radio', ...
		'Tag','SmoothRadio',...
		'Callback','normalize_arrays_cb(''radio2'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[120 55 120 20], ...
		'String',smooth_string, ...
		'Style','popupmenu',...
		'Value',1, ...	
		'Enable','off',...
		'Tag','SmoothPop', ...
		'Callback','');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 30 160 18], ...
		'String','Wyrwnanie kwantyli', ...
		'Value',0,...
		'Enable',missing_str,...
		'Style','radio', ...
		'Tag','QuantileRadio',...
		'Callback','normalize_arrays_cb(''radio2'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 5 160 18], ...
		'String','IRS', ...
		'Value',0,...
		'Enable','on',...
		'Style','radio', ...
		'Tag','IrsRadio',...
		'Callback','normalize_arrays_cb(''radio2'')');
    
                
    %Control
    %%%%%%%%%%%%
	uicontrol('Parent',ANorm_id, ...
		'Units','pixels', ...
		'Position',[180 5 75 25], ...
		'String','Wykonaj', ...
		'Tag','NormalizeButt', ...
		'CallBack','normalize_arrays_cb(''normalize'')');

	uicontrol('Parent',ANorm_id, ...
		'Units','pixels', ...
		'Position',[100 5 75 25], ...
		'String','Zamknij', ...
		'Tag','CancelButt', ...
		'Callback','delete(gcbf);');
end;