function rollup;

size_x=245;
size_y=285;

Rollup_id=findobj('Tag','Rollup');
if isempty(Rollup_id)==0
	figure(Rollup_id);
else
	Array_id=findobj(0,'Tag','ArrayView');
	data=get(Array_id,'UserData');
	config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');
	
	%
	%Config
	%%%%%%%%%%%%%%%%%%%%%%%
	if strcmp(get(gcbo,'Tag'),'RollupFeatures')
		dim=1;
        title='Urednianie cech';
		rollup_string={'Grup cech';'Par cech'};
		method_string={'mean';'median';'max';'r-rollup'};
		method_index=4;
	else
		dim=2;
        title='Urednianie prbek';
		rollup_string={'Klas prbek'};
		method_string={'mean';'median';};
		method_index=2;
	end;
	
    log_base=10;
	min_features=2;
	min_nonmissing=0.3;
	min_overlap=1;
	grubbs_min_values=6;
	grubbs_p_th=0.05;
	rollup_config=struct('dim',dim,'log_base',log_base,'min_features',min_features,'min_nonmissing',min_nonmissing,'method',method_string{method_index},'min_overlap',min_overlap,'grubbs_min_values',grubbs_min_values,'grubbs_p_th',grubbs_p_th);


	Rollup_id=figure('Units','pixels', ...
		'Position',[figpos(Array_id,size_x,size_y) size_x size_y],...
		'Color',config.bg_color, ...
		'Visible','on',...
		'MenuBar','none', ...
		'NumberTitle','off', ...
		'Resize','off',...
		'WindowStyle','modal',...
		'Name',title, ...
		'UserData',rollup_config,...
		'KeyPressFcn',@figure_kb_cb,...
		'Tag','Rollup');

	%Method
	%%%%%%%%%%
	hnd=uipanel('Parent',Rollup_id, ...
		'Title','Dane:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 240 240 45], ...
		'Tag','DataPanel');
		
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 3 105 18], ...
		'HorizontalAlignment','left', ...
		'String','Urednianie:',...
		'Style','text', ...
		'Tag','RollupText');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[125 5 105 20], ...
		'String',rollup_string, ...
		'Style','popupmenu',...
		'Tag','RollupPop', ...
		'Callback','rollup_cb(''pop'')');

	%Settings
	%%%%%%%%%%
	hnd=uipanel('Parent',Rollup_id, ...
		'Title','Ustawienia:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 35 240 205], ...
		'Tag','SettingsPanel');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 163 105 18], ...
		'HorizontalAlignment','left', ...
		'String','Metoda uredniania:',...
		'Style','text', ...
		'Tag','RollupMethodText');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[125 165 105 20], ...
		'String',method_string, ...
		'Value',method_index,...
		'Style','popupmenu',...
		'Tag','RollupMethodPop', ...
		'Callback','rollup_cb(''pop'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 138 155 18], ...
		'HorizontalAlignment','left', ...
		'String','Min. liczba cech w grupie:',...
		'Style','text',...
		'Enable','off',...
		'Tag','RollupMinFeaturesText');
		
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[170 140 60 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'String',num2str(rollup_config.min_features),...
		'UserData',[0 10^6 rollup_config.min_features 0],...
		'Tag','RollupMinFeaturesEdit',...
		'Enable','off',...
		'Callback','edit_cb');
		
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 113 155 18], ...
		'HorizontalAlignment','left', ...
		'String','Min. procent niebrakujcych:',...
		'Style','text', ...
		'Tag','RollupMinNonmissingText');
		
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[170 115 60 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'String',num2str(rollup_config.min_nonmissing),...
		'UserData',[0 1 rollup_config.min_nonmissing 0],...
		'Tag','RollupMinNonmissingEdit',...
		'Callback','edit_cb');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 88 130 18], ...
		'HorizontalAlignment','left', ...
		'String','Min. overlap:',...
		'Style','text', ...
		'Tag','RollupMinOverlapText');
		
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[170 90 60 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'String',num2str(rollup_config.min_overlap),...
		'UserData',[0 size(data,2) rollup_config.min_overlap 0],...
		'Tag','RollupMinOverlapEdit',...
		'Callback','edit_cb');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 63 130 18], ...
		'HorizontalAlignment','left', ...
		'String','Grubbs test min. values:',...
		'Style','text', ...
		'Tag','RollupGrubbsMinValText');
		
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[170 65 60 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'String',num2str(rollup_config.grubbs_min_values),...
		'UserData',[0 Inf rollup_config.grubbs_min_values 0],...
		'Tag','RollupGrubbsMinValEdit',...
		'Callback','edit_cb');

    	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 38 130 18], ...
		'HorizontalAlignment','left', ...
		'String','Grubbs test p-value th:',...
		'Style','text', ...
		'Tag','RollupGrubbsPValThText');
		
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[170 40 60 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'String',num2str(rollup_config.grubbs_p_th),...
		'UserData',[0 1 rollup_config.grubbs_p_th 0],...
		'Tag','RollupGrubbsPValThEdit',...
		'Callback','edit_cb');
    
	%%%%
	uicontrol('Parent',Rollup_id, ...
		'Units','pixels', ...
	   	'Position',[80 5 80 25], ...
		'String','Zamknij', ...
		'Tag','CancelButt', ...
   		'Callback','delete(gcbf)');

	uicontrol('Parent',Rollup_id, ...
		'Units','pixels', ...
	   	'Position',[165 5 80 25], ...
		'String','Wykonaj', ...
		'Tag','Selection1DButt', ...
		'CallBack','rollup_cb(''rollup'')');
	
end;