function sel1D;

size_x=245;
size_y=335;

Sel1D_id=findobj('Tag','Selection1D');
if isempty(Sel1D_id)==0
	figure(Sel1D_id);
else
	Array_id=findobj(0,'Tag','ArrayView');
	genes_count=str2num(get(findobj(Array_id,'Tag','GeneNrEdit'),'String'));
	aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
	acnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'UserData');
	
	config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');
	
	if length(unique(aorder))<=2
		method_string={'ANOVA';'ANOVA2';'Kruskal-Wallis';'Satterthwaite';'Mann-Whitney';'t-test (pary)';'Wilcoxon (pary)';'mattest'};
		default_method=1;
	else
		method_string={'ANOVA';'ANOVA2';'Kruskal-Wallis'};
		default_method=1;
	end;
	idx=find(strcmp(method_string,config.test));
	if ~isempty(idx)
		default_method=idx(1);
	end;
	
	mtest_string={'FDR B&H';'FRD B&H TST';'FDR B&J';'FDR Storey';'FWER Sidak';'FWER Bonferroni';'FWER Holm'};

	fc_method_string={'Arytmetyczna';'Obcita';'Mediana';'Geometryczna'};
	if length(unique(aorder))<=2
		fc_ref_string=acnames;
	else
		fc_ref_string={'jednej z klas','pozostaych klas'};
	end;
	
		Sel1D_id=figure('Units','pixels', ...
		'Position',[figpos(Array_id,size_x,size_y) size_x size_y],...
		'Color',config.bg_color, ...
		'Visible','on',...
		'MenuBar','none', ...
		'NumberTitle','off', ...
		'Resize','off',...
		'WindowStyle','modal',...
		'Name','Selekcja jednowymiarowa', ...
		'KeyPressFcn',@figure_kb_cb,...
		'Tag','Selection1D');

	%Test
	%%%%%%%%%%
	hnd=uipanel('Parent',Sel1D_id, ...
		'Title','Test:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 215 240 120], ...
		'Tag','TestPanel');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 80 105 18], ...
		'String','Statystyka:',...
		'Style','checkbox', ...
		'Value',1,...
		'Tag','MethodCheck',...
		'Callback','sel1D_cb(''check'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[125 80 105 20], ...
		'String',method_string, ...
		'Style','popupmenu',...
		'Value',default_method, ...
		'Tag','MethodPop', ...
		'Callback','sel1D_cb(''pop'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 55 165 18], ...
		'String','Liczba iteracji resamplingu: ', ...
		'Style','checkbox', ...
		'Tag','IterationsCheck',....
		'Callback','sel1D_cb(''check'')');
		
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[170 55 60 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'Enable','off',...
		'String',num2str(1000),...
		'UserData',[1 inf 1000 0],...
		'Tag','IterationsEdit',...
		'Callback','edit_cb');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 30 110 18], ...
		'String','Korekcja p-values:',...
		'Style','checkbox', ...
		'Value',0,...
		'Tag','MTestCheck',...
		'Callback','sel1D_cb(''check'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[125 30 105 20], ...
		'String',mtest_string, ...
		'Style','popupmenu',...
		'Enable','off',...
		'Value',1, ...
		'Tag','MTestPop', ...
		'Callback','');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 5 100 18], ...
		'HorizontalAlignment','left', ...
		'String','Prg istotnoci:', ...
		'Style','checkbox', ...
		'Tag','ThresholdCheck',...
		'Callback','sel1D_cb(''check'')');
		
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[170 5 60 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'Enable','off',...
		'String',num2str(config.pval_thr),...
		'UserData',[0 1 config.pval_thr 0],...
		'Tag','ThresholdEdit',...
		'Callback','edit_cb');

	%FC
	%%%%%%%%%%
	hnd=uipanel('Parent',Sel1D_id, ...
		'Title','FC:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 100 240 115], ...
		'Tag','FCPanel');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[7 80 100 18], ...
		'HorizontalAlignment','left', ...
		'String','Rodzaj redniej:', ...
		'Style','text', ...
		'Tag','FCMethodPopText');
		
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[125 80 105 20], ...
		'String',fc_method_string, ...
		'Style','popupmenu',...
		'Value',1, ...
		'Tag','FCMethodPop', ...
		'Callback','');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[7 55 100 18], ...
		'HorizontalAlignment','left', ...
		'String','Stosunek wobec:', ...
		'Style','text', ...
		'Tag','FCRefPopText');
		
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[125 55 105 20], ...
		'String',fc_ref_string, ...
		'Style','popupmenu',...
		'Value',1, ...
		'Tag','FCRefPop', ...
		'Callback','');

    	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[7 30 100 18], ...
		'HorizontalAlignment','left', ...
		'String','Skala danych:', ...
		'Style','text', ...
		'Tag','FCScalePopText');
		
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[125 30 105 20], ...
		'String',{'liniowa','log_2','log_10','log_e'}, ...
		'Style','popupmenu',...
		'Value',3, ...
		'Tag','FCScalePop', ...
		'Callback','');
    
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 5 180 18], ...
		'String','Min. stosunek rednich:',...
		'Style','checkbox', ...
		'Enable','on',...
		'Value',0,...
		'Tag','FCCheck',...
		'Callback','sel1D_cb(''check'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[170 5 60 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'Enable','off',...
		'String',num2str(config.fc_thr),...
		'UserData',[1 inf config.fc_thr 0],...
		'Tag','FCEdit',...
		'Callback','edit_cb');

    
	%Features
	%%%%%%%%%%
	hnd=uipanel('Parent',Sel1D_id, ...
		'Title','Cechy:', ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 35 240 65], ...
		'Tag','FeaturestPanel');
    
	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 30 180 18], ...
		'String','Maksymalna liczba cech:',...
		'Style','checkbox', ...
		'Value',0,...
		'Tag','FeaturesNrCheck',...
		'Callback','sel1D_cb(''check'')');

	uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[170 30 60 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'String',num2str(genes_count),...
		'UserData',[1 genes_count genes_count 0],...
		'Enable','off',...
		'Tag','FeaturesNrEdit',...
		'Callback','edit_cb');
    
    uicontrol('Parent',hnd, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 5 180 18], ...
		'String','Zachowaj kolejno cech',...
		'Style','checkbox', ...
		'Value',0,...
		'Tag','FeaturesRankCheck',...
		'Callback','sel1D_cb(''check'')');

	%%%%
	uicontrol('Parent',Sel1D_id, ...
		'Units','pixels', ...
		'Position',[5 5 70 25], ...
		'String','Podzia', ...
		'Enable','off',...
		'Tag','OrderButt', ...
		'CallBack','sel1D_cb(''load_order'')');

	uicontrol('Parent',Sel1D_id, ...
		'Units','pixels', ...
	   	'Position',[80 5 80 25], ...
		'String','Zamknij', ...
		'Tag','CancelButt', ...
   		'Callback','delete(gcbf)');

	uicontrol('Parent',Sel1D_id, ...
		'Units','pixels', ...
	   	'Position',[165 5 80 25], ...
		'String','Selekcja', ...
		'Tag','Selection1DButt', ...
   		'CallBack','sel1D_cb(''selection'')');
	
	sel1D_cb('pop');
end;