function sel1D_cb(action)

Array_id=findobj(0,'Tag','ArrayView');
Sel1D_id=findobj(0,'Tag','Selection1D');

StatMethodCheck_id=findobj(Sel1D_id,'Tag','MethodCheck');
StatMethodPop_id=findobj(Sel1D_id,'Tag','MethodPop');
StatMTestCheck_id=findobj(Sel1D_id,'Tag','MTestCheck');
StatMTestPop_id=findobj(Sel1D_id,'Tag','MTestPop');
StatThresholdCheck_id=findobj(Sel1D_id,'Tag','ThresholdCheck');
StatThresholdEdit_id=findobj(Sel1D_id,'Tag','ThresholdEdit');
StatIterationsCheck_id=findobj(Sel1D_id,'Tag','IterationsCheck');
StatIterationsEdit_id=findobj(Sel1D_id,'Tag','IterationsEdit');
StatOrderButt_id=findobj(Sel1D_id,'Tag','OrderButt');

FCThresholdCheck_id=findobj(Sel1D_id,'Tag','FCCheck');
FCThresholdEdit_id=findobj(Sel1D_id,'Tag','FCEdit');
FCMethodPop_id=findobj(Sel1D_id,'Tag','FCMethodPop');
FCRefPop_id=findobj(Sel1D_id,'Tag','FCRefPop');

FeaturesNrCheck_id=findobj(Sel1D_id,'Tag','FeaturesNrCheck');
FeaturesNrEdit_id=findobj(Sel1D_id,'Tag','FeaturesNrEdit');
FeaturesRankEdit_id=findobj(Sel1D_id,'Tag','FeaturesRankCheck');
FCScalePop_id=findobj(Sel1D_id,'Tag','FCScalePop');

method_string={'anova';'anova2';'kw';'satterthwaite';'mann-whitney';'pttest';'pwilcoxon';'mattest'};
mtest_string={'fdr_bh','fdr_bh_tst','fdr_bj','fdr_storey','sidak','bonferroni','holm'};
fc_string={'mean';'trimmed';'median';'gmean'};

config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

switch action
	case 'check'
		switch gcbo
			case StatMethodCheck_id
				set(StatMethodPop_id,'Enable','off');
				set(StatMTestCheck_id,'Enable','off');
				set(StatMTestPop_id,'Enable','off');
				set(StatThresholdCheck_id,'Enable','off');
				set(StatThresholdEdit_id,'Enable','off');			
				if get(StatMethodCheck_id,'Value')==1
					set(StatMethodPop_id,'Enable','on');
					set(StatMTestCheck_id,'Enable','on');
					if get(StatMTestCheck_id,'Value')==1
						set(StatMTestPop_id,'Enable','on');
					end;
					set(StatThresholdCheck_id,'Enable','on');
					if get(StatThresholdCheck_id,'Value')==1
						set(StatThresholdEdit_id,'Enable','on');
					end;
				end;
				sel1D_cb('pop');

			case StatIterationsCheck_id
                if get(StatIterationsCheck_id,'Value')==1
					set(StatIterationsEdit_id,'Enable','on');					
				else
					set(StatIterationsEdit_id,'Enable','off');
                end;	
				
			case StatMTestCheck_id
				if get(StatMTestCheck_id,'Value')==1
					set(StatMTestPop_id,'Enable','on');
				else
					set(StatMTestPop_id,'Enable','off');
				end;

			case StatThresholdCheck_id
                if get(StatThresholdCheck_id,'Value')==1
					set(StatThresholdEdit_id,'Enable','on');
				else
					set(StatThresholdEdit_id,'Enable','off');
                end;	
				
			case FCThresholdCheck_id
				if get(FCThresholdCheck_id,'Value')==1
					set(FCThresholdEdit_id,'Enable','on');
				else
					set(FCThresholdEdit_id,'Enable','off');
				end;
				
			case FeaturesNrCheck_id
				if get(FeaturesNrCheck_id,'Value')==1
					set(FeaturesNrEdit_id,'Enable','on');
				else
					set(FeaturesNrEdit_id,'Enable','off');
				end;
            case FeaturesRankEdit_id    
                if get(FeaturesRankEdit_id,'Value')==1
                    set(FeaturesNrCheck_id,'Enable','off');
                    set(FeaturesNrEdit_id,'Enable','off');
                else 
                    set(FeaturesNrCheck_id,'Enable','on');
                    if get(FeaturesNrCheck_id,'Value')==1
    					set(FeaturesNrEdit_id,'Enable','on');
                    else
                        set(FeaturesNrEdit_id,'Enable','off');
                    end;
                        
                end; 
		end;

	case 'pop'
		set(StatIterationsCheck_id,'Enable','off');
		set(StatIterationsCheck_id,'Value',0);		
		set(StatIterationsEdit_id,'Enable','off');
		set(StatOrderButt_id,'Enable','off');
		
		method=method_string{get(StatMethodPop_id,'Value')};
		if (strcmp(method,'anova') || strcmp(method,'anova2') || strcmp(method,'satterthwaite') || strcmp(method,'pttest'))
			set(StatIterationsCheck_id,'Enable','on');		
			if (get(StatIterationsCheck_id,'Value')==1)
				set(StatIterationsEdit_id,'Enable','on');
			end;
			if (strcmp(method,'anova2'))
				set(StatOrderButt_id,'Enable','on');
			end;
		elseif (strcmp(method,'mattest'))
			set(StatIterationsCheck_id,'Value',1);			
			set(StatIterationsEdit_id,'Enable','on');
		end;
		
	case 'load_order'
		[fname,path,format]=uigetfile({'*.ads','Plik ADS (*.ads)';'*.acl','Plik ACL (*.acl)'},'Otwrz plik',config.open_path);
		if fname~=0
			anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
			data=get(Array_id,'UserData');
			vectors_count=size(data,2);
			aorder=[];
			
			if format==0
				records=load_cell2([path fname]);
				records_count=length(records);

				if records_count>=vectors_count
					names=cell(records_count,1);
					order=zeros(records_count,1);
					empty_list=ones(records_count,1);
					for i=1:records_count
						record=records{i};
						if length(record)>=2
							names{i}=record{1};
							order(i)=str2num(record{2});
							empty_list(i)=0;
						end;
					end;
					names(find(empty_list==1))=[];
					order(find(empty_list==1))=[];

					index=name2index(anames,names);
					aorder=order(index);
				end;
			else
				[new_anames,ids,column]=load_description([path fname]);
				
				if column<1
					beep;
					if column==0
						warndlg('Brak podziau na klasy','MStat');
					end;
					return;
				end;
	
				index=name2index(anames,new_anames);
				
				if length(index)==vectors_count
					ids=ids(index);
					
					[b,index]=unique(ids,'first');
					acnames=ids(sort(index))';
					
					%zamienic na cos madrzejszego niz przeszukiwanie liniowe
					aorder=zeros(vectors_count,1);
					for i=1:length(ids)
						for j=1:length(acnames)
							if strcmp(acnames{j},ids{i})==1
								aorder(i)=j;
								break;
							end;
						end;
					end;
				end;
			end;
			
			if isempty(aorder)
				beep;
				warndlg('Liczba etykiet mniejsza od liczby prbek','MStat');
			elseif length(aorder)==vectors_count
				aorder=reorder_labels(aorder);
				set(Sel1D_id,'UserData',aorder);
			else
				beep;
				warndlg('Nie znaleziono etykiet dla wszystkich prbek','MStat');
			end;
		end;

	case 'selection'
		set(Sel1D_id,'Pointer','watch');
		set(Array_id,'Pointer','watch');
		pause(0.01);

		data=get(Array_id,'UserData');
		image_data=get(findobj(Array_id,'Tag','ArrayAxes'),'UserData');
		gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
		gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
		glist=get(findobj(Array_id,'Tag','DatasetPanel'),'UserData');
		gcnames=get(findobj(Array_id,'Tag','GeneClassPop'),'UserData');
		aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
		stat_struct=get(findobj(Array_id,'Tag','Select1D'),'UserData');		
		class_count=max(aorder);

		selected=1:str2num(get(findobj(Array_id,'Tag','GeneNrEdit'),'String'));

		fc=[];
		p=[];
		f=[];

		if get(StatMethodCheck_id,'Value')==1
			method=method_string{get(StatMethodPop_id,'Value')};
			
			if (get(StatIterationsCheck_id,'Value')==1 || strcmp(method,'matest')==1)
				iterations=str2num(get(StatIterationsEdit_id,'String'));
			else
				iterations=0;
			end;
			
			if (strcmp(method,'pttest'))
				if (mod(size(data,2),2)~=0)		
					warndlg('Prbki nie s sparowane','MStat');
					set(Sel1D_id,'Pointer','arrow');
					pause(0.01);
					return;
				end;
			elseif strcmp(method,'anova2')
				aorder2=get(Sel1D_id,'UserData');
				if isempty(aorder2)
					beep;
					warndlg('Drugi podzia prbek nie zosta wczytany','MStat');
					set(Sel1D_id,'Pointer','arrow');
					pause(0.01);
					return;
				end;
				aorder=[aorder,aorder2];
			end;

			if get(StatMTestCheck_id,'Value')==1
				adjust_method=mtest_string{get(StatMTestPop_id,'Value')};
			else
				adjust_method='max_pval';
			end;

			if get(StatThresholdCheck_id,'Value')==1
				threshold=str2num(get(StatThresholdEdit_id,'String'));
			else
				threshold=1;
			end;
			
			pn=1;
			[p,f,index]=selection1D(data,aorder,method,adjust_method,threshold,iterations,pn);
            if get(FeaturesRankEdit_id,'Value')==1
                [s,idx]=sort(index);
                index=s;
                p=p(idx);
                f=f(idx);
            end;
            
			data=data(index,:);
			selected=selected(index);
			aorder=aorder(:,1);
		end;

		if ~isempty(selected)
%             switch questdlg('Czy wartoci s zlogarytmowane?','MStat','Tak','Nie','Anuluj','Tak')
% 				case 'Tak'
% 					switch questdlg('Podaj podstaw logarytmu','MStat','log_2','log_10','log_e','log_2')
% 						case 'log_2'
% 							logbase=2;
% 						case 'log_10'
% 							logbase=10;
% 						case 'log_e'
% 							logbase=exp(1);
% 						otherwise
% 							set(Sel1D_id,'Pointer','arrow');
% 							return;
% 					end;
% 				case'Nie'
% 					logbase=0;
% 				otherwise
% 					set(Sel1D_id,'Pointer','arrow');
% 					pause(0.01);
% 					return;
% 			end;
            
			logbase=0;
			switch get(FCScalePop_id,'Value')
                case 2
                    logbase=2;
				case 3
					logbase=10;
				case 4
					logbase=exp(1);
			end;
            
			sel_data=data;
			if logbase~=0
				sel_data=logbase.^sel_data;
			end;
			
			if get(FCThresholdCheck_id,'Value')==1
				threshold=str2num(get(FCThresholdEdit_id,'String'));
			else
				threshold=1;
			end;
			
			[fc,index]=selection1D_fc(sel_data,aorder,fc_string{get(FCMethodPop_id,'Value')},get(FCRefPop_id,'Value'),threshold);
			data=data(index,:);
			selected=selected(index);
			if ~isempty(p)
				p=p(index);
				f=f(index);
			end;
		end;

		if get(FeaturesNrCheck_id,'Value')==1 && ~isempty(selected)
			index=1:min(str2num(get(FeaturesNrEdit_id,'String')),size(data,1));
			data=data(index,:);
			selected=selected(index);
			if ~isempty(p)
				f=f(index);
				p=p(index);
			end;
			if ~isempty(fc)
				fc=fc(index);
			end;
		end;

		if isempty(selected)
			beep;
			warndlg('Nie ma cech speniajcych warunki','MStat');
			set(Sel1D_id,'Pointer','arrow');
			pause(0.01);
			return;
		else
			if ~isempty(p)
				msg_str=sprintf('Liczba cech speniajcych warunki: %d \n(max p-value=%0.5g, FDR=%0.5g)',length(selected),p(end),max(f));
			else
				msg_str=sprintf('Liczba cech speniajcych warunki: %d',length(selected));
			end;
			switch questdlg(msg_str,'MStat','OK','Cofnij','OK')
				case 'Cofnij'
					set(Sel1D_id,'Pointer','arrow');
					set(Array_id,'Pointer','arrow');
					return;
				case 'OK'
					image_data=image_data(selected,:);
					gnames=gnames(selected);
					gorder=gorder(selected);
					glist=glist(selected);
					stat_struct.n=stat_struct.n(selected);
					
					%uprzadkowanie nazw grup i podziau genow
					clist=1:length(gcnames);
					gcnames=gcnames(clist(unique(gorder)));
					gorder=reorder_labels(gorder);

					%utworzenie stat_struct
					if get(StatMethodCheck_id,'Value')==1
						test_str=get(StatMethodPop_id,'String');
						stat_struct.test=test_str{get(StatMethodPop_id,'Value')};
					else
						stat_struct.test='None';
					end;
					if ~isempty(p)
						stat_struct.pval=p;
						stat_struct.fdr=f;
					else
						stat_struct.pval=NaN*ones(size(data,1),1);
						stat_struct.fdr=NaN*ones(size(data,1),1);
					end;
					if ~isempty(fc)
						stat_struct.fc=fc;
					else
						stat_struct.fc=NaN*ones(size(data,1),1);
					end;

					%zwrocenie wynikow
					set(Array_id,'UserData',data);
					set(findobj(Array_id,'Tag','ArrayAxes'),'UserData',image_data);
					set(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData',gnames);
					set(findobj(Array_id,'Tag','GeneClassAxes'),'UserData',gorder);
					set(findobj(Array_id,'Tag','DatasetPanel'),'UserData',glist);
					set(findobj(Array_id,'Tag','GeneClassPop'),'Value',1,'UserData',gcnames);
					set(findobj(Array_id,'Tag','Select1D'),'UserData',stat_struct);

					mstat_cb('reset_selection');
					mstat_cb('do_gui');
					mstat_cb('prepare_axis');
					mstat_cb('redraw');

					%aktualizacja tabel
					GeneTable_id=findobj('Tag','GeneTable');
					if ~isempty(GeneTable_id)
						genes_table('create')
					end;
					ValueTable_id=findobj('Tag','ValueTable');
					if ~isempty(ValueTable_id)
						values_table('create')
					end;
					GroupTable_id=findobj('Tag','GroupTable');
					if ~isempty(GroupTable_id)
						groups_table('create')
					end;

					set(Sel1D_id,'Pointer','arrow');
					set(Array_id,'Pointer','arrow');
					pause(0.01);
					
					delete(Sel1D_id);
			end;
		end;
end;
