function sel1D_corr;

size_x=245;
size_y=285;

Sel1DCorr_id=findobj('Tag','Selection1D_corr');
if isempty(Sel1DCorr_id)==0
	figure(Sel1DCorr_id);
else
	Array_id=findobj(0,'Tag','ArrayView');
	config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

	genes_count=str2num(get(findobj(Array_id,'Tag','GeneNrEdit'),'String'));
	aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');

	method_string={'Pearson';'Spearman'};
	mtest_string={'FDR B&H';'FRD B&H TST';'FDR B&J';'FDR Storey';'FWER Sidak';'FWER Bonferroni';'FWER Holm';'Bez korekcji';'Korelacja'};
	sort_string={'Dodatnie';'Ujemne';'Wszystkie';};
	log_string={'lin','log_2','log_10','log_e','exp_2','exp_10','exp_e'};

	Sel1DCorr_id=figure('Units','pixels', ...
		'Position',[figpos(Array_id,size_x,size_y) size_x size_y],...
		'Color',config.bg_color, ...
		'Visible','on',...
		'MenuBar','none', ...
		'NumberTitle','off', ...
		'Resize','off',...
		'WindowStyle','modal',...
		'Name','Selekcja korelacyjna', ...
		'KeyPressFcn',@figure_kb_cb,...				
		'Tag','Selection1D_corr');
		
	uicontrol('Parent',Sel1DCorr_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 35 240 240], ...
		'HorizontalAlignment','left', ...
		'Enable','off',...
		'Style','frame', ...
		'Tag','Selection1DFrame');

	uicontrol('Parent',Sel1DCorr_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 265 60 18], ...
		'HorizontalAlignment','left', ...
		'String',' Parametry: ', ...
		'Style','text', ...
		'Tag','Selection1DText');

	uicontrol('Parent',Sel1DCorr_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 243 120 18], ...
		'HorizontalAlignment','left', ...
		'String',' Wspczynnik korelacji: ', ...
		'Style','text', ...
		'Tag','MethodText');

	uicontrol('Parent',Sel1DCorr_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[130 245 105 20], ...
		'String',method_string, ...
		'Style','popupmenu',...
		'Value',1, ...
		'Tag','MethodPop', ...
		'Callback','');

	uicontrol('Parent',Sel1DCorr_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 195 110 18], ...
		'String','Korekcja p-values:',...
		'Style','checkbox', ...
		'Value',0,...
		'Tag','MTestCheck',...
		'Callback','sel1D_corr_cb(''check'')');

	uicontrol('Parent',Sel1DCorr_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[130 195 105 20], ...
		'String',mtest_string, ...
		'Style','popupmenu',...
		'Enable','off',...
		'Value',1, ...
		'Tag','MTestPop', ...
		'Callback','sel1D_corr_cb(''pop'')');

	uicontrol('Parent',Sel1DCorr_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[175 170 60 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'Enable','off',...
		'String',num2str(0.05),...
		'UserData',[0 1 0.05 0],...
		'Tag','ThresholdEdit',...
		'Callback','sel1D_corr_cb(''edit'')');

	uicontrol('Parent',Sel1DCorr_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[30 170 100 18], ...
		'HorizontalAlignment','left', ...
		'String','Prg istotnoci:', ...
		'Enable','off',...
		'Style','text', ...
		'Tag','ThresholdEditText');

	uicontrol('Parent',Sel1DCorr_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 145 180 18], ...
		'String','Uporzdkowanie:',...
		'Style','checkbox', ...
		'Enable','on',...
		'Value',0,...
		'Tag','FCCheck',...
		'Callback','sel1D_corr_cb(''check'')');

	uicontrol('Parent',Sel1DCorr_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[130 145 105 20], ...
		'String',sort_string, ...
		'Style','popupmenu',...
		'Enable','off',...
		'Value',1, ...
		'Tag','FCPop', ...
		'Callback','');

	uicontrol('Parent',Sel1DCorr_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 120 180 18], ...
		'String','Maksymalna liczba cech:',...
		'Style','checkbox', ...
		'Value',0,...
		'Tag','FeaturesNrCheck',...
		'Callback','sel1D_corr_cb(''check'')');

	uicontrol('Parent',Sel1DCorr_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[175 120 60 20], ...
		'HorizontalAlignment','right', ...
		'Style','edit', ...
		'String',num2str(genes_count),...
		'UserData',[1 genes_count genes_count 0],...
		'Enable','off',...
		'Tag','FeaturesNrEdit',...
		'Callback','sel1D_corr_cb(''edit'')');

	uicontrol('Parent',Sel1DCorr_id, ...
		'Units','pixels', ...
	   	'Position',[10 70 110 20], ...
		'String','Wczytaj wartoci', ...
		'Enable','on',...
		'Tag','OrderButt', ...
   		'CallBack','sel1D_corr_cb(''load_order'')');

	uicontrol('Parent',Sel1DCorr_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[130 70 105 20], ...
		'String',log_string, ...
		'Style','popupmenu',...
		'Value',1, ...	
		'Enable','on',...
		'Tag','LogPop', ...
		'Callback','');

	uicontrol('Parent',Sel1DCorr_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 45 200 18], ...
		'String','Uporzdkuj zgodnie z wartociami',...
		'Style','checkbox', ...
		'Value',0,...
		'Tag','OrderCheck',...
		'Callback','');

	uicontrol('Parent',Sel1DCorr_id, ...
		'Units','pixels', ...
	   	'Position',[80 5 80 25], ...
		'String','Zamknij', ...
		'Tag','CancelButt', ...
   		'Callback','delete(gcbf)');

	uicontrol('Parent',Sel1DCorr_id, ...
		'Units','pixels', ...
	   	'Position',[165 5 80 25], ...
		'String','Selekcja', ...
		'Tag','Selection1DButt', ...
   		'CallBack','sel1D_corr_cb(''selection'')');
end;