function svdec_cb(action);

Array_id=findobj(0,'Tag','ArrayView');
Sel1DICA_id=findobj(0,'Tag','Selection1D_ica');

PCEdit_id=findobj(Sel1DICA_id,'Tag','PCEdit');
GeneCenterCheck_id=findobj(Sel1DICA_id,'Tag','GeneCenterCheck');
ArrayCenterCheck_id=findobj(Sel1DICA_id,'Tag','ArrayCenterCheck');
GeneStdCheck_id=findobj(Sel1DICA_id,'Tag','GeneStdCheck');

ProfilePop_id=findobj(Sel1DICA_id,'Tag','ProfilePop');
ProfilePopText_id=findobj(Sel1DICA_id,'Tag','ProfilePopText');

ICAStabilizationCheck_id=findobj(Sel1DICA_id,'Tag','ICAStabilizationCheck');
ICARandGenCheck_id=findobj(Sel1DICA_id,'Tag','ICARandGenCheck');

ThresholdEdit_id=findobj(Sel1DICA_id,'Tag','ThresholdEdit');
ThresholdEditText_id=findobj(Sel1DICA_id,'Tag','ThresholdEditText');

Selection1DButt_id=findobj(Sel1DICA_id,'Tag','Selection1DButt');

switch action
	case 'edit'
		Edit_id=gcbo;
		num=str2num(get(Edit_id,'String'));
		limits=get(Edit_id,'UserData');

		if isempty(num)==1
			num=limits(3);
			beep;
		else
			switch limits(4)
				case 0
					if num<limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
				case 1
					if num<=limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 2
					if num<limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 3
					if num<=limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
			end;
		end;
		set(Edit_id,'String',num2str(num));

	case 'update_gui'
		data_struct=get(Sel1DICA_id,'UserData');

		if ~isempty(data_struct.v)
			components_count=size(data_struct.v,2);

			eigengene_string=cell(1,components_count);
			for i=1:components_count
				eigengene_string{i}=['IC' num2str(i)];
			end;
			set(ProfilePop_id,'Value',1,'String',eigengene_string,'Enable','on');
			set(ProfilePopText_id,'Enable','on');
			set(ThresholdEdit_id,'Enable','on');
			set(ThresholdEditText_id,'Enable','on');
			set(Selection1DButt_id,'Enable','on');
		end;


	case 'compute'
		set(Array_id,'Pointer','watch');
		set(Sel1DICA_id,'Pointer','watch');
		pause(0.01);

		data=get(Array_id,'UserData');

		if get(ArrayCenterCheck_id,'Value')==1
			data=data_center(data')';
		end;
		if get(GeneCenterCheck_id,'Value')==1
			data=data_center(data);
		end;
		if get(GeneStdCheck_id,'Value')==1
			data=data_normalize(data);
		end;
		eigenvectors_count=str2num(get(PCEdit_id,'String'));
		if eigenvectors_count>0
			[data,u,s,v]=data_denoise(data,eigenvectors_count);
		end;

		if get(ICAStabilizationCheck_id,'Value')==1
			ica_stabilization='on';
		else
			ica_stabilization='off';
		end;

		if get(ICARandGenCheck_id,'Value')==1
			rand('state',123);
			randn('state',123);
		end;

		retry=1;
		while retry==1
			[data_struct.v,data_struct.a,data_struct.w]=fastica(data,'stabilization',ica_stabilization);
			data_struct.v=data_struct.v';
			retry=0;
			if size(data_struct.v,2)<eigenvectors_count
				msg_str=sprintf('Nie byo moliwe wyznaczenie wszystkich skadowych.\nPonowi prb?');
				if strcmp(questdlg(msg_str,'MStat','Tak','Nie','Tak'),'Tak')==1
					retry=1;
				end;
			end;
		end;

		set(Sel1DICA_id,'UserData',data_struct);

		set(Array_id,'Pointer','arrow');
		set(Sel1DICA_id,'Pointer','arrow');
		
		sel1D_ica_cb('update_gui');

	case 'selection'
		set(Array_id,'Pointer','watch');
		set(Sel1DICA_id,'Pointer','watch');
		pause(0.01);

		data=get(Array_id,'UserData');
		image_data=get(findobj(Array_id,'Tag','ArrayAxes'),'UserData');
		gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
		gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
		glist=get(findobj(Array_id,'Tag','DatasetPanel'),'UserData');
		gcnames=get(findobj(Array_id,'Tag','GeneClassPop'),'UserData');
		stat_struct=get(findobj(Array_id,'Tag','Select1D'),'UserData');	

		selected=1:str2num(get(findobj(Array_id,'Tag','GeneNrEdit'),'String'));

		component_nr=get(ProfilePop_id,'Value');
		threshold=str2num(get(ThresholdEdit_id,'String'));

		fc=[];
		p=[];
		f=[];

		data_struct=get(Sel1DICA_id,'UserData');

		[c,index]=selection1D_ica(data_struct.w,component_nr,threshold);

		data=data(index,:);
		selected=selected(index);

		if isempty(selected)
			beep;
			warndlg('Nie ma cech speniajcych warunki','MStat');
			set(Sel1DICA_id,'Pointer','arrow');
			set(Array_id,'Pointer','arrow');
			return;
		else
			msg_str=sprintf('Liczba cech speniajcych warunki: %d \n(min u=%0.5g)',length(selected),c(end));

			switch questdlg(msg_str,'MStat','OK','Cofnij','OK')
				case 'Cofnij'
					set(Sel1DICA_id,'Pointer','arrow');
					set(Array_id,'Pointer','arrow');
					return;
				case 'OK'
					image_data=image_data(selected,:);
					gnames=gnames(selected);
					gorder=gorder(selected);
					glist=glist(selected);
				
					%uprzadkowanie nazw grup i podziau genow
					clist=1:length(gcnames);
					gcnames=gcnames(clist(unique(gorder)));
					gorder=reorder_labels(gorder);

					%utworzenie stat_struct
					stat_struct.test='ICA';
					stat_struct.pval=c;
					stat_struct.fdr=NaN*ones(size(data,1),1);
					stat_struct.fc=NaN*ones(size(data,1),1);
					stat_struct.n=stat_struct.n(selected);
					
					%zwrocenie wynikow
					set(Array_id,'UserData',data);
					set(findobj(Array_id,'Tag','ArrayAxes'),'UserData',image_data);
					set(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData',gnames);
					set(findobj(Array_id,'Tag','GeneClassAxes'),'UserData',gorder);
					set(findobj(Array_id,'Tag','DatasetPanel'),'UserData',glist);
					set(findobj(Array_id,'Tag','GeneClassPop'),'Value',1,'UserData',gcnames);
					set(findobj(Array_id,'Tag','Select1D'),'UserData',stat_struct);

					mstat_cb('reset_selection');
					mstat_cb('do_gui');
					mstat_cb('prepare_axis');
					mstat_cb('redraw');

					%aktualizacja tabel
					GeneTable_id=findobj('Tag','GeneTable');
					if ~isempty(GeneTable_id)
						genes_table('create')
					end;
					ValueTable_id=findobj('Tag','ValueTable');
					if ~isempty(ValueTable_id)
						values_table('create')
					end;
					GroupTable_id=findobj('Tag','GroupTable');
					if ~isempty(GroupTable_id)
						groups_table('create')
					end;

					set(Sel1DICA_id,'Pointer','arrow');
					set(Array_id,'Pointer','arrow');
					delete(Sel1DICA_id);
			end;
		end;
end;
