function sel1D_svd_cb(action);

Array_id=findobj(0,'Tag','ArrayView');
Sel1DSvd_id=findobj(0,'Tag','Selection1D_svd');

GeneCenterCheck_id=findobj(Sel1DSvd_id,'Tag','GeneCenterCheck');
ArrayCenterCheck_id=findobj(Sel1DSvd_id,'Tag','ArrayCenterCheck');
GeneStdCheck_id=findobj(Sel1DSvd_id,'Tag','GeneStdCheck');

EigengenePop_id=findobj(Sel1DSvd_id,'Tag','EigengenePop');
ThresholdEdit_id=findobj(Sel1DSvd_id,'Tag','ThresholdEdit');
ThresholdEditText_id=findobj(Sel1DSvd_id,'Tag','ThresholdEditText');

switch action
	case 'edit'
		Edit_id=gcbo;
		num=str2num(get(Edit_id,'String'));
		limits=get(Edit_id,'UserData');

		if isempty(num)==1
			num=limits(3);
			beep;
		else
			switch limits(4)
				case 0
					if num<limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
				case 1
					if num<=limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 2
					if num<limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 3
					if num<=limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
			end;
		end;
		set(Edit_id,'String',num2str(num));

	case 'save'
		[fname,path]=uiputfile({'*.txt';'*.*'},'Zapisz do pliku');
		if fname~=0
			if isempty(strfind(fname,'.txt'))
				fname=[fname '.txt'];
			end;

			set(Sel1DSvd_id,'Pointer','watch');
			set(Array_id,'Pointer','watch');
			pause(0.01);

			data=get(Array_id,'UserData');
			gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');

			eigengene_nr=get(EigengenePop_id,'Value');
			threshold=str2num(get(ThresholdEdit_id,'String'));

			sel_data=data;
			if get(ArrayCenterCheck_id,'Value')==1
				sel_data=data_center(sel_data')';
			end;
			if get(GeneCenterCheck_id,'Value')==1
				sel_data=data_center(sel_data);
			end;
			if get(ArrayCenterCheck_id,'Value')==1 & get(GeneCenterCheck_id,'Value')==1
				sel_data=sel_data-mean(sel_data(:));
			end;

			if get(GeneStdCheck_id,'Value')==1
				sel_data=data_normalize(sel_data);
			end;
			[c,index,ck]=selection1D_svd(sel_data,eigengene_nr,threshold);

			if get(ArrayCenterCheck_id,'Value')==1
				ck=ck(:,1:end-1);
			end;

			dataset.data=100*ck;
			dataset.name='Eigengene';
			dataset.column_names=cell(size(ck,2),1);
			for i=1:length(dataset.column_names)
				dataset.column_names{i}=num2str(i);
			end;
			dataset.column_classes=ones(size(ck,2),1);
			dataset.class_names=cell(1);
			dataset.class_names{1}='Ta linia nic nie znaczy';
			dataset.row_names=gnames;
			save_table(dataset,fname);

			set(Sel1DSvd_id,'Pointer','arrow');
			set(Array_id,'Pointer','arrow');
		end;

	case 'selection'
		set(Sel1DSvd_id,'Pointer','watch');
		set(Array_id,'Pointer','watch');
		pause(0.01);

		data=get(Array_id,'UserData');
		image_data=get(findobj(Array_id,'Tag','ArrayAxes'),'UserData');
		gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
		gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
		glist=get(findobj(Array_id,'Tag','DatasetPanel'),'UserData');
		gcnames=get(findobj(Array_id,'Tag','GeneClassPop'),'UserData');
		stat_struct=get(findobj(Array_id,'Tag','Select1D'),'UserData');	
		
		selected=1:str2num(get(findobj(Array_id,'Tag','GeneNrEdit'),'String'));

		eigengene_nr=get(EigengenePop_id,'Value');
		threshold=str2num(get(ThresholdEdit_id,'String'));

		fc=[];
		p=[];
		f=[];

		sel_data=data;
		if get(ArrayCenterCheck_id,'Value')==1
			sel_data=data_center(sel_data')';
		end;
		if get(GeneCenterCheck_id,'Value')==1
			sel_data=data_center(sel_data);
		end;
		if get(GeneStdCheck_id,'Value')==1
			sel_data=data_normalize(sel_data);
		end;
		[c,index]=selection1D_svd(sel_data,eigengene_nr,threshold);

		data=data(index,:);
		selected=selected(index);

		if isempty(selected)
			beep;
			warndlg('Nie ma cech speniajcych warunki','MStat');
			set(Sel1DSvd_id,'Pointer','arrow');
			set(Array_id,'Pointer','arrow');
			return;
		else
			msg_str=sprintf('Liczba cech speniajcych warunki: %d \n(min u=%0.5g)',length(selected),c(end));


			switch questdlg(msg_str,'MStat','OK','Cofnij','OK')
				case 'Cofnij'
					set(Sel1DSvd_id,'Pointer','arrow');
					set(Array_id,'Pointer','arrow');
					return;
				case 'OK'
					image_data=image_data(selected,:);
					gnames=gnames(selected);
					gorder=gorder(selected);
					glist=glist(selected);

					%uprzadkowanie nazw grup i podziau genow
					clist=1:length(gcnames);
					gcnames=gcnames(clist(unique(gorder)));
					gorder=reorder_labels(gorder);

					%utworzenie stat_struct
					stat_struct.test='SVD';
					stat_struct.pval=c;
					stat_struct.fdr=NaN*ones(size(data,1),1);
					stat_struct.fc=NaN*ones(size(data,1),1);
					stat_struct.n=stat_struct.n(selected);
					
					%zwrocenie wynikow
					set(Array_id,'UserData',data);
					set(findobj(Array_id,'Tag','ArrayAxes'),'UserData',image_data);
					set(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData',gnames);
					set(findobj(Array_id,'Tag','GeneClassAxes'),'UserData',gorder);
					set(findobj(Array_id,'Tag','DatasetPanel'),'UserData',glist);
					set(findobj(Array_id,'Tag','GeneClassPop'),'Value',1,'UserData',gcnames);
					set(findobj(Array_id,'Tag','Select1D'),'UserData',stat_struct);

					mstat_cb('reset_selection');
					mstat_cb('do_gui');
					mstat_cb('prepare_axis');
					mstat_cb('redraw');

					%aktualizacja tabel
					GeneTable_id=findobj('Tag','GeneTable');
					if ~isempty(GeneTable_id)
						genes_table('create')
					end;
					ValueTable_id=findobj('Tag','ValueTable');
					if ~isempty(ValueTable_id)
						values_table('create')
					end;
					GroupTable_id=findobj('Tag','GroupTable');
					if ~isempty(GroupTable_id)
						groups_table('create')
					end;

					set(Sel1DSvd_id,'Pointer','arrow');
					set(Array_id,'Pointer','arrow');

					delete(Sel1DSvd_id);
			end;
		end;
end;
