function sel_cb(action);

Array_id=findobj(0,'Tag','ArrayView');
Sel_id=findobj(0,'Tag','Selection');
MethodPop_id=findobj(Sel_id,'Tag','MethodPop');
FeaturesNrEdit_id=findobj(Sel_id,'Tag','FeaturesNrEdit');
ReductionCheck_id=findobj(Sel_id,'Tag','ReductionCheck');
MinDiffCheck_id=findobj(Sel_id,'Tag','MinDiffCheck');
MinDiffEdit_id=findobj(Sel_id,'Tag','MinDiffEdit');

aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
class_count=max(aorder);
arrays_count=str2num(get(findobj(Array_id,'Tag','ArrayNrEdit'),'String'));
genes_count=str2num(get(findobj(Array_id,'Tag','GeneNrEdit'),'String'));
zoom=get(findobj(Array_id,'Label','&Widok'),'UserData');

switch action
	case 'pop'
		switch get(MethodPop_id,'Value')
			case 1
				set(ReductionCheck_id,'Enable','off');
				set(FeaturesNrEdit_id,'String',num2str(genes_count));
			case 2
				set(ReductionCheck_id,'Enable','on');
				set(FeaturesNrEdit_id,'String',num2str(min(genes_count,arrays_count-class_count-2)));
			end;

	case 'selection'
		set(Sel_id,'Pointer','watch');
		pause(0.01);

		data=get(Array_id,'UserData');
		aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
		stat_struct=get(findobj(Array_id,'Tag','Select1D'),'UserData');	

		features_nr=str2num(get(FeaturesNrEdit_id,'String'));
		method=get(MethodPop_id,'Value');
		switch method
			case 1
				if (length(unique(aorder))==2)
					aorder(find(aorder==min(aorder)))=-1;
					aorder(find(aorder==max(aorder)))=1;
				end;
				selected=rfe(mapminmax(data,0,1),aorder,features_nr);
			case 2
				selected=anova_u(data,aorder,features_nr);
		end;
		gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
		gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
		glist=get(findobj(Array_id,'Tag','DatasetPanel'),'UserData');

		data=data(selected,:);
		gnames=gnames(selected);
		gorder=gorder(selected);
		glist=glist(selected);

		switch method
			case 1
				stat_struct.test='RFE';
			case 2
				stat_struct.test='ANOVA_U';
		end;
		stat_struct.pval=NaN*ones(size(data,1),1);
		stat_struct.fdr=NaN*ones(size(data,1),1);
		stat_struct.fc=NaN*ones(size(data,1),1);
		stat_struct.n=stat_struct.n(selected);
					
		set(Array_id,'UserData',data);
		set(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData',gnames);
		set(findobj(Array_id,'Tag','GeneClassAxes'),'UserData',gorder);
		set(findobj(Array_id,'Tag','DatasetPanel'),'UserData',glist);
		set(findobj(Array_id,'Tag','Select1D'),'UserData',stat_struct);

		mstat_cb('reset_selection');
		mstat_cb('do_gui');
		mstat_cb('prepare_data');
		mstat_cb('prepare_axis');
		mstat_cb('redraw');

		set(Sel_id,'Pointer','arrow');
		delete(Sel_id);
end;
