function svdec();

size_x=400;
size_y=220;

SVD_id=findobj('Tag','SVD');
if isempty(SVD_id)==0
	figure(SVD_id);
else
	Array_id=findobj(0,'Tag','ArrayView');
	config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

	set(Array_id,'Pointer','watch');
	pause(0.01);

	data=get(Array_id,'UserData');
	standarized=0;
	if strcmp(get(gcbf,'Tag'),'ACluster')
		genes_group=get(findobj(gcbf,'Tag','GeneGroupPop'),'Value');
		if genes_group~=1
			gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
			index=find(gorder==genes_group-1);
			if ~isempty(index)
				data=data(index,:);
			else
				beep;
			end;
		end;
		if get(findobj(gcbf,'Tag','NormalizeCheck'),'Value')==1
			data=data_normalize(data_center(data,'mean'),'std');
			standarized=1;
		end;
	end;

	if standarized~=1
%		switch questdlg('Czy standaryzowa cechy?','MStat','Tak','Nie','Anuluj','Tak')
		switch questdlg('Czy centrowa cechy?','MStat','Tak','Nie','Anuluj','Tak')
			case 'Tak'
%				data=data_normalize(data_center(data,'mean'),'std');
				data=data_center(data,'mean');
			case 'Anuluj'
				set(Array_id,'Pointer','arrow');
				return;
		end;
	end;

	[u,s,v]=svd(data,0);
	[enthropy,p,nr]=svd_entropy([],0,0.8,s);
	set(Array_id,'Pointer','arrow');

	eigengene_count=min(size(data,1),size(data,2));
	eigengene_string=cell(1,eigengene_count);
	for i=1:eigengene_count
		eigengene_string{i}=num2str(i);
	end;

	aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
	if max(aorder)>1
		
		p=anova1(v(:,1),aorder,'off');
	else
		p=0;
	end;

	SVD_id=figure('Units','pixels', ...
		'Position',[figpos(Array_id,size_x,size_y) size_x size_y],...
		'Color',config.bg_color, ...
		'Visible','on',...
		'MenuBar','none', ...
		'NumberTitle','off', ...
		'Resize','off',...
		'CreateFcn','set(findobj(0,''Tag'',''ArrayView''),''WindowButtonMotionFcn'','''');',...
		'DeleteFcn','set(findobj(0,''Tag'',''ArrayView''),''WindowButtonMotionFcn'',''mstat_mf'');',...
		'KeyPressFcn',@figure_kb_cb,...						
		'Name','SVD', ...
		'Tag','SVD');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[5 35 390 175], ...
		'HorizontalAlignment','left', ...
		'Enable','off',...
		'Style','frame', ...
		'Tag','SVDFrame');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 199 60 18], ...
		'HorizontalAlignment','left', ...
		'String',' Informacje: ', ...
		'Style','text', ...
		'Tag','SVDText');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[130 175 70 20], ...
		'HorizontalAlignment','right', ...
   		'String',num2str(enthropy),...
		'Style','edit', ...
		'Enable','off',...
		'Tag','EnthropyEdit');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 175 90 18], ...
		'HorizontalAlignment','left', ...
		'String','Entropia zbioru:',...
		'Style','text', ...
		'Tag','EnthropyEditText');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
	   	'Position',[210 175 180 20], ...
		'String','Wywietl wzgldny udzia', ...
		'Tag','ExpressionButt', ...
		'CallBack','svdec_cb(''expression'')');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[130 150 70 20], ...
		'HorizontalAlignment','right', ...
		'UserData',[1 100 80 3],...
   		'String',num2str(80),...
		'Style','edit', ...
		'Enable','on',...
		'Tag','PercentEdit',...
		'Callback','svdec_cb(''edit'')');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 150 120 18], ...
		'HorizontalAlignment','left', ...
		'String','Cechy w. zawierajce',...
		'Style','text', ...
		'Tag','PercentEditText');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[275 150 40 20], ...
		'HorizontalAlignment','right', ...
	   	'String',num2str(nr),...
		'Style','edit', ...
		'Enable','off',...
		'Tag','PercentEdit2',...
		'Callback','');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[210 150 60 18], ...
		'HorizontalAlignment','left', ...
		'String','% ekspresji:',...
		'Style','text', ...
		'Tag','PercentEditText2');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
	   	'Position',[320 150 70 20], ...
		'String','Wyznacz', ...
		'Tag','PercentButt', ...
   		'CallBack','svdec_cb(''percent'')');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[130 125 70 20], ...
		'String',eigengene_string, ...
		'Style','popupmenu',...
		'Value',1, ...
		'Tag','ProfilePop', ...
		'Callback','svdec_cb(''pop'')');

%	uicontrol('Parent',SVD_id, ...
%		'Units','pixels', ...
%		'BackgroundColor',[1 1 1], ...
%		'Position',[140 125 50 20], ...
%		'HorizontalAlignment','right', ...
%		'UserData',[1 size(s,1) 1 0],...
%	   	'String',num2str(1),...
%		'Style','edit', ...
%		'Enable','on',...
%		'Tag','ProfileEdit',...
%		'Callback','svdec_cb(''edit'')');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 125 120 18], ...
		'HorizontalAlignment','left', ...
		'String','Numer cechy wasnej:',...
		'Style','text', ...
		'Tag','ProfileEditText');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
	   	'Position',[210 125 180 20], ...
		'String','Wywietl profil ekspresji', ...
		'Tag','ProfileButt', ...
   		'CallBack','svdec_cb(''profile'')');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[130 100 70 20], ...
		'HorizontalAlignment','right', ...
		'UserData',[0 1 0 3],...
		'String',num2str(p),...
		'Style','edit', ...
		'Enable','on',...
		'Tag','PValueEdit',...
		'Callback','');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
		'BackgroundColor',config.bg_color, ...
		'Position',[10 100 60 18], ...
		'HorizontalAlignment','left', ...
		'String','p-value:',...
		'Style','text', ...
		'Tag','PValueEditText');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
	   	'Position',[210 100 85 20], ...
		'String','Min. p-value', ...
		'Tag','FindButt', ...
   		'CallBack','svdec_cb(''find_minp'')');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
	   	'Position',[305 100 85 20], ...
		'String','Usu', ...
		'Tag','DeleteButt', ...
   		'CallBack','svdec_cb(''delete'')');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
	   	'Position',[225 5 80 25], ...
		'String','Zapisz', ...
		'Tag','SaveButt', ...
		'Callback','svdec_cb(''save'');');

	uicontrol('Parent',SVD_id, ...
		'Units','pixels', ...
	   	'Position',[315 5 80 25], ...
		'String','Zamknij', ...
		'Tag','CancelButt', ...
		'Callback','delete(gcbf);');

	data_struct.u=u;
	data_struct.s=s;
	data_struct.v=v;
	data_struct.eigengene_nr=1;
	
	set(SVD_id,'UserData',data_struct);
end;

