function tst1D_cb(action,fig);

if nargin==1
	Tst1D_id=gcbf;
else
	Tst1D_id=fig;
end;
Array_id=findobj(0,'Tag','ArrayView');
LogCheck_id=findobj(Tst1D_id,'Tag','LogCheck');
LogPop_id=findobj(Tst1D_id,'Tag','LogPop');
MethodPop_id=findobj(Tst1D_id,'Tag','MethodPop');
ClassPop1_id=findobj(Tst1D_id,'Tag','ClassPop1');
ClassPop2_id=findobj(Tst1D_id,'Tag','ClassPop2');
PValEdit_id=findobj(Tst1D_id,'Tag','PValEdit');
PVal2Edit_id=findobj(Tst1D_id,'Tag','PVal2Edit');
FCEdit_id=findobj(Tst1D_id,'Tag','FCEdit');
%IQREdit_id=findobj(Tst1D_id,'Tag','IQREdit');
GeneNrEdit_id=findobj(Tst1D_id,'Tag','GeneNrEdit');
AlfaEdit_id=findobj(Tst1D_id,'Tag','AlfaEdit');

switch action
	case 'edit'
		Edit_id=gcbo;
		num=str2num(get(Edit_id,'String'));
		limits=get(Edit_id,'UserData');

		if isempty(num)==1
			num=limits(3);
			beep;
		else
			switch limits(4)
				case 0
					if num<limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
				case 1
					if num<=limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 2
					if num<limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 3
					if num<=limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
			end;
		end;
		set(Edit_id,'String',num2str(num));
		tst1D_cb('test');

	case 'check'
		if get(LogCheck_id,'Value')==1		
			set(LogPop_id,'Enable','on');
		else
			set(LogPop_id,'Enable','off');
		end;
		tst1D_cb('test');

	case 'pop'
		class_nr1=get(ClassPop1_id,'Value');
		class_nr2=get(ClassPop2_id,'Value');
		if class_nr1==class_nr2
			set(ClassPop1_id,'Value',1);
			set(ClassPop2_id,'Value',2)
			beep;
		else
			tst1D_cb('test');
		end;

	case 'switch_pop'
		class_nr1=get(ClassPop1_id,'Value');
		class_nr2=get(ClassPop2_id,'Value');
		set(ClassPop1_id,'Value',class_nr2);
		set(ClassPop2_id,'Value',class_nr1)
		tst1D_cb('test');

	case 'boxplot'
		gene_nr=str2num(get(GeneNrEdit_id,'String'));
		aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
		gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
		cnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'UserData');

		data_struct=get(Tst1D_id,'UserData');
		if data_struct.eigen==0
			data=get(Array_id,'UserData');
			gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
			gene_name=gnames{gene_nr};
		else
			data=data_struct.data;
			gene_name=['Engengene ' num2str(gene_nr)];
		end;
		plot_box(data(gene_nr,:),aorder,cnames,gene_name)
	
	case 'test'
		set(Array_id,'Pointer','watch');
		pause(0.01);
		data_struct=get(Tst1D_id,'UserData');

		if data_struct.eigen==1
			data=data_struct.data;
		else
			data=get(Array_id,'UserData');
		end;

		gene_nr=str2num(get(GeneNrEdit_id,'String'));
		aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
		gene_nr=str2num(get(GeneNrEdit_id,'String'));
		alfa=str2num(get(AlfaEdit_id,'String'));
		class_nr1=get(ClassPop1_id,'Value');
		class_nr2=get(ClassPop2_id,'Value');

		p1=NaN;
		p2=NaN;
		fc=NaN;
		iqrange=NaN;

		missing=isnan(data(gene_nr,:));
		index=find(missing==0);
		
		%[p,ctable]=chi_square(missing,aorder);
		%p
		%ctable
		
		if ~isempty(index)
			gene_data=data(gene_nr,index);
			gene_aorder=aorder(index);

			if max(gene_aorder>1)
				index1=find(gene_aorder==class_nr1);
				index2=find(gene_aorder==class_nr2);

				switch get(MethodPop_id,'Value')
					case 1
						p1=anova1(gene_data,gene_aorder,'off');
						if ~isempty(index1) & ~isempty(index2) & length(index1>2) & length(index2>2)
							p2=anova1(gene_data([index1;index2]),gene_aorder([index1;index2]),'off');
						end;
					case 2
						p1=kruskalwallis(gene_data,gene_aorder,'off');
						if ~isempty(index1) & ~isempty(index2) & length(index1>2) & length(index2>2)
							p2=kruskalwallis(gene_data([index1;index2]),gene_aorder([index1;index2]),'off');
						end;
					case 3
						[d,p1]=satterthwaite(gene_data,gene_aorder);
						if ~isempty(index1) & ~isempty(index2) & length(index1>2) & length(index2>2)
							[d,p2]=satterthwaite(gene_data,gene_aorder,[class_nr1,class_nr2]);
						end;
					case 4
						[w,p1]=mann_whitney(gene_data,gene_aorder);
						if ~isempty(index1) & ~isempty(index2) & length(index1>2) & length(index2>2)
							[w,p2]=mann_whitney(gene_data,gene_aorder,[class_nr1,class_nr2]);
						end;
				end;

				if ~isempty(index1) & ~isempty(index2) & length(index1>1) & length(index2>1)
					if get(LogCheck_id,'Value')==1
						switch get(LogPop_id,'Value')
							case 1
								logbase=2;
							case 2
								logbase=10;
							case 3
								logbase=exp(1);
						end;
						exp_data=logbase.^gene_data;
					else
						exp_data=gene_data;
					end;

					if min(exp_data)>=0
						fc=mean(exp_data(index1))/mean(exp_data(index2));
			%			fc=trimmean(exp_data(find(aorder==class_nr1)),4)/trimmean(exp_data(find(aorder==class_nr2)),4);
					end;
				end;
			end;
			%iqrange=iqr(gene_data);
		end;

		color1=[0 0 0];
		if p1<=alfa
			color1=[1 0 0];
		end;
		color2=[0 0 0];
		if p2<=alfa
			color2=[1 0 0];
		end;

		set(PValEdit_id,'String',num2str(p1),'ForegroundColor',color1);
		set(PVal2Edit_id,'String',num2str(p2),'ForegroundColor',color2);
		set(FCEdit_id,'String',num2str(fc));
		%set(IQREdit_id,'String',num2str(iqrange));
		set(Array_id,'Pointer','arrow');
end;
