function dataset=load_dataset(filename,path);

if nargin==0
	filename=[];
	path='.';
elseif nargin==1
	path='.';
end;

if isempty(filename)
	[fname,path]=uigetfile('*.txt','Otwrz plik',path);
	filename=[path,fname];
	if filename==0
		dataset=[];
		return;
	end
else
	[path,name,ext]=fileparts(filename);
	fname=[name ext];
end;

%%%%%%%%wczytanie pliku z danymi%%%%%%%%%%%%%
dataset=load_table([path fname]);

dimension=size(dataset.data,1);
vectors_count=size(dataset.data,2);

fname=fname(1:length(fname)-4);

%%%%%%%%wczytanie pliku z podziaem na grupy genw%%%%%%%%%
records=load_cell2([path fname '.gcl']);
genes_order=ones(dimension,1);

if size(records,1)==dimension & size(records,2)==1
	for i=1:dimension
		record=records{i};
		if length(record)<2
			break;
		end;
		genes_order(i)=str2num(record{2});

	end;
end;
dataset.row_classes=reorder_labels(genes_order);

%%%%%%%%wczytanie pliku z nazwami grup genw%%%%%%%%
[groups_names,groups_count]=load_cell([path fname '.gcn']);
if groups_count~=max(genes_order)
	clear groups_names;
	groups_count=max(genes_order);

	groups_names=cell(groups_count,1);
	if groups_count==1
		groups_names{1}='Brak podziau na grupy';
	else
		for i=1:groups_count
			groups_names{i}=['Grupa' num2str(i)];
		end;
	end;
end;
dataset.row_class_names=groups_names;

%
%
%%%%%%%%%%%%%%%%%%%%%%
function [new_order,trans_table]=reorder_labels(order);

order=order-min(order)+1;
class_count=max(order);

new_order=zeros(size(order));

class_list=cell(class_count,1);
for i=1:class_count
	class_list{i}=find(order==i);
end;

trans_table=[];
counter=1;
for i=1:class_count
	if ~isempty(class_list{i})
		trans_table(1,counter)=i;
		trans_table(2,counter)=counter;
		new_order(class_list{i})=counter;
		counter=counter+1;
	end;
end;
