package	mscanlib.gui;

import java.io.File;
import javax.swing.filechooser.*;

public final class MScanJFileFilter extends FileFilter
{
	public final static int TYPE_END=0;
	public final static int TYPE_START=1;
	public final static int TYPE_CONTAINS=2;

	protected String	mExtensions[]=null;
	protected String	mDescription=null;
	protected boolean	mShowDirectories=true;
	protected int		mType=TYPE_END;

	public MScanJFileFilter(String extension, String description, boolean showDirectories)
	{
		if (extension!=null)
		{
			this.mExtensions=new String[1];
			this.mExtensions[0]=extension;
			this.mDescription=description;
			this.mShowDirectories=showDirectories;
			this.mType=TYPE_END;
		}
	}

	public MScanJFileFilter(String extension, String description, boolean showDirectories,int type)
	{
		if (extension!=null)
		{
			this.mExtensions=new String[1];
			this.mExtensions[0]=extension;
			this.mDescription=description;
			this.mShowDirectories=showDirectories;
			this.mType=type;
		}
	}

	public MScanJFileFilter(String extensions[], String description, boolean showDirectories)
	{
		if (extensions!=null && extensions.length!=0)
		{
			this.mExtensions=new String[extensions.length];
			for (int i=0;i<extensions.length;i++)
				this.mExtensions[i]=extensions[i];
			this.mDescription=description;
			this.mShowDirectories=showDirectories;
		}
	}

	public boolean accept(File file)
	{
		if (file!=null)
		{
			if (file.isDirectory())
				if (this.mShowDirectories)
					return(true);
				else
					return(false);
			for (int i=0;i<this.mExtensions.length;i++)
				switch (this.mType)
				{
				case TYPE_END:		if (file.getName().toUpperCase().endsWith(this.mExtensions[i].toUpperCase()))
										return(true);
									break;
				case TYPE_START:	if (file.getName().toUpperCase().startsWith(this.mExtensions[i].toUpperCase()))
										return(true);
									break;
				case TYPE_CONTAINS:	if (file.getName().toUpperCase().indexOf(this.mExtensions[i].toUpperCase())!=-1)
										return(true);
									break;
				}

		}
		return(false);
	}

    public String getDescription()
	{
		return new String(this.mDescription);
	}
}