function libsvm_demo()

addpath('.\libsvm');

%data=load('libsvm_demo_x.txt');
data=[ 1  1  2  4  5  5  7  8  8  9;
    1  2  3  3  2  7  6  4  8  5];

%classes=load('libsvm_demo_y.txt');
classes=[-1 -1 -1 -1 -1  1  1  1  1  1];

 
% SVM parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
svm_type=0;                 %0 -> C-SVC;
                            %1 -> nu-SVC

svm_kernel=0;               %0 -> linear: [u'*v];
                            %1 -> polynomial: [(gamma*u'*v + coef0)^degree];
                            %2 -> RBF: [exp(-gamma*|u-v|^2)];
                            %3 -> sigmoid: [tanh(gamma*u'*v + coef0)]
                            
svm_c=10;                   %wartosc marginesu C (jezeli NaN, to wartosci wszystkich parametrow szukane sa automatycznie)
svm_gamma=0.1;              %wartosc stalej gamma
svm_shrinkage=0;

svm_model_params=sprintf('-s %d -t %d -h %d -c %f',svm_type,svm_kernel,svm_shrinkage,svm_c);

svm_cost_sensitive = 0;
svm_norm=1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[cmodel,svm_model_params]=libsvm_train(data,classes,svm_model_params,svm_cost_sensitive,svm_norm);

[out_classes,f]=libsvm_classify(data,classes,cmodel);

figure;
hold on;
 
%cmap = [1 0.8 0.8; 0.95 1 0.95; 0.9 0.9 1];
pstyle= {'ro','go','bo'};

clabels=unique(classes);
for i=1:length(clabels)
    idx=find(classes==clabels(i));
    plot(data(1,idx),data(2,idx),pstyle{i});
end;    
 
xlim=[min(data(1,:))-1 max(data(1,:))+1];
xtick=xlim(1):0.1:xlim(2);

w=cmodel.w;
w0=cmodel.w0;
SV_index=cmodel.model.sv_indices;

plot(xtick,-1/w(2)*(w(1)*xtick + w0),'k');
plot(xtick,-1/w(2)*(w(1)*xtick + w0+1),'k-.');
plot(xtick,-1/w(2)*(w(1)*xtick + w0-1),'k-.');

plot(data(1,SV_index),data(2,SV_index),'ks');


set(gca,'XLim',xlim);
hold off;

rmpath('.\libsvm');