function [cmodel,svm_model_params]=libsvm_train(data,classes,svm_model_params,cost_sensitive,norm)

cmodel=struct('model',[],'scale',ones(size(data,1),1),'shift',zeros(size(data,1),1));

if (cost_sensitive==true)
    n=length(classes);
	labels=unique(classes);
	for i=1:length(labels)
		class_n=length(find(classes==labels(i)));
		class_w=n/(2*class_n);
		svm_model_params=[svm_model_params ' -w' num2str(labels(i)) ' ' num2str(class_w)];
	end;
end;

if (norm==false)
	[data,norm_settings]=mapminmax(data,0,1);
	cmodel.shift=norm_settings.xmin;
	cmodel.scale=norm_settings.xrange;
end;

%fprintf('LibSVM paramaters %s\n',svm_model_params);

cmodel.model=libsvmtrain(classes,data',svm_model_params); %[svm_model_params ' -b 1']);

[w,w0]=libsvm_weights(cmodel.model);
cmodel.w=w;
cmodel.w0=w0;
