function [w,w0]=libsvm_weights(model)

%http://www.csie.ntu.edu.tw/~cjlin/libsvm/faq.html#f804

if model.nr_class==2
	coeffs=model.sv_coef;
	SV=full(model.SVs);

	w = SV'*coeffs;
	w0 = -model.rho;
	
	%If you do regression or one-class SVM, then the if statement is not needed. 
	if model.Label(1) == -1
		w = -w;
		w0 = -w0;
	end;
else
	indices=[1;cumsum(model.nSV)+1];
	
	w=[];
	%w=zeros(size(model.SVs,2),model.nr_class*(model.nr_class-1)/2);
	counter=1;
	for i=1:model.nr_class-1
		i_index=[indices(i):indices(i+1)-1];
		for j=i+1:model.nr_class
			j_index=[indices(j):indices(j+1)-1];
			
			coeffs=[model.sv_coef(i_index,j-1) ; model.sv_coef(j_index,i)];
			SV=[full(model.SVs(i_index,:)) ; full(model.SVs(j_index,:))];
	
			w = [w , SV'*coeffs];
			%w(:,counter)=SV'*coeffs;
			counter=counter+1;
		end;
	end;
	
	%rho is arranged by 1vs2 1vs3 2vs3 ...
	w0 = -model.rho;
end;

