function [data_out,list]=missing_filter(data,max_missing,order,p_threshold,min_restore);

if nargin==2
	order=[];
end;
if nargin==3
	p_threshold=0.01;
	min_restore=0;
end;
missing=isnan(data);

not_nan_index=find(missing==0);
min_value=min(data(not_nan_index));

list=find(sum(missing,2)>max_missing);

if ~isempty(list) && ~isempty(order)
	excluded=zeros(1,length(list));
	percent=max_missing/length(order);
	
	for i=1:length(list)
        if ~any(missing(list(i),:)==0)
            continue;
        end;
        
		[p,ctable]=chi_square(missing(list(i),:),order);
		min_nan_count=min(ctable(2,:));
		min_nan_class=find(ctable(2,:)==min_nan_count);

        %zostawiamy jezeli p-value ponizej progu i w klasie o minimalnej liczbie brakujacych wartosci jest ich nie wiecej niz to wynika procentu dla calego zbioru danych
		if p<=p_threshold && min_nan_count<=max(percent*length(find(order==min_nan_class(1))),1)
			excluded(i)=1;
			if min_restore==1
				classes_count=size(ctable,2);
				for j=1:classes_count
					nan_count=ctable(2,j);
					class_index=find(order==j);
					%zastepowanie minimalna wartoscia jezeli w klasie jest wiecej brakujacych niz to wynika procentu dla calego zbioru danych
					if nan_count>max(percent*length(class_index),1);
						class_data=data(list(i),class_index);
						class_data(isnan(class_data))=min_value;
						data(list(i),class_index)=class_data;
					end;
				end;
			end;

%			if min_restore==1
%				max_nan_class=find(ctable(2,:)==max(ctable(2,:)));
%				for j=1:length(max_nan_class)
%					class_index=find(order==max_nan_class(j));
%					if ctable(2,max_nan_class(j))==length(class_index)
%						data(list(i),class_index)=min_value;
%					else
%						data(list(i),class_index)=nan_median(data(list(i),class_index));
%					end;
%				end;
%			end;
		end;
	end;
	list(find(excluded==1))=[];
end;

data_out=data;
data_out(list,:)=[];

