function plot_box(data,aorder,cnames,name,ylabel_text);

if nargin==1
	aorder=ones(length(data),1);
	cnames={''};
	name='';
	ylabel_text='Expression level';
end;
if nargin==2
	classes_count=max(aorder);

	cnames=cell(classes_count,1);
	if classes_count==1
		cnames{1}='';
	else
		for i=1:classes_count
			cnames{i}=['Klasa nr. ' num2str(i)];
		end;
	end;
	name='';
	ylabel_text='Expression level';
end;
if nargin==3
	name='';
	ylabel_text='Expression level';
end;
if nargin==4
	ylabel_text='Expression level';
end;

if ~isempty(aorder) & max(aorder)==1
	cnames={''};
end;

screen=get(0,'Screensize');
screen_x=screen(3);
screen_y=screen(4);

size_x=630;
size_y=425;
pos_x=(screen_x-size_x)/2;
pos_y=(screen_y-size_y)/2;

PlotBox_id=figure('Units','pixels',...
			'Position',[pos_x pos_y size_x size_y],...
			'Color',get(0,'defaultUicontrolBackgroundColor'),...
			'Visible','on',...
			'NumberTitle','off',...
			'MenuBar','none',...
			'Resize','off',...
			'KeyPressFcn',@figure_kb_cb,...				
			'Tag','PlotBox');

PlotAxes_id=axes('Parent',PlotBox_id,...
		'Units','pixels',...
		'FontSize',8,...
		'Position',[60 40 565 360],...
		'Tag','PlotAxes');

FileMenu_id=uimenu('Label','&Plik');
uimenu(FileMenu_id,'Label','&Zapisz...','CallBack','plot_box_cb(''save'')');
uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','delete(gcbf)');

hnd=[];
ViewMenu_id=uimenu('Label','&Widok','Tag','ViewMenu');

ViewScaleMenu_id=uimenu(ViewMenu_id,'Label','&Skala','Tag','ScaleSubmenu');
uimenu(ViewScaleMenu_id,'Label','Bez zmian','Check','on','CallBack','plot_box_cb(''scale'')','Tag','0');
hnd(1)=uimenu(ViewScaleMenu_id,'Label','log2','Separator','on','CallBack','plot_box_cb(''scale'')','Tag','2');
hnd(2)=uimenu(ViewScaleMenu_id,'Label','log10','CallBack','plot_box_cb(''scale'')','Tag','10');
uimenu(ViewScaleMenu_id,'Label','exp2','Separator','on','CallBack','plot_box_cb(''scale'')','Tag','-2');
uimenu(ViewScaleMenu_id,'Label','exp10','CallBack','plot_box_cb(''scale'')','Tag','-10');

if isempty(aorder)
	set(ViewScaleMenu_id,'Enable','off');
else
	if ~isempty(find(data<=0))
		for i=1:2
			set(hnd(i),'Enable','off');
		end;
	end;
end;

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
data_struct.data=data;
data_struct.aorder=aorder;
data_struct.cnames=cnames;
data_struct.name=name;
data_struct.log_base=0;
set(PlotBox_id,'UserData',data_struct,'Name',['Boxplot: ' name]);

plot_box_cb('redraw',PlotBox_id);
set(findobj(0,'Tag','ArrayView'),'Pointer','arrow');
return;
