function plot_corrmtx(data);

size_x=320;
size_y=320;

PlotCorr_id=figure('Units','pixels', ...
	'Position',[0 0 size_x size_y],...
	'Color',get(0,'defaultUicontrolBackgroundColor'), ...
	'Visible','on',...
	'MenuBar','none', ...
	'NumberTitle','off', ...
	'Resize','off',...
	'Doublebuffer','on',...
	'Colormap',lut('red_green',256),...
	'KeyPressFcn',@figure_kb_cb,...
	'Tag','PlotCorr');

axes_id=axes('Parent',PlotCorr_id,...
	'Units','pixels',...
	'XTick',[],...
	'YTick',[],...
	'XLim',[0.5 1.5],...
	'YLim',[0.5 1.5],...
	'YDir','reverse',...
	'Tag','CorrAxes',...
	'Position',[25 5 290 290]);

image_id=image('Parent',axes_id,...
	'CData',127,...
	'BusyAction','Queue',...
	'CDataMapping','Direct', ...
	'Interruptible','off',...
	'EraseMode','none',...
	'Clipping','off',...
	'Tag','CorrImage');

axes2_id=axes('Parent',PlotCorr_id,...
	'Units','pixels',...
	'Color',[0 0 0], ...
	'Box','on',...
	'XTick',[],...
	'YTick',[],...
	'XLim',[0.5 1.5],...
	'YLim',[0.5 1.5],...
	'YDir','reverse',...
	'Tag','XAxes',...
	'Position',[25 300 290 15]);

image2_id=image('Parent',axes2_id,...
	'CData',127,...
	'BusyAction','Queue',...
	'CDataMapping','Direct', ...
	'Interruptible','off',...
	'EraseMode','none',...
	'Clipping','off',...
	'Tag','XAxesImage');

axes3_id=axes('Parent',PlotCorr_id,...
	'Units','pixels',...
	'Color',[0 0 0], ...
	'XTick',[],...
	'YTick',[],...
	'XLim',[0.5 1.5],...
	'YLim',[0.5 1.5],...
	'YDir','reverse',...
	'Tag','YAxes',...
	'Position',[5 5 15 290]);

image3_id=image('Parent',axes3_id,...
	'CData',127,...
	'BusyAction','Queue',...
	'CDataMapping','Direct', ...
	'Interruptible','off',...
	'EraseMode','none',...
	'Clipping','off',...
	'Tag','YAxesImage');

FileMenu_id=uimenu('Label','&Plik');
uimenu(FileMenu_id,'Label','&Zapisz obraz...','CallBack','plot_corrmtx_cb(''save'')');
uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','plot_corrmtx_cb(''exit'')');

ViewMenu_id=uimenu('Label','&Widok');
ViewLUTSubMenu_id=uimenu(ViewMenu_id,'Label','&Paleta','Tag','ViewLUTSubMenu');
uimenu(ViewLUTSubMenu_id,'Label','Red&&Green','Checked','on','Tag','red_green','CallBack','plot_corrmtx_cb(''set_lut'')');
uimenu(ViewLUTSubMenu_id,'Label','Hot','Tag','hot','Separator','on','CallBack','plot_corrmtx_cb(''set_lut'')');
uimenu(ViewLUTSubMenu_id,'Label','Jet','Tag','jet','CallBack','plot_corrmtx_cb(''set_lut'')');
uimenu(ViewLUTSubMenu_id,'Label','Gray','Tag','gray','Separator','on','CallBack','plot_corrmtx_cb(''set_lut'')');
uimenu(ViewLUTSubMenu_id,'Label','Red','Tag','red','CallBack','plot_corrmtx_cb(''set_lut'')');
uimenu(ViewLUTSubMenu_id,'Label','Green','Tag','green','CallBack','plot_corrmtx_cb(''set_lut'')');
uimenu(ViewLUTSubMenu_id,'Label','Blue','Tag','blue','CallBack','plot_corrmtx_cb(''set_lut'')');
uimenu(ViewLUTSubMenu_id,'Label','Invert','Separator','on','CallBack','plot_corrmtx_cb(''invert_lut'')');

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
if nargin==0
	Array_id=findobj(0,'Tag','ArrayView');
	set(Array_id,'WindowButtonMotionFcn','');
	set(Array_id,'Pointer','watch');
	pause(0.01);
	drawnow;

	data=get(Array_id,'UserData');

	aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
	gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
	standarized=0;
else
	aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
	gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
end;

name='Wspczynniki korelacji prbek';
if strcmp(get(gcbf,'Tag'),'ACluster')
	genes_group=get(findobj(gcbf,'Tag','GeneGroupPop'),'Value');
	if genes_group~=1
		index=find(gorder==genes_group-1);
		if ~isempty(index)
			data=data(index,:);
		else
			beep;
		end;
	end;
	if get(findobj(gcbf,'Tag','NormalizeCheck'),'Value')==1
		data=data_normalize(data_center(data,'mean'),'std');
		standarized=1;
	end;

	order=aorder;
elseif strcmp(get(gcbo,'Tag'),'GCorrMtx')
	name='Wspczynniki korelacji cech';
	data=data';
	order=gorder;
else
	order=aorder;
end;

if standarized~=1
	switch questdlg('Czy standaryzowa cechy?','MStat','Tak','Nie','Anuluj','Tak')
		case 'Tak'
			data=data_normalize(data_center(data,'mean'),'std');
		case 'Anuluj'
			set(Array_id,'Pointer','arrow');
			return;
	end;
end;

vectors_count=length(order);

c=corrcoef(data);
c=round((c/2+0.5)*255);

zoom=4;
plot_size=zoom*vectors_count;
color=ctable;
colors_count=length(color);

screen=get(0,'Screensize');
screen_x=screen(3);
screen_y=screen(4);
if plot_size+80>screen_x | plot_size+80>screen_y
	plot_size=min(screen_x,screen_y)-80;
	zoom=-1;
end;

set(PlotCorr_id,'Name',name,'Position',[1 1 plot_size+30 plot_size+30]);
set(axes_id,'Position',[25 5 plot_size plot_size],'XLim',[0.5 vectors_count+0.5],'YLim',[0.5 vectors_count+0.5]);
set(axes2_id,'Position',[25 plot_size+10 plot_size 15],'XLim',[0.5 vectors_count+0.5],'YLim',[0.5 1.5],'UserData',order);
set(axes3_id,'Position',[5 5 15 plot_size],'XLim',[0.5 1.5],'YLim',[0.5 vectors_count+0.5]);
set(image_id,'CData',c);

xorder_image=zeros(1,vectors_count,3);
yorder_image=zeros(vectors_count,1,3);
for i=1:max(order)
	ind=find(order==i);
	for j=1:3
		xorder_image(1,ind,j)=color(i,j);
		yorder_image(ind,1,j)=color(i,j);
	end;
end;
set(image2_id,'CData',xorder_image);
set(image3_id,'CData',yorder_image);

%axes(axes2_id);
%hold on;
%hnd=fill([0:vectors_count-1;0:vectors_count-1;1:vectors_count;1:vectors_count],repmat([0;1;1;0],1,vectors_count),'g');
%for i=1:vectors_count
%	cindex=mod(order(i),colors_count);
%	if cindex==0
%		cindex=colors_count;
%	end;
%
%	set(hnd(i),'FaceColor',color(cindex,:));
%	if zoom==-1
%		set(hnd(i),'EdgeColor',color(cindex,:));
%	end;
%end;
%hold off;

%axes(axes3_id);
%hold on;
%hnd=fill(repmat([0;1;1;0],1,vectors_count),[0:vectors_count-1;0:vectors_count-1;1:vectors_count;1:vectors_count],'g');
%for i=1:vectors_count
%	cindex=mod(order(i),colors_count);
%	if cindex==0
%		cindex=colors_count;
%	end;
%
%	set(hnd(i),'FaceColor',color(cindex,:));
%	if zoom==-1
%		set(hnd(i),'EdgeColor',color(cindex,:));
%	end;
%end;
%hold off;
%axes(axes_id);

set(Array_id,'WindowButtonMotionFcn','mstat_mf');
set(Array_id,'Pointer','arrow');
drawnow;

