function plot_hierclust_cb(action);

PlotHierClust_id=gcbf;
if isempty(strfind(get(PlotHierClust_id,'Tag'),'HierClust'))
	hnd=get(0,'Child');
	PlotHierClust_id=hnd(1);
end;
Array_id=findobj(get(0,'Child'),'Tag','ArrayView');
config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

NameEdit_id=findobj(PlotHierClust_id,'Tag','NameEdit');

data_struct=get(PlotHierClust_id,'UserData');

orientation=data_struct.orientation;
vectors_count=data_struct.vectors_count;
min_range=data_struct.min_range;
range=data_struct.range;
zoom=data_struct.zoom;
order=data_struct.labels_order;
color=data_struct.color;
scroller=data_struct.scroller;

PlotAxes_id=findobj(PlotHierClust_id,'Tag','PlotAxes');
OrderAxes_id=findobj(PlotHierClust_id,'Tag','OrderAxes');
if scroller==1
	Scroller_id=findobj(PlotHierClust_id,'Tag','Scroll');
end;

config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');

switch action
	case 'save'
		format_str={'png';'bmp';'jpg';'tiff'};

		name=get(Array_id,'Name');
		name=name(strfind(name,'-')+2:length(name));
		if strcmp(orientation,'left')
			name=[name  '_ghier'];
		else
			name=[name  '_ahier'];
		end;

		[name,path,format]=uiputfile({'*.png','*.png';'*.bmp','*.bmp';'*.jpg','*.jpg';'*.tif','*.tif'},'Zapisz obraz do pliku',[config.export_path name]);
		if name~=0
			if isempty(strfind(name,format_str{format}))
				name=[name '.' format_str{format}];
			end;
			filename=[path name];

			set(PlotHierClust_id,'Renderer','painters'); 
			if scroller==1
				plot_position=get(PlotAxes_id,'Position');
				order_position=get(OrderAxes_id,'Position');
				regions_count=ceil(vectors_count/range);

				set(Scroller_id,'Visible','off');
				if strcmp(orientation,'left')
					size_x=plot_position(3)+order_position(3)+1;
					image=zeros(zoom*regions_count*range,size_x,3);
					for i=0:regions_count-1
						current_min_range=i*range;
						set(PlotAxes_id,'YLim',[current_min_range+0.5 current_min_range+range+0.5],'XTick',[],'YTick',[],'XColor',[1 1 1],'YColor',[1 1 1]);
						set(OrderAxes_id,'XLim',[0 1],'YLim',[current_min_range current_min_range+range],'XTick',[],'YTick',[]);

						fig=getframe(PlotHierClust_id);
						image(zoom*(current_min_range)+1:zoom*(current_min_range+range),1:size_x,:)=fig.cdata(2:end-1-30,1:size_x,:);
					end;
					image=image(1:zoom*vectors_count+zoom/2,:,:);
%					[image,cmap]=rgb2ind(image,256);
					set(PlotAxes_id,'YLim',[min_range+0.5 min_range+range+0.5],'XTick',[],'YTick',[],'XColor',[1 1 1],'YColor',[1 1 1]);
					set(OrderAxes_id,'XLim',[0 1],'YLim',[min_range min_range+range],'XTick',[],'YTick',[]);
				else
					size_y=plot_position(4)+order_position(4)+1;
					image=zeros(size_y,zoom*regions_count*range,3);

					for i=0:regions_count-1
						current_min_range=i*range;
						set(PlotAxes_id,'XLim',[current_min_range+0.5 current_min_range+range+0.5],'XTick',[],'YTick',[],'XColor',[1 1 1],'YColor',[1 1 1]);
						set(OrderAxes_id,'YLim',[0 1],'XLim',[current_min_range current_min_range+range],'XTick',[],'YTick',[]);

						fig=getframe(PlotHierClust_id);
						image(1:size_y,zoom*(current_min_range)+1:zoom*(current_min_range+range),:)=fig.cdata(1:size_y,2:end-1,:);
					end;

					image=image(:,1:zoom*vectors_count+zoom/2,:);
%					[image,cmap]=rgb2ind(image,256);
					set(PlotAxes_id,'XLim',[min_range+0.5 min_range+range+0.5],'XTick',[],'YTick',[],'XColor',[1 1 1],'YColor',[1 1 1]);
					set(OrderAxes_id,'YLim',[0 1],'XLim',[min_range min_range+range],'XTick',[],'YTick',[]);
				end;
				set(Scroller_id,'Visible','on');
			else
				current_color=get(PlotHierClust_id,'Color');
				set(PlotHierClust_id,'Color',[1 1 1]);
				fig=getframe(PlotHierClust_id);
				set(PlotHierClust_id,'Color',current_color);
%				[image,cmap]=rgb2ind(fig.cdata(2:end-1-30,:,:),256);
				image=fig.cdata(2:end-1-30,:,:);
			end;

%			imwrite(image,cmap,filename,format_str{format});
			imwrite(image,filename,format_str{format});
		end;


	case 'exit'
		delete(PlotHierClust_id);

	case 'scroll'
		if strcmp(orientation,'left')
			min_range=vectors_count-range-get(Scroller_id,'Value');
		else
			min_range=get(Scroller_id,'Value');
		end;
		data_struct.min_range=min_range;
		set(PlotHierClust_id,'UserData',data_struct);
		plot_hierclust_cb('set_axes');

	case 'click'
		orientation=data_struct.orientation;
		index=get(gcbo,'UserData');
		if strcmp(orientation,'left')
			gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
			gcnames=get(findobj(Array_id,'Tag','GeneClassPop'),'UserData');
			gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
			name=[gnames{index} ' [' char(gcnames{gorder(index)}) ']'];
			
			set(findobj(Array_id,'Tag','SelectedGeneEdit'),'UserData',index);
			array_nr=get(findobj(Array_id,'Tag','SelectedArrayEdit'),'UserData');
			if array_nr==0
				set(findobj(Array_id,'Tag','SelectedArrayEdit'),'UserData',1);
			end;
			if index>config.view_struct.position_y+config.view_struct.max_y || index<config.view_struct.position_y
				config.view_struct.position_y=index;
			end;

			set(findobj(Array_id,'Tag','FileOpen'),'UserData',config);
			mstat_cb('redraw');
			mstat_cb('do_gui');
		else
			anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
			acnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'UserData');
			aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
			name=[anames{index} ' [' char(acnames{aorder(index)}) ']'];

			if ~isempty(get(gcbf,'currentmodifier')) & strcmp(get(gcbf,'currentkey'),'shift')
				config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');
				config.view_struct.selected_array=index;
				config.view_struct.selected_gene=max(config.view_struct.selected_gene,1);
				set(findobj(Array_id,'Tag','FileOpen'),'UserData',config);
				mstat_cb('set_selected_array');
			end
			axes(PlotAxes_id);
		end;
		set(NameEdit_id,'String',name);

	case 'set_axes'
		if strcmp(orientation,'top')
			set(PlotAxes_id,'XLim',[min_range+0.5 min_range+range+0.5],'XTick',[],'YTick',[],'XColor',[1 1 1],'YColor',[1 1 1]);
			set(OrderAxes_id,'XLim',[min_range min_range+range],'YLim',[0 1],'XTick',[],'YTick',[]);
		else
			set(PlotAxes_id,'YLim',[min_range+0.5 min_range+range+0.5],'YDir','reverse','XTick',[],'YTick',[],'XColor',[1 1 1],'YColor',[1 1 1]);
			set(OrderAxes_id,'XLim',[0 1],'YLim',[min_range min_range+range],'XTick',[],'YTick',[]);
		end;
		drawnow;
end;