function plot_pca

size_x=620;
size_y=490;

screen_size=get(0,'screensize');
screen_width=screen_size(3); 
screen_height=screen_size(4);

pos_x=(screen_width-size_x)/2;
pos_y=(screen_height-size_y)/2;

PlotPCA_id=figure('Units','pixels', ...
		'Visible','on',...
		'MenuBar','none', ...
		'Color',get(0,'defaultUicontrolBackgroundColor'),...
		'NumberTitle','off', ...
		'Position',[pos_x pos_y size_x size_y],...
		'Name','PCA',...
		'DeleteFcn','plot_pca_cb(''exit'')',...
		'ResizeFcn','plot_pca_cb(''resize'')',...
		'KeyPressFcn',@figure_kb_cb,...		
		'Tag','PlotPCA');

PlotAxes_id=axes('Parent',PlotPCA_id,...
		'Units','pixels',...
		'box','on',...
		'FontSize',8,...
		'Position',[35 100 560 400],...
		'Tag','PlotAxes');

EditFrame_id=uipanel('Parent',PlotPCA_id, ...
		'Title','', ...
		'Units','pixels', ...
		'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'), ...
		'Position',[55 5 560 30], ...
		'Tag','EditPanel');
		
PC1PopText_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'), ...
		'Position',[5 3 20 18], ...
		'HorizontalAlignment','left', ...
		'String','X: ', ...
		'Style','text', ...
		'Tag','PC1PopText');

PC1Pop_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[25 5 100 20], ...
		'Style','popupmenu',...
		'String','PC1',...
		'Tag','PC1Pop', ...
		'Callback','plot_pca_cb(''pc_pop'')');

PC2PopText_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'), ...
		'Position',[140 3 20 18], ...
		'HorizontalAlignment','left', ...
		'String','Y: ', ...
		'Style','text', ...
		'Tag','PC2PopText');

PC2Pop_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[160 5 100 20], ...
		'Style','popupmenu',...
		'String','PC2',...
		'Tag','PC2Pop', ...
		'Callback','plot_pca_cb(''pc_pop'')');

PC3PopText_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'), ...
		'Position',[275 3 20 18], ...
		'HorizontalAlignment','left', ...
		'String','Z: ', ...
		'Style','text', ...
		'Tag','PC2PopText');

PC3Pop_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[295 5 100 20], ...
		'Style','popupmenu',...
		'String','PC3',...
		'Tag','PC3Pop', ...
        'Enable','off',...
		'Callback','plot_pca_cb(''pc_pop'')');
    
ListButton_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'Position',[480 3 70 22], ...
		'String','Lista', ...
		'Tag','ListButton', ...
		'Callback','plot_pca_cb(''list'')');


FileMenu_id=uimenu('Label','&Plik');
uimenu(FileMenu_id,'Label','&Zapisz...','CallBack','plot_pca_cb(''save'')');
uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','delete(gcbf)');

DataMenu_id=uimenu('Label','&Dane');
uimenu(DataMenu_id,'Label','&Standaryzacja','Checked','on','CallBack','plot_pca_cb(''standarize'')');
uimenu(DataMenu_id,'Label','&Varimax','Separator','on','CallBack','plot_pca_cb(''varimax'')');

ViewMenu_id=uimenu('Label','&Widok');
uimenu(ViewMenu_id,'Label','&3D','Checked','off','CallBack','plot_pca_cb(''3d_view'')');
AxisSubmenu_id=uimenu(ViewMenu_id,'Label','&Osie','Separator','on','Tag','AxisSubmenu');
uimenu(AxisSubmenu_id,'Label','Pokazuj &osie','Checked','on','CallBack','plot_pca_cb(''plot_axes'')');
uimenu(AxisSubmenu_id,'Label','Obr w poziomie','Separator','on','CallBack','plot_pca_cb(''flip_horizontal'')');
uimenu(AxisSubmenu_id,'Label','Obr w pionie','CallBack','plot_pca_cb(''flip_vertical'')');
uimenu(AxisSubmenu_id,'Label','O&brt 3D','Separator','on','Checked','off','CallBack','plot_pca_cb(''3d_rotate'')','Tag','Rotate3D');
MeanSubmenu_id=uimenu(ViewMenu_id,'Label','&rednie','Tag','MeanSubmenu');
uimenu(MeanSubmenu_id,'Label','&rednie arytm.','CallBack','plot_pca_cb(''plot_means'')','UserData',0);
uimenu(MeanSubmenu_id,'Label','Mediany','CallBack','plot_pca_cb(''plot_means'')','UserData',1);
LegendSubmenu_id=uimenu(ViewMenu_id,'Label','&Legenda','Tag','LegendSubmenu');
uimenu(LegendSubmenu_id,'Label','Wyczona','Checked','off','CallBack','plot_pca_cb(''plot_legend'')','Tag','none');
uimenu(LegendSubmenu_id,'Label','Swobodna pozycja','Separator','on','Checked','on','CallBack','plot_pca_cb(''plot_legend'')','Tag','free');
uimenu(LegendSubmenu_id,'Label','Na grze po prawej','Checked','off','CallBack','plot_pca_cb(''plot_legend'')','Tag','NorthEast');
uimenu(LegendSubmenu_id,'Label','Na grze po lewej','Checked','off','CallBack','plot_pca_cb(''plot_legend'')','Tag','NorthWest');
uimenu(LegendSubmenu_id,'Label','Na dole po prawej','Checked','off','CallBack','plot_pca_cb(''plot_legend'')','Tag','SouthEast');
uimenu(LegendSubmenu_id,'Label','Na dole po lewej','Checked','off','CallBack','plot_pca_cb(''plot_legend'')','Tag','SouthWest');
uimenu(LegendSubmenu_id,'Label','Na zewntrz','Checked','off','CallBack','plot_pca_cb(''plot_legend'')','Tag','NorthEastOutside');
MarkerSubmenu_id=uimenu(ViewMenu_id,'Label','&Znaczniki','Tag','MarkerSubmenu');
uimenu(MarkerSubmenu_id,'Label','&Symbole','Checked','off','CallBack','plot_pca_cb(''plot_symbols'')');
uimenu(MarkerSubmenu_id,'Label','&Etykiety','CallBack','plot_pca_cb(''plot_labels'')');
uimenu(MarkerSubmenu_id,'Label','&Due','Checked','off','CallBack','plot_pca_cb(''plot_big'')');
uimenu(MarkerSubmenu_id,'Label','&Wybieralne','Separator','on','Checked','on','CallBack','plot_pca_cb(''marker_clickable'')');
%uimenu(ViewMenu_id,'Label','&Antyaliasing','Separator','on','CallBack','myaa');

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
Array_id=findobj(0,'Tag','ArrayView');
        
pause(0.01);
set(Array_id,'Pointer','watch');
set(PlotPCA_id,'Pointer','watch');
pause(0.01);

data=get(Array_id,'UserData');

genes=strcmp(get(gcbo,'Tag'),'GenePCA');
if genes==1
	data=data';
end;

standarized=1;
data=data_normalize(data_center(data,'mean'),'std');

%if genes==1
%	[coeff,score]=princomp(data','econ');
%	figure;
%	scatter(score(:,1),score(:,2));
%else
%	[coeff,score]=princomp(data','econ');
%	figure;
%	scatter(score(:,1),score(:,2));
%end;

%[u,s,v]=svd(data,0);
%data_struct.pca_data=u'*data;
%p=diag(s);
%p=p(find(p~=0)).^2;
%p=100*p/sum(p);

[T,lambda,m,data_struct.pca_data]=pca(data);
p=100*lambda/sum(lambda);

pc_count=length(p);
pc_str=cell(1,pc_count);
for i=1:pc_count
	pc_str{i}=['PC' sprintf('%d [%0.2f%%]',i,p(i))];
end;
set(PC1Pop_id,'String',pc_str,'Value',1);
set(PC2Pop_id,'String',pc_str,'Value',2);
set(PC3Pop_id,'String',pc_str,'Value',3);

if genes==0
	data_struct.order=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
	data_struct.names=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
	data_struct.cnames=get(findobj(Array_id,'Tag','ArrayClassPop'),'UserData');
else
	data_struct.order=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
	data_struct.names=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
	data_struct.cnames=get(findobj(Array_id,'Tag','GeneClassPop'),'UserData');
end;

data_struct.std=standarized;
data_struct.genes=genes;
data_struct.pc1=1;
data_struct.pc2=2;
data_struct.pc3=3;
data_struct.selected=[];
data_struct.color=ctable;
data_struct.mean_symbol='o';
data_struct.plot_symbols=0;
data_struct.symbols={'o';'x';'s';'^';'v';'d';'p';'h';'<';'>';'*'};
data_struct.symbols_sizes=[2;5;5;5;5;5;5;5;5;5;5];
data_struct.symbols_big=0;
data_struct.plot_means=-1;
data_struct.plot_axes=1;
data_struct.plot_labels=0;
data_struct.plot_3d=0;
data_struct.rotate=0;
data_struct.view=[];
data_struct.marker_clickable=1;
if length(data_struct.cnames)==1
	data_struct.legend_position='none';
	set(LegendSubmenu_id,'Enable','off');
	set(get(LegendSubmenu_id,'Child'),'Checked','off');
else
	if genes==1
		set(LegendSubmenu_id,'Enable','on');
		set(get(LegendSubmenu_id,'Child'),'Checked','off');
		data_struct.legend_position='none';
	else
		set(LegendSubmenu_id,'Enable','on');
		data_struct.legend_position='free';
	end;
end;
data_struct.varimax=[];
data_struct.plot_varimax=0;

set(PlotPCA_id,'UserData',data_struct);
plot_pca_cb('redraw',PlotPCA_id);

set(Array_id,'Pointer','arrow');
set(PlotPCA_id,'Pointer','arrow');
return;
