function plot_pca_cb(action,fig)

if nargin==1
	PlotPCA_id=gcbf;
else
	PlotPCA_id=fig;
end;

Array_id=findobj(get(0,'Child'),'Tag','ArrayView');
PlotAxes_id=findobj(PlotPCA_id,'Tag','PlotAxes');
PC1Pop_id=findobj(PlotPCA_id,'Tag','PC1Pop');
PC2Pop_id=findobj(PlotPCA_id,'Tag','PC2Pop');
PC3Pop_id=findobj(PlotPCA_id,'Tag','PC3Pop');
Rotate3D_id=findobj(PlotPCA_id,'Tag','Rotate3D');

EditFrame_id=findobj(PlotPCA_id,'Tag','EditPanel');
        
LegendSubmenu_id=findobj(PlotPCA_id,'Tag','LegendSubmenu');
MeanSubmenu_id=findobj(PlotPCA_id,'Tag','MeanSubmenu');

switch action
	case 'exit'
		PCATable_id=findobj('Tag',['PCATable' num2str(PlotPCA_id)]);
		if ~isempty(PCATable_id)
			delete(PCATable_id);
		end;
		delete(PlotPCA_id);

	case 'resize'
		p=get(PlotPCA_id,'Position');
		size_x=p(3);
		size_y=p(4);
		set(PlotAxes_id,'Position',[[55 80 (size_x-55-5) (size_y-80-10)]]);

	case 'save'
		set(EditFrame_id,'Visible','off');
		
		name=get(Array_id,'Name');
		name=name(strfind(name,'-')+2:length(name));
		figsave_cb(0,[name '_pca']);

		set(EditFrame_id,'Visible','on');

	case 'pc_pop'
		data_struct=get(PlotPCA_id,'UserData');
		pc1=get(PC1Pop_id,'Value');
		pc2=get(PC2Pop_id,'Value');
        pc3=get(PC3Pop_id,'Value');
                
		if pc1~=pc2 && (pc1~=data_struct.pc1 || pc2~=data_struct.pc2)
			data_struct.pc1=pc1;
			data_struct.pc2=pc2;
			set(PlotPCA_id,'UserData',data_struct);
			plot_pca_cb('redraw');
		else
			set(PC1Pop_id,'Value',data_struct.pc1);
			set(PC2Pop_id,'Value',data_struct.pc2);
		end;

	case 'plot_labels'
		data_struct=get(PlotPCA_id,'UserData');
		if strcmp(get(gcbo,'Checked'),'off')
			set(gcbo,'Checked','on');
			data_struct.plot_labels=1;
		else
			set(gcbo,'Checked','off');
			data_struct.plot_labels=0;
		end;
		set(PlotPCA_id,'UserData',data_struct);
		plot_pca_cb('redraw');

	case 'plot_symbols'
		data_struct=get(PlotPCA_id,'UserData');
		
		if strcmp(get(gcbo,'Checked'),'off')
			set(gcbo,'Checked','on');
			data_struct.plot_symbols=1;
		else
			set(gcbo,'Checked','off');
			data_struct.plot_symbols=0;
		end;
		set(PlotPCA_id,'UserData',data_struct);
		plot_pca_cb('redraw');

	case 'plot_big'
		data_struct=get(PlotPCA_id,'UserData');
		
		if strcmp(get(gcbo,'Checked'),'off')
			set(gcbo,'Checked','on');
			data_struct.symbols_big=3;
		else
			set(gcbo,'Checked','off');
			data_struct.symbols_big=0;
		end;
		set(PlotPCA_id,'UserData',data_struct);
		plot_pca_cb('redraw');

	case 'plot_means'
		data_struct=get(PlotPCA_id,'UserData');

		if strcmp(get(gcbo,'Checked'),'off')
			set(get(MeanSubmenu_id,'Child'),'Checked','off');
			set(gcbo,'Checked','on');
			data_struct.plot_means=get(gcbo,'UserData');
		else
			set(gcbo,'Checked','off');
			data_struct.plot_means=-1;
		end;
		set(PlotPCA_id,'UserData',data_struct);
		plot_pca_cb('redraw');

	case 'plot_axes'
		data_struct=get(PlotPCA_id,'UserData');
		
		if strcmp(get(gcbo,'Checked'),'off')
			set(gcbo,'Checked','on');
			data_struct.plot_axes=1;
		else
			set(gcbo,'Checked','off');
			data_struct.plot_axes=0;
		end;
		set(PlotPCA_id,'UserData',data_struct);
		plot_pca_cb('redraw');

	case 'flip_horizontal'
		data_struct=get(PlotPCA_id,'UserData');
		data_struct.pca_data(data_struct.pc1,:)=-1*data_struct.pca_data(data_struct.pc1,:);
		set(PlotPCA_id,'UserData',data_struct);
		plot_pca_cb('redraw');

	case 'flip_vertical'
		data_struct=get(PlotPCA_id,'UserData');
		data_struct.pca_data(data_struct.pc2,:)=-1*data_struct.pca_data(data_struct.pc2,:);
		set(PlotPCA_id,'UserData',data_struct);
		plot_pca_cb('redraw');

	case 'plot_legend'
		data_struct=get(PlotPCA_id,'UserData');

		set(get(LegendSubmenu_id,'Child'),'Checked','off');
		set(gcbo,'Checked','on');
		data_struct.legend_position=get(gcbo,'Tag');
		set(PlotPCA_id,'UserData',data_struct);
		plot_pca_cb('redraw');

	case 'marker_clickable'
		data_struct=get(PlotPCA_id,'UserData');
		if data_struct.marker_clickable==0
			data_struct.marker_clickable=1;
			set(gcbo,'Checked','on');
		else
			data_struct.marker_clickable=0;
			set(gcbo,'Checked','off');
		end;
		set(PlotPCA_id,'UserData',data_struct);
		plot_pca_cb('redraw');

	case 'click'
		data_struct=get(PlotPCA_id,'UserData');
		selected=get(gcbo,'UserData');

		PCATable_id=findobj('Tag',['PCATable' num2str(PlotPCA_id)]);
		if ~isempty(PCATable_id)
			hnd_struct=get(PCATable_id,'UserData');
		end;

		if ~isempty(get(gcbf,'currentmodifier')) && strcmp(get(gcbf,'currentkey'),'control')
			index=find(data_struct.selected==selected);
			if isempty(index)
				data_struct.selected(end+1)=selected;
			else
				data_struct.selected(index)=[];
			end;
			if ~isempty(PCATable_id)
				hnd_struct.table.changeSelection(selected-1,0,true,false);
				hnd_struct.table.repaint;
			end;
		else
			data_struct.selected=selected;
			if ~isempty(PCATable_id)
				hnd_struct.table.changeSelection(selected-1,0,false,false);
				hnd_struct.table.repaint;
			end;
			if ~isempty(get(gcbf,'currentmodifier')) && strcmp(get(gcbf,'currentkey'),'shift')
				config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');
				config.view_struct.selected_array=selected;
				config.view_struct.selected_gene=max(config.view_struct.selected_gene,1);
				set(findobj(Array_id,'Tag','FileOpen'),'UserData',config);
				mstat_cb('set_selected_array');
			end
		end;

        if data_struct.plot_3d==1
            data_struct.view=zeros(1,2);
            [data_struct.view(1),data_struct.view(2)]=view;
        end;
        
		set(PlotPCA_id,'UserData',data_struct);
		plot_pca_cb('redraw');

	case 'list'
		plot_pca_table;

	case 'varimax'
		data_struct=get(PlotPCA_id,'UserData');
		
		if strcmp(get(gcbo,'Checked'),'off')
			set(gcbo,'Checked','on');
			data_struct.plot_varimax=1;
			if isempty(data_struct.varimax)
				set(PlotPCA_id,'Pointer','watch');
				pause(0.01);
				%data_struct.pca_data=Varimax4M(data_struct.pca_data',100,1e-4,0)';
				data_struct.varimax=varimax(data_struct.pca_data,1e-4,'noreorder');
				set(PlotPCA_id,'Pointer','arrow');
			end;
		else
			set(gcbo,'Checked','off');
			data_struct.plot_varimax=0;
		end;
		set(PlotPCA_id,'UserData',data_struct);
		plot_pca_cb('redraw');

    case 'standarize'
        set(PlotPCA_id,'Pointer','watch');
		pause(0.01);
                
		data_struct=get(PlotPCA_id,'UserData');
        
        data=get(Array_id,'UserData');
        if data_struct.genes==1
            data=data';
        end;

        data=data_center(data,'mean');
		if strcmp(get(gcbo,'Checked'),'off')
			set(gcbo,'Checked','on');
			data_struct.std=1;
            data=data_normalize(data,'std');
		else
			set(gcbo,'Checked','off');
			data_struct.std=0;
		end;
        
        [T,lambda,m,data_struct.pca_data]=pca(data);
        
        set(PlotPCA_id,'Pointer','arrow');
                
		set(PlotPCA_id,'UserData',data_struct);
		plot_pca_cb('redraw');
    
    case '3d_view'
        data_struct=get(PlotPCA_id,'UserData');
        
        if strcmp(get(gcbo,'Checked'),'off')
			set(gcbo,'Checked','on');
			
            data_struct.plot_3d=1;
            data_struct.symbols_sizes(1)=5;
            
            set(PC3Pop_id,'Enable','on');
            set(Rotate3D_id,'Enable','on');
		else
			set(gcbo,'Checked','off');
			
            data_struct.plot_3d=0;
            data_struct.symbols_sizes(1)=2;
                        
            set(PC3Pop_id,'Enable','off');
            set(Rotate3D_id,'Enable','off');
        end        
        data_struct.view=[];

        set(PlotPCA_id,'UserData',data_struct);
		plot_pca_cb('redraw');
	
    case '3d_rotate'
		data_struct=get(PlotPCA_id,'UserData');
		
        if strcmp(get(gcbo,'Checked'),'off')
			set(gcbo,'Checked','on');
			data_struct.rotate=1;
            rotate3d(PlotPCA_id,'on');
		else
			set(gcbo,'Checked','off');
			data_struct.rotate=0;
            rotate3d(PlotPCA_id,'off');            
        end

		set(PlotPCA_id,'UserData',data_struct);
        
	case 'redraw'
		data_struct=get(PlotPCA_id,'UserData');

		if data_struct.plot_varimax==1
			data_struct.pca_data=data_struct.varimax*data_struct.pca_data;
		end;

		axes(PlotAxes_id);
		delete(findobj(gca,'Type','line'));
		delete(findobj(gca,'Type','text'));
		hold on;

		x_max=max(data_struct.pca_data(data_struct.pc1,:));
		x_min=min(data_struct.pca_data(data_struct.pc1,:));
		y_max=max(data_struct.pca_data(data_struct.pc2,:));
		y_min=min(data_struct.pca_data(data_struct.pc2,:));
        if (data_struct.plot_3d==1)
            z_max=max(data_struct.pca_data(data_struct.pc3,:));
            z_min=min(data_struct.pca_data(data_struct.pc3,:));
        end
        
		x_grid=(x_max-x_min)/100;
		y_grid=(y_max-y_min)/100;
        if (data_struct.plot_3d==1)
            z_grid=(z_max-z_min)/100;
        end
        
		if strcmp(data_struct.legend_position,'none')~=1
			legend_hnd=zeros(max(data_struct.order));
			for i=1:max(data_struct.order)
				cindex=mod(i,length(data_struct.color));
				if cindex==0
					cindex=length(data_struct.color);
				end;

				if data_struct.plot_symbols==1
					sindex=mod(i,length(data_struct.symbols));
					if sindex==0
						sindex=length(data_struct.symbols);
					end;
				else
					sindex=1;
				end;
				leghend_hnd(i)=plot(0,0,data_struct.symbols{sindex});
				set(leghend_hnd(i),'MarkerSize',data_struct.symbols_sizes(sindex)+data_struct.symbols_big,'MarkerFaceColor',data_struct.color(cindex,:),'MarkerEdgeColor',data_struct.color(cindex,:),'Visible','off');
			end;
		end;

		if data_struct.plot_axes==1
			hnd=line([0 0],[y_min-5*y_grid y_max+5*y_grid]);
            if (data_struct.plot_3d==1)            
                set(hnd,'Color',[0 0 0],'LineWidth',1.5);
            else
                set(hnd,'Color',[0.5 0.5 0.5]);                
            end            
            
			hnd=line([x_min-5*x_grid x_max+5*x_grid],[0 0]);
            if (data_struct.plot_3d==1)            
                set(hnd,'Color',[0 0 0],'LineWidth',1.5);
            else
                set(hnd,'Color',[0.5 0.5 0.5]);                
            end            
            
            if (data_struct.plot_3d==1)            
                hnd=line([0 0],[0 0],[z_min-5*z_grid z_max+5*z_grid]);
                set(hnd,'Color',[0 0 0],'LineWidth',1.5);
            end
		end;

		for i=1:max(data_struct.order)
			index=find(data_struct.order==i);

			cindex=mod(i,length(data_struct.color));
			if cindex==0
				cindex=length(data_struct.color);
			end;

			if data_struct.plot_symbols==1
				sindex=mod(i,length(data_struct.symbols));
				if sindex==0
					sindex=length(data_struct.symbols);
				end;
			else
				sindex=1;
			end;
            
			if data_struct.marker_clickable==1
				for j=1:length(index)
                    if (data_struct.plot_3d==0)
                        hnd=plot(data_struct.pca_data(data_struct.pc1,index(j)),data_struct.pca_data(data_struct.pc2,index(j)),data_struct.symbols{sindex});
                    else
                        hnd=plot3(data_struct.pca_data(data_struct.pc1,index(j)),data_struct.pca_data(data_struct.pc2,index(j)),data_struct.pca_data(data_struct.pc3,index(j)),data_struct.symbols{sindex});                    
                    end
					set(hnd,'MarkerSize',data_struct.symbols_sizes(sindex)+data_struct.symbols_big,'MarkerFaceColor',data_struct.color(cindex,:),'MarkerEdgeColor',data_struct.color(cindex,:),'ButtonDownFcn','plot_pca_cb(''click'')','UserData',index(j));
				end;
            else
                if (data_struct.plot_3d==0)                
                    hnd=plot(data_struct.pca_data(data_struct.pc1,index),data_struct.pca_data(data_struct.pc2,index),data_struct.symbols{sindex});
                else
                    hnd=plot3(data_struct.pca_data(data_struct.pc1,index),data_struct.pca_data(data_struct.pc2,index),data_struct.pca_data(data_struct.pc3,index),data_struct.symbols{sindex});                
                end
				set(hnd,'MarkerSize',data_struct.symbols_sizes(sindex)+data_struct.symbols_big,'MarkerFaceColor',data_struct.color(cindex,:),'MarkerEdgeColor',data_struct.color(cindex,:));
			end;

			if ~isempty(data_struct.selected)
				for j=1:length(data_struct.selected)
					if ~isempty(find(index==data_struct.selected(j)))
                        if (data_struct.plot_3d==0)  
                            hnd=plot(data_struct.pca_data(data_struct.pc1,data_struct.selected(j)),data_struct.pca_data(data_struct.pc2,data_struct.selected(j)),data_struct.symbols{sindex});
                        else
                            hnd=plot3(data_struct.pca_data(data_struct.pc1,data_struct.selected(j)),data_struct.pca_data(data_struct.pc2,data_struct.selected(j)),data_struct.pca_data(data_struct.pc3,data_struct.selected(j)),data_struct.symbols{sindex});
                        end
                        set(hnd,'MarkerSize',data_struct.symbols_sizes(sindex)+data_struct.symbols_big+3,'MarkerFaceColor',data_struct.color(cindex,:),'MarkerEdgeColor',[0 0 0],'ButtonDownFcn','plot_pca_cb(''click'')','UserData',data_struct.selected(j));

						label=char(data_struct.names(data_struct.selected(j)));
						x=data_struct.pca_data(data_struct.pc1,data_struct.selected(j));
						y=data_struct.pca_data(data_struct.pc2,data_struct.selected(j));
                        
						if x>x_max-5*x_grid
							label_x=x-x_grid;
							valign='right';
						else
							label_x=x+x_grid;
							valign='left';
						end;
						
                        if y>y_max-2*y_grid
							label_y=y-y_grid;
							halign='top';
						else
							label_y=y+y_grid;
							halign='bottom';
                        end;

                        if (data_struct.plot_3d==1)
                            z=data_struct.pca_data(data_struct.pc3,data_struct.selected(j));
                            hnd=text(label_x,label_y,z,label);
                        else
                            hnd=text(label_x,label_y,label);
                        end;
						set(hnd,'VerticalAlignment',halign,'HorizontalAlignment',valign,'Color',data_struct.color(cindex,:),'EdgeColor',[0 0 0],'FontSize',7,'Interpreter','none','ButtonDownFcn','plot_pca_cb(''click'')','UserData',data_struct.selected);
					end;
				end;
			end;

			if data_struct.plot_labels==1
				for j=1:length(index)
					label=char(data_struct.names(index(j)));
					x=data_struct.pca_data(data_struct.pc1,index(j));
					y=data_struct.pca_data(data_struct.pc2,index(j));

						if x>x_max-5*x_grid
							label_x=x-x_grid;
							valign='right';
						else
							label_x=x+x_grid;
							valign='left';
						end;
						if y>y_max-2*y_grid
							label_y=y-y_grid;
							halign='top';
						else
							label_y=y+y_grid;
							halign='bottom';
						end;

					hnd=text(label_x,label_y,label);
					set(hnd,'VerticalAlignment',halign,'HorizontalAlignment',valign,'Color',data_struct.color(cindex,:),'FontSize',7,'Interpreter','none','ButtonDownFcn','plot_pca_cb(''click'')','UserData',index(j));
				end;
			end;

			if data_struct.plot_means~=-1
				if data_struct.plot_means==0
                    if (data_struct.plot_3d==0)                      
                        hnd=plot(mean(data_struct.pca_data(data_struct.pc1,index)),mean(data_struct.pca_data(data_struct.pc2,index)),data_struct.mean_symbol);
                    else
                        hnd=plot3(mean(data_struct.pca_data(data_struct.pc1,index)),mean(data_struct.pca_data(data_struct.pc2,index)),mean(data_struct.pca_data(data_struct.pc3,index)),data_struct.mean_symbol);
                    end
                else
                    if (data_struct.plot_3d==0)                      
                        hnd=plot(median(data_struct.pca_data(data_struct.pc1,index)),median(data_struct.pca_data(data_struct.pc2,index)),data_struct.mean_symbol);
                    else
                        hnd=plot3(median(data_struct.pca_data(data_struct.pc1,index)),median(data_struct.pca_data(data_struct.pc2,index)),median(data_struct.pca_data(data_struct.pc3,index)),data_struct.mean_symbol);
                    end
				end;
				set(hnd,'Color',data_struct.color(cindex,:));
			end;
		end;

        if (data_struct.plot_3d==1)
            set(gca,'XLim',[x_min-5*x_grid x_max+5*x_grid],'YLim',[y_min-5*y_grid y_max+5*y_grid],'ZLim',[z_min-5*z_grid z_max+5*z_grid],'FontSize',9);            
            set(gca,'box','off','XGrid','on','YGrid','on','ZGrid','on','XColor',[0.2 0.2 0.2]);  
        else
            set(gca,'XLim',[x_min-5*x_grid x_max+5*x_grid],'YLim',[y_min-5*y_grid y_max+5*y_grid],'FontSize',9);            
            set(gca,'box','on','XGrid','off','YGrid','off','ZGrid','off');                      
        end

		if strcmp(data_struct.legend_position,'none')~=1
			current_legend=findobj(PlotPCA_id,'Tag','legend');
			if ~isempty(current_legend)
				current_position=get(current_legend,'OuterPosition');
			end;
		
			cnames=data_struct.cnames;
			for i=1:length(cnames)
				index=strfind(cnames{i},'_');
				if ~isempty(index)
					cnames{i}(index)=' ';
				end;
			end;
			hnd=legend(cnames);
			if strcmp(data_struct.legend_position,'free')~=1
				set(hnd,'Location',data_struct.legend_position);
				set(hnd,'HitTest','off');
			else
				if ~isempty(current_legend)
					set(hnd,'OuterPosition',current_position);
				end;
				set(hnd,'HitTest','on');
			end;
			
			set(hnd,'FontSize',8);
			set(findall(hnd,'type','text'),'Interpreter', 'none');
		else
			delete(findobj(PlotPCA_id,'Tag','legend'));
		end;

        xlabel(['PC ' num2str(data_struct.pc1)]);
		ylabel(['PC ' num2str(data_struct.pc2)]);
        if (data_struct.plot_3d==1)
            zlabel(['PC ' num2str(data_struct.pc3)]);
        end
		hold off;
        
        if (data_struct.plot_3d==1)
            if isempty(data_struct.view)
                view(3);
            else
                view(data_struct.view(1),data_struct.view(2));
            end
        else
            view(2);
        end
end;
return;
