function plot_profiles_cb(action,fig);

if nargin==1
	PlotProfiles_id=gcbf;
else
	PlotProfiles_id=fig;
end;

PlotAxes_id=findobj(PlotProfiles_id,'Tag','PlotAxes');
ViewMenu_id=findobj(PlotProfiles_id,'Tag','ViewMenu');
ViewMeanSubmenu_id=findobj(PlotProfiles_id,'Tag','ViewMeanSubmenu');

switch action
	case 'resize'
		p=get(PlotProfiles_id,'Position');
		size_x=p(3);
		size_y=p(4);
		set(PlotAxes_id,'Position',[[55 80 (size_x-55-5) (size_y-80-10)]]);
		
	case 'scaling'
		data_struct=get(PlotProfiles_id,'UserData');
		
		if strcmp(get(gcbo,'Checked'),'off')
			set(gcbo,'Checked','on');
			data_struct.scaling=1;
		else
			set(gcbo,'Checked','off');
			data_struct.scaling=0;
		end;
		set(PlotProfiles_id,'UserData',data_struct);
		plot_profiles_cb('redraw');

	case 'mean'
		data_struct=get(PlotProfiles_id,'UserData');
		
		set(get(ViewMeanSubmenu_id,'Child'),'Checked','off');
		set(gcbo,'Checked','on');
		data_struct.mean_method=get(gcbo,'Tag');
	
		set(PlotProfiles_id,'UserData',data_struct);
		plot_profiles_cb('redraw');
		
	case 'redraw'
		data_struct=get(PlotProfiles_id,'UserData');

		axes(PlotAxes_id);
		delete(findobj(gca,'Type','line'));
		delete(findobj(gca,'Type','text'));
		hold on;
		
		data=data_struct.data;
		
		if data_struct.plot_mean==1
			rollup_config=struct('dim',1,'log_base',data_struct.log_base,'nonmissing_threshold',0.3,'method',data_struct.mean_method,'min_overlap',1,'grubbs_min_values',6,'grubbs_p_th',0.05);
	
			[centroide,scaled_data,ref_index,outliers]=rollup_features(data,rollup_config);
			if ~isempty(scaled_data) && data_struct.scaling==1
				data=scaled_data;
			end;
		else
			centroide=[];
		end;
		
		hold on;
		plot(data','b');
		
		if ~isempty(centroide)
			hnd=plot(centroide);
			set(hnd,'Color',[1 0 0],'LineWidth',2,'Marker','o','MarkerSize',2,'MarkerFaceColor',[1 0 0],'Tag','Mean');
		end;
		hold off;

		set(gca,'XLim',[1 size(data,2)],'XTick',[1:2:size(data,2)],'FontSize',8,'box','on');
		xlabel('Numer prbki');
		ylabel('Wzgldny poziom ekspresji');
		
		if ~isempty(scaled_data)
			set(findobj(ViewMenu_id,'Label','&Skalowanie'),'Enable','on')
		else
			set(findobj(ViewMenu_id,'Label','&Skalowanie'),'Enable','off')
		end;
end;