function plot_pval;

PlotPVal_id=figure('Units','pixels',...
			'Visible','on',...
			'Name','Posortowane p-value',...
			'Color',get(0,'defaultUicontrolBackgroundColor'),...
			'NumberTitle','off',...
			'MenuBar','none',...
			'Resize','off',...
			'KeyPressFcn',@figure_kb_cb,...			
			'Tag','PlotPVal');

FileMenu_id=uimenu('Label','&Plik');
uimenu(FileMenu_id,'Label','&Zapisz...','CallBack','figsave_cb');
uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','delete(gcbf)');

TestMenu_id=uimenu('Label','&Testy','Tag','Test');
AnovaTestMenu_id=uimenu(TestMenu_id,'Label','&ANOVA');
uimenu(AnovaTestMenu_id,'Label','p-values','CallBack','plot_pval_cb(''anova_p'')');
uimenu(AnovaTestMenu_id,'Label','T^2','CallBack','plot_pval_cb(''anova_t'')');
uimenu(TestMenu_id,'Label','&K-W','CallBack','plot_pval_cb(''kw'')');
SatterthwaiteMenu_id=uimenu(TestMenu_id,'Label','&Satterthwaite','CallBack','plot_pval_cb(''satterthwaite'')');
MannWhitneyMenu_id=uimenu(TestMenu_id,'Label','&Mann-Whitney','CallBack','plot_pval_cb(''mann-whitney'')');
uimenu(TestMenu_id,'Label','&Posortowane','Tag','Sort','Separator','on','Checked','on','CallBack','plot_pval_cb(''sort'')');
uimenu(TestMenu_id,'Label','&Histogram','Tag','Hist','Separator','on','CallBack','plot_pval_cb(''histogram'')');

Array_id=findobj(0,'Tag','ArrayView');
set(Array_id,'Pointer','watch');
pause(0.01);
data=get(Array_id,'UserData');
aorder=get(findobj(Array_id,'Tag','ArrayClassAxes'),'UserData');
class_count=max(aorder);
if class_count>2
	set(SatterthwaiteMenu_id,'Enable','off');
	set(MannWhitneyMenu_id,'Enable','off');
end;
color=ctable;

hold on;
[F,ts,p]=anova_test(data,aorder);
[p,index]=sort(p);
plot(p);

%plot(min_t1*ones(1,length(index)),'r');
hold off;

set(gca,'XLim',[1 size(data,1)],'FontSize',8,'box','on');
xlabel('Numer cechy');
%ylabel('T^2 (ANOVA)');
ylabel('p-value (ANOVA)');

data_struct=cell(2,1);
data_struct{1}=data;
data_struct{2}=aorder;
%data_struct{3}=t(end:-1:1);
data_struct{3}=p(end:-1:1);
data_struct{4}=index(end:-1:1);
set(PlotPVal_id,'UserData',data_struct);
set(Array_id,'Pointer','arrow');