function plot_sammon_cb(action,fig);

if nargin==1
	PlotSammon_id=gcbf;
else
	PlotSammon_id=fig;
end;
Array_id=findobj(get(0,'Child'),'Tag','ArrayView');
PlotAxes_id=findobj(PlotSammon_id,'Tag','PlotAxes');

switch action
	case 'exit'
		delete(PlotSammon_id);

	case 'resize'
		p=get(PlotSammon_id,'Position');
		size_x=p(3);
		size_y=p(4);
		set(PlotAxes_id,'Position',[[55 50 (size_x-55-5) (size_y-50-10)]]);

	case 'save'
		%set(EditFrame_id,'Visible','off');
		%set(ListButton_id,'Visible','off');
		%set(UnListButton_id,'Visible','off');
		%set(PC1Pop_id,'Visible','off');
		%set(PC1PopText_id,'Visible','off');
		%set(PC2Pop_id,'Visible','off');
		%set(PC2PopText_id,'Visible','off');

		name=get(Array_id,'Name');
		name=name(strfind(name,'-')+2:length(name));
		figsave_cb(0,[name '_sammon']);

		%set(EditFrame_id,'Visible','on');
		%set(ListButton_id,'Visible','on');
		%set(UnListButton_id,'Visible','on');
		%set(PC1Pop_id,'Visible','on');
		%set(PC1PopText_id,'Visible','on');
		%set(PC2Pop_id,'Visible','on');
		%set(PC2PopText_id,'Visible','on');
		
	case 'click'
		data_struct=get(PlotSammon_id,'UserData');
		selected=get(gcbo,'UserData');

		if ~isempty(get(gcbf,'currentmodifier')) && strcmp(get(gcbf,'currentkey'),'control')
			index=find(data_struct.selected==selected);
			if isempty(index)
				data_struct.selected(end+1)=selected;
			else
				data_struct.selected(index)=[];
			end;
		else
			data_struct.selected=selected;
			if ~isempty(get(gcbf,'currentmodifier')) & strcmp(get(gcbf,'currentkey'),'shift')
				config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');
				config.view_struct.selected_array=selected;
				config.view_struct.selected_gene=max(config.view_struct.selected_gene,1);
				set(findobj(Array_id,'Tag','FileOpen'),'UserData',config);
				mstat_cb('set_selected_array');
			end
		end;

		set(PlotSammon_id,'UserData',data_struct);
		plot_sammon_cb('redraw');
		
	case 'redraw'
		data_struct=get(PlotSammon_id,'UserData');

		axes(PlotAxes_id);
		delete(findobj(gca,'Type','line'));
		delete(findobj(gca,'Type','text'));
		hold on;

		x_max=max(data_struct.sammon_data(1,:));
		x_min=min(data_struct.sammon_data(1,:));
		y_max=max(data_struct.sammon_data(2,:));
		y_min=min(data_struct.sammon_data(2,:));
		x_grid=(x_max-x_min)/100;
		y_grid=(y_max-y_min)/100;

		if data_struct.plot_legend==1
			legend_hnd=zeros(max(data_struct.order));
			for i=1:max(data_struct.order)
				cindex=mod(i,length(data_struct.color));
				if cindex==0
					cindex=length(data_struct.color);
				end;

				if data_struct.plot_symbols==1
					sindex=mod(i,length(data_struct.symbols));
					if sindex==0
						sindex=length(data_struct.symbols);
					end;
				else
					sindex=1;
				end;
				leghend_hnd(i)=plot(0,0,data_struct.symbols{sindex});
				set(leghend_hnd(i),'MarkerSize',data_struct.symbols_sizes(sindex)+data_struct.symbols_big,'MarkerFaceColor',data_struct.color(cindex,:),'MarkerEdgeColor',data_struct.color(cindex,:),'Visible','off');
			end;
		end;

		if data_struct.plot_axes==1
			hnd=line([0 0],[y_min-5*y_grid y_max+5*y_grid]);
			set(hnd,'Color',[0.5 0.5 0.5]);
			hnd=line([x_min-5*x_grid x_max+5*x_grid],[0 0]);
			set(hnd,'Color',[0.5 0.5 0.5]);
		end;

		for i=1:max(data_struct.order)
			index=find(data_struct.order==i);

			cindex=mod(i,length(data_struct.color));
			if cindex==0
				cindex=length(data_struct.color);
			end;

			if data_struct.plot_symbols==1
				sindex=mod(i,length(data_struct.symbols));
				if sindex==0
					sindex=length(data_struct.symbols);
				end;
			else
				sindex=1;
			end;

			if data_struct.marker_clickable==1
				for j=1:length(index)
					hnd=plot(data_struct.sammon_data(1,index(j)),data_struct.sammon_data(2,index(j)),data_struct.symbols{sindex});
					set(hnd,'MarkerSize',data_struct.symbols_sizes(sindex)+data_struct.symbols_big,'MarkerFaceColor',data_struct.color(cindex,:),'MarkerEdgeColor',data_struct.color(cindex,:),'ButtonDownFcn','plot_sammon_cb(''click'')','UserData',index(j));
				end;
			else
				hnd=plot(data_struct.sammon_data(1,index),data_struct.sammon_data(2,index),data_struct.symbols{sindex});
				set(hnd,'MarkerSize',data_struct.symbols_sizes(sindex)+data_struct.symbols_big,'MarkerFaceColor',data_struct.color(cindex,:),'MarkerEdgeColor',data_struct.color(cindex,:));
			end;

			if ~isempty(data_struct.selected)
				for j=1:length(data_struct.selected)
					if ~isempty(find(index==data_struct.selected(j)))
						hnd=plot(data_struct.sammon_data(1,data_struct.selected(j)),data_struct.sammon_data(2,data_struct.selected(j)),data_struct.symbols{sindex});
						set(hnd,'MarkerSize',data_struct.symbols_sizes(sindex)+data_struct.symbols_big+3,'MarkerFaceColor',data_struct.color(cindex,:),'MarkerEdgeColor',[0 0 0],'ButtonDownFcn','plot_sammon_cb(''click'')','UserData',data_struct.selected(j));

						label=char(data_struct.names(data_struct.selected(j)));
						x=data_struct.sammon_data(1,data_struct.selected(j));
						y=data_struct.sammon_data(2,data_struct.selected(j));

						if x>x_max-5*x_grid
							label_x=x-x_grid;
							valign='right';
						else
							label_x=x+x_grid;
							valign='left';
						end;
						if y>y_max-2*y_grid
							label_y=y-y_grid;
							halign='top';
						else
							label_y=y+y_grid;
							halign='bottom';
						end;

						hnd=text(label_x,label_y,label);
						set(hnd,'VerticalAlignment',halign,'HorizontalAlignment',valign,'Color',data_struct.color(cindex,:),'EdgeColor',[0 0 0],'FontSize',7,'Interpreter','none','ButtonDownFcn','plot_sammon_cb(''click'')','UserData',data_struct.selected);
					end;
				end;
			end;

			if data_struct.plot_labels==1
				for j=1:length(index)
					label=char(data_struct.names(index(j)));
					x=data_struct.sammon_data(1,index(j));
					y=data_struct.sammon_data(2,index(j));

						if x>x_max-5*x_grid
							label_x=x-x_grid;
							valign='right';
						else
							label_x=x+x_grid;
							valign='left';
						end;
						if y>y_max-2*y_grid
							label_y=y-y_grid;
							halign='top';
						else
							label_y=y+y_grid;
							halign='bottom';
						end;

					hnd=text(label_x,label_y,label);
					set(hnd,'VerticalAlignment',halign,'HorizontalAlignment',valign,'Color',data_struct.color(cindex,:),'FontSize',7,'Interpreter','none','ButtonDownFcn','plot_sammon_cb(''click'')','UserData',index(j));
				end;
			end;
		end;

		set(gca,'XLim',[x_min-5*x_grid x_max+5*x_grid],'YLim',[y_min-5*y_grid y_max+5*y_grid],'FontSize',9)

		if data_struct.plot_legend==1
			cnames=data_struct.cnames;
			for i=1:length(cnames)
				index=strfind(cnames{i},'_');
				if ~isempty(index)
					cnames{i}(index)=' ';
				end;
			end;
			hnd=legend(cnames,'Location',data_struct.legend_position);
			set(hnd,'FontSize',8);
			set(findall(hnd,'type','text'),'Interpreter', 'none');

%			if isempty(current_legend)
%				current_position=get(hnd,'OuterPosition');
%			end;
%			if move_legend==0
%				set(hnd,'OuterPosition',current_position);
%			end;
		else
			delete(findobj(PlotSammon_id,'Tag','legend'));
		end;
		hold off;
end;
return;