function plot_scatterplot

switch questdlg('Czy wartoci s zlogarytmowane?','MStat','Tak','Nie','Anuluj','Tak')
	case 'Tak'
		logged=1;
	case'Nie'
		logged=0;
	otherwise
		return;
end;

Array_id=findobj(0,'Tag','ArrayView');
anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
cnames=get(findobj(Array_id,'Tag','GeneClassPop'),'UserData');

if length(cnames)==1
	cnames={''};
else
	cnames=[cnames;{''}];
end;

fit_str={'lowess','rlowess','loess','rloess','invset loess','rinvset loess','LS'};

size_x=575;
size_y=660;

screen_size=get(0,'screensize');
screen_width=screen_size(3); 
screen_height=screen_size(4);

pos_x=(screen_width-size_x)/2;
pos_y=(screen_height-size_y)/2;

PlotScatter_id=figure('Units','pixels', ...
		'Visible','on',...
		'Color',get(0,'defaultUicontrolBackgroundColor'),...
		'Position',[pos_x pos_y size_x size_y],...
		'NumberTitle','off', ...
		'MenuBar','none', ...
		'Resize','off',...
		'Name','Scatterplot',...
		'KeyPressFcn',@figure_kb_cb,...		
		'Tag','PlotScatter');

PlotAxes_id=axes('Parent',PlotScatter_id,...
		'Units','pixels',...
		'box','on',...
		'FontSize',9,...
		'FontName','Arial CE',...
		'Position',[60 130 500 500],...
		'Tag','PlotAxes');

EditFrame_id=uipanel('Parent',PlotScatter_id, ...
		'Title','', ...
		'Units','pixels', ...
		'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'), ...
		'Position',[60 5 500 85], ...
		'Tag','EditPanel');
	
SamplePopText_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'), ...
		'Position',[5 60 40 18], ...
		'HorizontalAlignment','left', ...
		'String','Prbka: ', ...
		'Style','text', ...
		'Tag','SamplePopText');

SamplePop_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[50 60 170 20], ...
		'Style','popupmenu',...
		'String',anames, ...
		'Value',1, ...
		'Tag','SamplePop', ...
		'Callback','plot_scatterplot_cb(''sample_pop'')');

RefSamplePopText_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'), ...
		'Position',[225 60 95 18], ...
		'HorizontalAlignment','left', ...
		'String','Prbka odniesienia: ', ...
		'Style','text', ...
		'Tag','RefSamplePopText');

anames{length(anames)+1}='Mediana';

RefSamplePop_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[320 60 170 20], ...
		'Style','popupmenu',...
		'String',anames, ...
		'Value',length(anames), ...
		'Tag','RefSamplePop', ...
		'Callback','plot_scatterplot_cb(''sample_pop'')');

GeneNameText_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'), ...
		'Position',[5 35 40 18], ...
		'HorizontalAlignment','left', ...
		'String','Nazwa: ', ...
		'Style','text', ...
		'Tag','GeneNameText');

GeneNameEdit_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[50 35 170 20], ...
		'HorizontalAlignment','left', ...
		'String','',...
		'Style','edit', ...
		'Tag','GeneNameEdit');

GroupPopText_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'), ...
		'Position',[225 35 70 18], ...
		'HorizontalAlignment','left', ...
		'String','Zaznaczenia: ', ...
		'Style','text', ...
		'Tag','GroupPopText');

GroupPop1_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[320 35 80 20], ...
		'Style','popupmenu',...
		'String',cnames, ...
		'Value',length(cnames), ...
		'Tag','GroupPop1', ...
		'Callback','plot_scatterplot_cb(''group_pop'')');

GroupPop2_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[410 35 80 20], ...
		'Style','popupmenu',...
		'String',cnames, ...
		'Value',length(cnames), ...
		'Tag','GroupPop2', ...
		'Callback','plot_scatterplot_cb(''group_pop'')');

SmoothMethodText_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'), ...
		'Position',[5 5 120 18], ...
		'HorizontalAlignment','left', ...
		'String','Metoda dopasowania: ', ...
		'Style','text', ...
		'Tag','SmoothMethodText');

SmoothMethodPop_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[130 5 90 20], ...
		'Style','popupmenu',...
		'String',fit_str, ...
		'Value',7, ...
		'Tag','SmoothMethodPop', ...
		'Callback','plot_scatterplot_cb(''smooth_pop'')');

SmoothParamText_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'), ...
		'Position',[225 5 95 18], ...
		'HorizontalAlignment','left', ...
		'String','Rozmiar otoczenia: ', ...
		'Style','text', ...
		'Tag','SmoothParamText');

SmoothParamEdit_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'BackgroundColor',[1 1 1], ...
		'Position',[320 5 80 20], ...
		'HorizontalAlignment','right', ...
		'String',num2str(0.5),...
		'Style','edit', ...
		'UserData',[0 1 0.5 3],...
		'Tag','SmoothParamEdit',...
		'Callback','plot_scatterplot_cb(''smooth_edit'')');

SmoothButton_id=uicontrol('Parent',EditFrame_id, ...
		'Units','pixels', ...
		'Position',[410 5 80 20], ...
		'String','Wyznacz', ...
		'Tag','SmoothButton', ...
		'CallBack','plot_scatterplot_cb(''smooth'')');

FileMenu_id=uimenu('Label','&Plik');
uimenu(FileMenu_id,'Label','&Zapisz...','CallBack','plot_scatterplot_cb(''save'')');
uimenu(FileMenu_id,'Label','&Zamknij','Separator','on','CallBack','plot_scatterplot_cb(''exit'')');

DataMenu_id=uimenu('Label','&Dane');
uimenu(DataMenu_id,'Label','&Normalizacja','CallBack','plot_scatterplot_cb(''normalize'')');

ViewMenu_id=uimenu('Label','&Widok');
PlotSubmenu_id=uimenu(ViewMenu_id,'Label','&Rodzaj wykresu','Tag','PlotType');
uimenu(PlotSubmenu_id,'Label','&Scatterplot','Checked','on','CallBack','plot_scatterplot_cb(''plot_type'')','Tag','scatter');
uimenu(PlotSubmenu_id,'Label','&M vs A','CallBack','plot_scatterplot_cb(''plot_type'')','Tag','ma');
uimenu(PlotSubmenu_id,'Label','&Rezydua','CallBack','plot_scatterplot_cb(''plot_type'')','Tag','residues');
hnd=uimenu(ViewMenu_id,'Label','Skala &log','Checked','on','CallBack','plot_scatterplot_cb(''log_scale'')');
if logged==1
	set(hnd,'Enable','off');
end;
uimenu(ViewMenu_id,'Label','Pokazuj &grupy','CallBack','plot_scatterplot_cb(''use_colors'')');
uimenu(ViewMenu_id,'Label','Pokazuj &prost','Separator','on','Checked','on','CallBack','plot_scatterplot_cb(''plot_line'')');
uimenu(ViewMenu_id,'Label','Pokazuj pro&gi','Checked','off','CallBack','plot_scatterplot_cb(''plot_thresholds'')');
uimenu(ViewMenu_id,'Label','Pokazuj &dopasowanie','Checked','on','CallBack','plot_scatterplot_cb(''plot_fit'')');
uimenu(ViewMenu_id,'Label','Pokazuj &zbir niezmiennych','Checked','off','CallBack','plot_scatterplot_cb(''plot_invset'')');
MarkerSubmenu_id=uimenu(ViewMenu_id,'Label','&Znaczniki');
big_hnd=uimenu(MarkerSubmenu_id,'Label','&Due','CallBack','plot_scatterplot_cb(''marker_big'')');
small_hnd=uimenu(MarkerSubmenu_id,'Label','&Mae','Checked','on','CallBack','plot_scatterplot_cb(''marker_small'')');
set(big_hnd,'UserData',small_hnd);
set(small_hnd,'UserData',big_hnd);
uimenu(MarkerSubmenu_id,'Label','&Wybieralne','Separator','on','CallBack','plot_scatterplot_cb(''marker_clickable'')');

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
set(Array_id,'Pointer','watch');
set(PlotScatter_id,'Pointer','watch');
pause(0.01);
drawnow;

data=get(Array_id,'UserData');

if strcmp(get(gcbf,'Tag'),'ACluster');
	genes_group=get(findobj(gcbf,'Tag','GeneGroupPop'),'Value');
	if genes_group~=1
		gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
		index=find(gorder==genes_group-1);
		if ~isempty(index)
			data=data(index,:);
		else
			beep;
		end;
	end;
end;

data_struct.data=data;
data_struct.data_median=median(data,2);
data_struct.plot_type='scatter';
data_struct.log_scale=1-logged;
data_struct.ref_array_nr=get(RefSamplePop_id,'Value');
data_struct.array_nr=get(SamplePop_id,'Value');
data_struct.gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
data_struct.gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
data_struct.groups_count=max(length(cnames)-1,1);
data_struct.selected_group1=get(GroupPop1_id,'Value');
data_struct.selected_group2=get(GroupPop2_id,'Value');
data_struct.point_symbol='o';
data_struct.marker_size=2;
data_struct.marker_clickable=0;
data_struct.color=ctable;
data_struct.use_colors=0;
data_struct.plot_invset=0;
data_struct.invset=[];
data_struct.plot_line=1;
data_struct.line=[];
data_struct.plot_thresholds=0;
data_struct.thresholds=[];
data_struct.threshold_value=2;
data_struct.plot_fit=1;
data_struct.fit=[];
data_struct.norm=0;

set(PlotScatter_id,'UserData',data_struct);
plot_scatterplot_cb('redraw',PlotScatter_id);
