function plot_scatterplot_cb(action,fig)

if nargin==1
	PlotScatter_id=gcbf;
else
	PlotScatter_id=fig;
end;

Array_id=findobj(get(0,'Child'),'Tag','ArrayView');

PlotAxes_id=findobj(PlotScatter_id,'Tag','PlotAxes');
RefSamplePop_id=findobj(PlotScatter_id,'Tag','RefSamplePop');
SamplePop_id=findobj(PlotScatter_id,'Tag','SamplePop');
GroupPop1_id=findobj(PlotScatter_id,'Tag','GroupPop1');
GroupPop2_id=findobj(PlotScatter_id,'Tag','GroupPop2');
GeneNameEdit_id=findobj(PlotScatter_id,'Tag','GeneNameEdit');
SmoothMethodText_id=findobj(PlotScatter_id,'Tag','SmoothMethodText');
SmoothMethodPop_id=findobj(PlotScatter_id,'Tag','SmoothMethodPop');
SmoothParamText_id=findobj(PlotScatter_id,'Tag','SmoothParamText');
SmoothParamEdit_id=findobj(PlotScatter_id,'Tag','SmoothParamEdit');
SmoothButton_id=findobj(PlotScatter_id,'Tag','SmoothButton');
PlotSubmenu_id=findobj(PlotScatter_id,'Tag','PlotType');
EditFrame_id=findobj(PlotScatter_id,'Tag','EditPanel');

fit_str={'lowess','rlowess','loess','rloess','invset loess','rinvset loess','ls'};

switch action
	case 'exit'
		delete(PlotScatter_id);

	case 'save'
		set(EditFrame_id,'Visible','off');
		
%		name=get(Array_id,'Name');
%		name=name(strfind(name,'-')+2:length(name));
		figsave_cb(0);

		set(EditFrame_id,'Visible','on');

	case 'edit'
		Edit_id=gcbo;
		num=str2num(get(Edit_id,'String'));
		limits=get(Edit_id,'UserData');

		if isempty(num)==1
			num=limits(3);
			beep;
		else
			switch limits(4)
				case 0
					if num<limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
				case 1
					if num<=limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 2
					if num<limits(1) | num>=limits(2)
						num=limits(3);
						beep;
					end;
				case 3
					if num<=limits(1) | num>limits(2)
						num=limits(3);
						beep;
					end;
			end;
		end;
		set(Edit_id,'String',num2str(num));

	case 'sample_pop'
		data_struct=get(PlotScatter_id,'UserData');
		ref_array_nr=get(RefSamplePop_id,'Value');
		array_nr=get(SamplePop_id,'Value');
		if ref_array_nr~=data_struct.ref_array_nr || array_nr~=data_struct.array_nr
			data_struct.ref_array_nr=ref_array_nr;
			data_struct.array_nr=array_nr;
			data_struct.fit=[];
			set(PlotScatter_id,'UserData',data_struct);
			plot_scatterplot_cb('redraw');
		end;

	case 'group_pop'
		data_struct=get(PlotScatter_id,'UserData');
		group_nr=get(gcbo,'Value');
		if gcbo==GroupPop1_id
			if group_nr~=data_struct.selected_group1
				data_struct.selected_group1=group_nr;
			end;
			set(PlotScatter_id,'UserData',data_struct);
			plot_scatterplot_cb('redraw');
		else
			if group_nr~=data_struct.selected_group2
				data_struct.selected_group2=group_nr;
			end;
			set(PlotScatter_id,'UserData',data_struct);
			plot_scatterplot_cb('redraw');
		end;

	case 'smooth_pop'
		data_struct=get(PlotScatter_id,'UserData');
		data_struct.fit=[];
		set(PlotScatter_id,'UserData',data_struct);

	case 'plot_type'
		data_struct=get(PlotScatter_id,'UserData');
		set(get(PlotSubmenu_id,'Child'),'Checked','off');
		set(gcbo,'Checked','on');

		data_struct.plot_type=get(gcbo,'Tag');
		data_struct.fit=[];

		set(PlotScatter_id,'UserData',data_struct);
		plot_scatterplot_cb('redraw');

	case 'plot_fit'
		data_struct=get(PlotScatter_id,'UserData');
		if data_struct.plot_fit==0
			data_struct.plot_fit=1;
			state='on';
		else
			data_struct.plot_fit=0;
			state='off';
		end;
		set(gcbo,'Checked',state);
		set(SmoothMethodText_id,'Enable',state);
		set(SmoothMethodPop_id,'Enable',state);
		set(SmoothParamText_id,'Enable',state);
		set(SmoothParamEdit_id,'Enable',state);
		set(SmoothButton_id,'Enable',state);

		set(PlotScatter_id,'UserData',data_struct);
		plot_scatterplot_cb('redraw');

	case 'smooth'
		data_struct=get(PlotScatter_id,'UserData');
		data_struct.fit=[];
		set(PlotScatter_id,'UserData',data_struct);
		plot_scatterplot_cb('redraw');

	case 'normalize'
		data_struct=get(PlotScatter_id,'UserData');
		if data_struct.norm==0
			data_struct.norm=1;
			set(gcbo,'Checked','on');
		else
			data_struct.norm=0;
			set(gcbo,'Checked','off');
		end;
		data_struct.fit=[];
		set(PlotScatter_id,'UserData',data_struct);
		plot_scatterplot_cb('redraw');

	case 'plot_line'
		data_struct=get(PlotScatter_id,'UserData');
		if data_struct.plot_line==0
			data_struct.plot_line=1;
			range=get(PlotAxes_id,'XLim');
			hold on;
			switch data_struct.plot_type
				case {'ma','residues'}
					data_struct.line=plot([range(1) range(2)],[0 0]);
				case 'scatter'
					data_struct.line=plot([range(1) range(2)],[range(1) range(2)]);
			end;
			set(data_struct.line,'Color',[0.5 0.5 0.5]);
			hold off;
			set(gcbo,'Checked','on');
		else
			delete(data_struct.line);
			data_struct.plot_line=0;
			data_struct.line=[];
			set(gcbo,'Checked','off');
		end;
		set(PlotScatter_id,'UserData',data_struct);

	case 'plot_thresholds'
		data_struct=get(PlotScatter_id,'UserData');
		if data_struct.plot_thresholds==0
			data_struct.plot_thresholds=1;
			th=log10(data_struct.threshold_value);
			range=get(PlotAxes_id,'XLim');
			hold on;
			switch data_struct.plot_type
				case {'ma','residues'}
					data_struct.thresholds=[plot(x_range,[th th]) plot(x_range,[-1*th -1*th])];
				case 'scatter'
					data_struct.thresholds=[plot([x_range(1) x_range(2)-th],[x_range(1)+th x_range(2)]) plot([x_range(1)+th x_range(2)],[x_range(1) x_range(2)-th])];
			end;
			set(data_struct.thresholds(1),'Color',[0.5 0.5 0.5]);
			set(data_struct.thresholds(2),'Color',[0.5 0.5 0.5]);
			hold off;
			set(gcbo,'Checked','on');
		else
			delete(data_struct.thresholds(1));
			delete(data_struct.thresholds(2));
			data_struct.plot_thresholds=0;
			data_struct.thresholds=[];
			set(gcbo,'Checked','off');
		end;
		set(PlotScatter_id,'UserData',data_struct);

	case 'plot_invset'
		data_struct=get(PlotScatter_id,'UserData');
		if data_struct.plot_invset==0
			data_struct.plot_invset=1;
			set(gcbo,'Checked','on');
		else
			data_struct.plot_invset=0;
			set(gcbo,'Checked','off');
		end;
		data_struct.inv_set=[];
		set(PlotScatter_id,'UserData',data_struct);
		plot_scatterplot_cb('redraw');
		
	case 'log_scale'
		data_struct=get(PlotScatter_id,'UserData');
		if data_struct.log_scale==0
			data_struct.log_scale=1;
			set(gcbo,'Checked','on');
		else
			data_struct.log_scale=0;
			set(gcbo,'Checked','off');
		end;
		data_struct.fit=[];
		set(PlotScatter_id,'UserData',data_struct);
		plot_scatterplot_cb('redraw');

	case 'use_colors'
		data_struct=get(PlotScatter_id,'UserData');
		if data_struct.use_colors==0
			data_struct.use_colors=1;
			set(gcbo,'Checked','on');
		else
			data_struct.use_colors=0;
			set(gcbo,'Checked','off');
		end;
		set(PlotScatter_id,'UserData',data_struct);		
		plot_scatterplot_cb('redraw');

	case 'marker_big'
		data_struct=get(PlotScatter_id,'UserData');
		if data_struct.marker_size==2
			data_struct.marker_size=5;
			set(gcbo,'Checked','on');
			set(get(gcbo,'UserData'),'Checked','off');
			
		end;
		set(PlotScatter_id,'UserData',data_struct);		
		plot_scatterplot_cb('redraw');

	case 'marker_small'
		data_struct=get(PlotScatter_id,'UserData');
		if data_struct.marker_size==5
			data_struct.marker_size=2;
			set(gcbo,'Checked','on');
			set(get(gcbo,'UserData'),'Checked','off');
			
		end;
		set(PlotScatter_id,'UserData',data_struct);		
		plot_scatterplot_cb('redraw');

	case 'marker_clickable'
		data_struct=get(PlotScatter_id,'UserData');
		if data_struct.marker_clickable==0
			data_struct.marker_clickable=1;
			set(gcbo,'Checked','on');
		else
			data_struct.marker_clickable=0;
			set(gcbo,'Checked','off');
		end;
		set(PlotScatter_id,'UserData',data_struct);		
		plot_scatterplot_cb('redraw');

	case 'click'
		data_struct=get(PlotScatter_id,'UserData');
		index=get(gcbo,'UserData');

		if index>=0
			set(GeneNameEdit_id,'String',data_struct.gnames{index});
			
			if strcmp(get(gcbf,'selectiontype'),'open')
				config=get(findobj(Array_id,'Tag','FileOpen'),'UserData');	
			
				config.view_struct.selected_gene=index;
				config.view_struct.selected_array=max(config.view_struct.selected_array,1);
				set(findobj(Array_id,'Tag','FileOpen'),'UserData',config);
				mstat_cb('set_selected_gene');
			end;
			%figure(frame);
		end;

	case 'update'
		data=get(Array_id,'UserData');
		anames=get(findobj(Array_id,'Tag','SelectedArrayNameEdit'),'UserData');
		cnames=get(findobj(Array_id,'Tag','GeneClassPop'),'UserData');
		if length(cnames)==1
			cnames={''};
		else
			cnames=[cnames;{''}];
		end;

		data_struct=get(PlotScatter_id,'UserData');
		data_struct.data=data;
		data_struct.data_median=median(data,2);
		%data_struct.ref_array_nr=get(RefSamplePop_id,'Value');
		%data_struct.array_nr=get(SamplePop_id,'Value');
		data_struct.gorder=get(findobj(Array_id,'Tag','GeneClassAxes'),'UserData');
		data_struct.gnames=get(findobj(Array_id,'Tag','SelectedGeneNameEdit'),'UserData');
		data_struct.groups_count=max(length(cnames)-1,1);
		%data_struct.selected_group1=get(GroupPop1_id,'Value');
		%data_struct.selected_group2=get(GroupPop2_id,'Value');
		
		set(PlotScatter_id,'UserData',data_struct);
		plot_scatterplot_cb('redraw',PlotScatter_id);
		
	case 'redraw'
		set(PlotScatter_id,'Pointer','watch');
		drawnow;
		data_struct=get(PlotScatter_id,'UserData');

		axes(PlotAxes_id);
		delete(findobj(PlotAxes_id,'Type','line'));
		delete(findobj(PlotAxes_id,'Type','text'));		
		axis auto;
		hold on;

		if data_struct.ref_array_nr>size(data_struct.data,2)
			data_x=data_struct.data_median;
		else
			data_x=data_struct.data(:,data_struct.ref_array_nr);
		end;
		data_y=data_struct.data(:,data_struct.array_nr);

		excluded_x=find(isnan(data_x)==1);
		excluded_y=find(isnan(data_y)==1);
		excluded=unique([excluded_x;excluded_y]);
		
		if data_struct.log_scale==1
			excluded_x=find(data_x<=0);
			data_x(excluded_x)=1;
			data_x=log10(data_x);
			data_x(excluded_x)=0;

			excluded_y=find(data_y<=0);
			data_y(excluded_y)=1;
			data_y=log10(data_y);
			data_y(excluded_y)=0;
	
			excluded=unique([excluded ; excluded_x ; excluded_y]);
		end;

		switch data_struct.plot_type
			case 'ma'
				m=data_y-data_x;
				a=0.5*(data_y+data_x);

				data_x=a;
				data_y=m;
			case 'residues'
				r=data_y-data_x;

				data_y=r;
		end;

		if data_struct.norm==1
			data_y=data_smoothnorm(data_x,data_y,excluded,fit_str{get(SmoothMethodPop_id,'Value')},str2num(get(SmoothParamEdit_id,'String')));
			data_struct.fit=[];
		end;

		colors_count=size(data_struct.color,1);
		for i=1:data_struct.groups_count
			if data_struct.use_colors==0 || data_struct.groups_count==1
				cindex=2;
			else
				cindex=mod(i,colors_count);
				if cindex==0
					cindex=colors_count;
				end;
			end;

			index=find(data_struct.gorder==i);
			if data_struct.marker_clickable==1
				for j=1:length(index)
					hnd=plot(data_x(index(j)),data_y(index(j)),data_struct.point_symbol);
					set(hnd,'MarkerSize',data_struct.marker_size,'MarkerFaceColor',data_struct.color(cindex,:),'MarkerEdgeColor',data_struct.color(cindex,:),'ButtonDownFcn','plot_scatterplot_cb(''click'')','UserData',index(j));
				end;
			else
				hnd=plot(data_x(index),data_y(index),data_struct.point_symbol);
				set(hnd,'MarkerSize',data_struct.marker_size,'MarkerFaceColor',data_struct.color(cindex,:),'MarkerEdgeColor',data_struct.color(cindex,:));
			end;
		end;

		x_range=get(PlotAxes_id,'XLim');
		y_range=get(PlotAxes_id,'YLim');
		switch data_struct.plot_type
			case {'ma','residues'}
				y_range=[-1*max(abs(y_range)) max(abs(y_range))];
			case 'scatter'
				x_range=[min(x_range(1),y_range(1)) max(x_range(2),y_range(2))];
				y_range=x_range;
		end;
		set(PlotAxes_id,'XLim',x_range);
		set(PlotAxes_id,'YLim',y_range);

		if data_struct.plot_line==1
			switch data_struct.plot_type
				case {'ma','residues'}
					data_struct.line=plot(x_range,[0 0]);
				case 'scatter'
					data_struct.line=plot(x_range,y_range);
			end;
			set(data_struct.line,'Color',[0.5 0.5 0.5]);
		end;

		if data_struct.plot_thresholds==1
			th=log10(data_struct.threshold_value);
			switch data_struct.plot_type
				case {'ma','residues'}
					data_struct.thresholds=[plot(x_range,[th th]) plot(x_range,[-1*th -1*th])];
				case 'scatter'
					data_struct.thresholds=[plot([x_range(1) x_range(2)-th],[x_range(1)+th x_range(2)]) plot([x_range(1)+th x_range(2)],[x_range(1) x_range(2)-th])];
			end;
			set(data_struct.thresholds(1),'Color',[0.5 0.5 0.5]);
			set(data_struct.thresholds(2),'Color',[0.5 0.5 0.5]);
		end;

		if data_struct.selected_group1>0 && data_struct.groups_count~=1
			index=find(data_struct.gorder==data_struct.selected_group1);
			marker_size=data_struct.marker_size+3;
			for j=1:length(index)
				hnd=plot(data_x(index(j)),data_y(index(j)),data_struct.point_symbol);
				set(hnd,'MarkerSize',marker_size,'MarkerFaceColor',[1 0 0],'MarkerEdgeColor',[0 0 0],'ButtonDownFcn','plot_scatterplot_cb(''click'')','UserData',index(j));
			end;
		end;

		if data_struct.selected_group2>0 && data_struct.groups_count~=1
			index=find(data_struct.gorder==data_struct.selected_group2);
			marker_size=data_struct.marker_size+3;
			for j=1:length(index)
				hnd=plot(data_x(index(j)),data_y(index(j)),data_struct.point_symbol);
				set(hnd,'MarkerSize',marker_size,'MarkerFaceColor',[0 1 0],'MarkerEdgeColor',[0 0 0],'ButtonDownFcn','plot_scatterplot_cb(''click'')','UserData',index(j));
			end;
		end;

		full_smooth=[];
		if data_struct.plot_fit==1
			method=fit_str{get(SmoothMethodPop_id,'Value')};
			f=str2num(get(SmoothParamEdit_id,'String'));
			
			if (~isempty(strfind(method,'invset')) || data_struct.plot_invset==1) && isempty(data_struct.invset)
				data_struct.invset=select_invariant(data_struct.data,floor(size(data_struct.data,1)/10));
			end;
			
			if isempty(data_struct.fit)
				if ~isempty(strfind(method,'invset'))
					index_min=find(data_x==min(data_x));
					index_max=find(data_x==max(data_x));

					nodes_x=data_x([index_min;data_struct.invset;index_max]);
					nodes_y=data_y([index_min;data_struct.invset;index_max]);
					
					[data_struct.fit,data_struct.fit_param]=data_smoothingc(data_x,data_y,excluded,method,f,nodes_x,nodes_y);
					full_smooth=data_smoothingc(data_x,data_y,excluded,method,f);
				else
					[data_struct.fit,data_struct.fit_param]=data_smoothingc(data_x,data_y,excluded,method,f);
					full_smooth=[];
				end;
			end;
			
			hnd=plot(data_struct.fit(1,:),data_struct.fit(2,:));
			set(hnd,'LineWidth',2,'Color',[0 0 0]);
			
			if data_struct.plot_invset==1
				for i=1:length(data_struct.invset)
					hnd=plot(data_x(data_struct.invset(i)),data_y(data_struct.invset(i)),'v');
					set(hnd,'MarkerSize',6,'MarkerFaceColor',[1 0 0],'MarkerEdgeColor',[0 0 0],'ButtonDownFcn','plot_scatterplot_cb(''click'')','UserData',data_struct.invset(i));
				end;
			end;

			if strcmp(data_struct.plot_type,'scatter')==1
				if strcmp(method,'ls')==1
					hnd=text(x_range(2)-0.25*(x_range(2)-x_range(1)),y_range(2)-0.90*(y_range(2)-y_range(1)),sprintf('a = %0.3f; b = %0.3f',data_struct.fit_param.a,data_struct.fit_param.b));
					set(hnd,'FontName','Arial CE','FontSize',9);
				end;

				hnd=text(x_range(2)-0.25*(x_range(2)-x_range(1)),y_range(2)-0.95*(y_range(2)-y_range(1)),sprintf('R^2 = %0.3f',data_struct.fit_param.rsq));
				set(hnd,'FontName','Arial CE','FontSize',9);
			end;
						
			if ~isempty(full_smooth)
				hnd=plot(full_smooth(1,:),full_smooth(2,:));
				set(hnd,'LineWidth',2,'Color',[1 0 0]);
			end;
		end;
		hold off;

		set(PlotAxes_id,'FontName','Arial CE','FontSize',9,'XGrid','off','YGrid','off','Box','on');
		anames=get(RefSamplePop_id,'String');
		xlabel(anames{data_struct.ref_array_nr});	
		%xlabel('Median pseudo-sample');
		ylabel(anames{data_struct.array_nr});

		set(PlotScatter_id,'UserData',data_struct);
		set(PlotScatter_id,'Pointer','arrow');
end;

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function invset=select_invariant(data,ranges_count)

nan_index=sum(isnan(data),2);
data(find(nan_index==size(data,2)),:)=[];

range_points_count=floor(length(data)/ranges_count);

m=nanmean(data,2);
[m,index]=sort(m);

invset=zeros(ranges_count,1);
for i=1:ranges_count
	start=(i-1)*range_points_count+1;
	stop=start+range_points_count-1;

	range_data=data(index(start:stop),:);
	cv=sqrt(nan_sd(range_data')')./nan_mean(range_data,2);

	min_index=find(cv==min(cv));
	invset(i)=index(start+min_index(1)-1);
end;