function [fit,fit_param]=data_smoothingc(x,y,excluded,method,f,nodes_x,nodes_y)

if nargin==5
	nodes_x=x;
	nodes_y=y;
end;

not_excluded=[1:length(x)];
not_excluded(excluded)=[];

x=x(not_excluded);
y=y(not_excluded);

[x,index]=sort(x);
y=y(index);

switch method
	case {'lowess','rlowess'}
		if method(1)=='r'
			yfit=lowess(x,y,f,5);
		else
			yfit=lowess(x,y,f,0,0);
		end;

	case {'loess','rloess'}
		if method(1)=='r'
			robust=1;
		else
			robust=0;
		end;

		yfit=loess(x,y,f,robust,2);

	case {'invset loess','rinvset loess'}
		if method(1)=='r'
			robust=1;
		else
			robust=0;
		end;
		yfit=loess(x,y,f,robust,2,nodes_x,nodes_y);
		
	otherwise
		p=polyfit(x,y,1);		
		yfit = polyval(p,x);	%yfit =  p(1) * x + p(2);

		fit_param.a=p(1);
		fit_param.b=p(2);
		
		%coeffs=[x ones(size(x))]\y;
		%fit_parm.a=coeffs(1);
		%fit_parm.b=coeffs(2);
		%yfit=fit_parm.a.*x+fit_parm.b;

end;
fit=[x';yfit'];

yresid = y - yfit;					%Compute the residual values as a vector of signed numbers:
SSresid = sum(yresid.^2);			%Square the residuals and total them to obtain the residual sum of squares:
SStotal = (length(y)-1) * var(y);	%Compute the total sum of squares of y by multiplying the variance of y by the number of observations minus 1:
fit_param.rsq=1 - SSresid/SStotal;	%Compute R2 using the formula given in the introduction of this topic:

