function [F,Ts,p]=anova_test(data,order,s0);

if nargin<2
	error('The function needs al least two arguments');
elseif nargin<3
	s0=0;
end;

dimension=size(data,1);
vectors_count=size(data,2);

class_count=max(order);	

m=zeros(dimension,1);
w=zeros(dimension,1);
b=zeros(dimension,1);

data=data-repmat(mean(data,2),1,vectors_count);
m=mean(data,2);

for i=1:class_count
	class_index=find(order==i);
	class_vectors_count=length(class_index);
	if class_vectors_count~=0
		mi=mean(data(:,class_index),2);
		b=b+class_vectors_count*(mi-m).*(mi-m);
	end;	
end;
t=sum((data-repmat(m,1,vectors_count)).^2,2);
w=t-b;

w_zeros_list=find(w==0);
w(w_zeros_list)=1;

df1=class_count-1;
df2=vectors_count-class_count;

F=(b/df1)./((w/df2)+s0);
F(w_zeros_list)=Inf;

if nargout>1
	Ts=F*(df1/df2);
	if nargout>2
		p=1-fcdf(F,df1,df2);
	end;
end;
