function selected=anova_u(data,order,selected_count);

dimension=size(data,1);
vectors_count=size(data,2);

t=anova_test(data,order);
[t,index]=sort(t,'descend');

selected=zeros(selected_count,1);
selected(1)=index(1);

list=index(1:dimension)';
list(1)=0;
u=zeros(dimension,1);

waitbar_hnd=waitbar(0,'Selekcja cech...');

for i=2:selected_count
	for j=1:dimension
		if list(j)==0
			u(j)=-1;
		else
			u(j)=anova_mv_stat(data([selected(1:i-1);list(j)],:),order);
		end;
	end;
	max_list=find(u==max(u));
	selected(i)=list(max_list(1));
	list(max_list(1))=0;

	waitbar(i/selected_count,waitbar_hnd);
end;

delete(waitbar_hnd);
return;

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function t=anova_mv_stat(data,order);

dimension=size(data,1);
vectors_count=size(data,2);

classes=unique(order);
classes_count=length(classes);

mi=zeros(dimension,classes_count);		%macierz zawierejaca wekotry wartosci srednich w klasach
n=zeros(classes_count,1);			%wektor liczebnosci klas
m=zeros(dimension,1);				%wektor wartosci średniej klas
s=zeros(dimension,dimension);		%wspolna macierz kowariancji klas

for i=1:classes_count
	index=find(order==classes(i));
	n(i)=length(index);
	mi(:,i)=mean(data(:,index),2);
	m=m + n(i)*mi(:,i);
	s=s + n(i)*cov(data(:,index)',1);
end;
m=m/vectors_count;
s=s/(vectors_count-classes_count);

if (dimension<(vectors_count-classes_count-1))
	inv_s=inv(s);
else
	inv_s=pinv(s);
end;

t=0;
for i=1:classes_count
	t=t + n(i)*((mi(:,i)-m)'*inv_s*(mi(:,i)-m));
end;

t=t/(vectors_count-classes_count);
