function [h,pval,g,index]=grubbs(x,alpha)

n=sum(~isnan(x));
m=nan_mean(x);
s=nan_sd(x);

h=0;
index=0;

x_min=min(x);
g=(m-x_min)/s;
if (g>zcritical(n,alpha,0))
	h=-1;
	index=find(x==x_min);
else
	x_max=max(x);
	g=(x_max-m)/s;
	if (g>zcritical(n,alpha,0))
		h=1;
		index=find(x==x_max);
	end;
end;

pval=1-pgrubbs(g,n);

return;

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function zcrit = zcritical(n,alpha,two_sided)
if two_sided==1
	tcrit=tinv(alpha/(2*n),n-2);
else
	tcrit=tinv(alpha/(n),n-2);
end;
zcrit = (n-1)/sqrt(n)*(sqrt(tcrit^2/(n-2+tcrit^2)));
return;

%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function res=pgrubbs(g,n)

s=(g^2*n*(2-n))/(g^2*n-(n-1)^2);
if isfinite(s)==1 && s>0
    t=sqrt(s);
    df=n-2;

    if (isnan(t))
        res=0;
    else
        res=n*(1-tcdf(t,df));
        res(find(res>1))=1;
    end;

    res=1-res;
else
	%disp(sprintf('s=%f (g=%f,n=%d)',s,g,n));
    res=NaN;
end;
return;