function [d,p]=satterthwaite(data,order,class_index,s0)

if nargin<3
	class_index=[min(order) max(order)];
	s0=0;
elseif nargin<4
	s0=0;
end;

ind_x=find(order==class_index(1));
ind_y=find(order==class_index(2));

x=data(:,ind_x)';
y=data(:,ind_y)';
    
if sum(isnan(data(:)))==0
    nx=length(ind_x);
    ny=length(ind_y);

    difference=mean(x)-mean(y);
    var_x=var(x)/nx;
    var_y=var(y)/ny;
else
    nx=sum(~isnan(x));
    ny=sum(~isnan(y));
    
    difference=nanmean(x)-nanmean(y);
    var_x=nanvar(x)./nx;
    var_y=nanvar(y)./ny;
end;

ratio=difference./(sqrt(var_x+var_y)+s0);
d=abs(ratio)';
	
if nargout>1
	df=((var_x+var_y).^2)./((var_x.^2)./(nx-1) + (var_y.^2)./(ny-1));
	p=1-tcdf(ratio,df);
	p=2*min(p,1-p)';
end;