function [c,p,adj_p,index]=selection1D_corr(data,order,selection_method,threshold_method,threshold,sort_method);

dimension=size(data,1);

if nargin<3
	selection_method='corrp';
	threshold_method='none';
	threshold=0.01;
	sort_method='p_val';
end;

if nargin==3
	threshold_method='none';
	threshold=0.01;
	sort_method='p_val';
end;

if nargin==4
	threshold=0.01;
	sort_method='p_val';
end;

if nargin==5
	sort_method='p_val';
end;

selection_method=lower(selection_method);
threshold_method=lower(threshold_method);
sort_method=lower(sort_method);

c=zeros(size(data,1),1);
p=c;

switch selection_method
	case 'corrp'
		disp('Pearson correlation')
		for i=1:length(c)
			[r,pval]=corrcoef(data(i,:),order');
			c(i)=r(1,2);
			p(i)=pval(1,2);
		end;
	case 'corrs'
		disp('Spearmen correlation')
		for i=1:length(c)
			[r,t,pval]=spear(data(i,:)',order);
			c(i)=r;
			p(i)=pval;
		end;
end;

[p,index]=sort(p);
c=c(index);
f=fdr_bh(p,1);

%f=computeBHFDR(p);
%f=f(:,1);
adj_p=f;

if strcmp(threshold_method,'none')==0
	switch threshold_method
		case 'max_features'
			adj_p=f;
			ind=1:threshold;

		case 'min_corr'
			adj_p=f;
			ind=find(abs(c)>=threshold);

		case 'max_pval'
			adj_p=f;
			ind=find(p<=threshold);

		case 'bonferroni'
			adj_p=min(p*dimension,1);
			ind=find(adj_p<=threshold);

		case 'sidak'
			adj_p=min(1-(1-p)^dimension,1);
			ind=find(adj_p<=threshold);

		case 'holm'
			adj_p=zeros(size(p));
			adj_p(1)=p(1)/dimension;
			for i=2:dimension
				adj_p(i)=max(min((dimension-i+1)*p(i),1),adj_p(i-1));
			end;
			ind=find(adj_p<=threshold);

		case 'fdr_bh'
			disp('FDR B&H')
			adj_p=f;
			ind=find(adj_p<=threshold);

		case 'fdr_bh_tst'
			disp('FDR B&H TST')
			adj_p=f;
			r=length(find(adj_p<=(threshold/(1+threshold))))
			switch r
				case 0
					ind=[];
				case dimension
					ind=1:dimension;
				otherwise
					m_m0=dimension/((dimension-r)*(1+threshold))
					if m_m0>1
						adj_p=adj_p/m_m0;
					end;
					ind=find(adj_p<=threshold);
			end;

		case 'fdr_storey'
			disp('FDR STOREY')
			alfa=0.5;
			r=length(find(p<=alfa));
			m_m0=dimension/((dimension-r)/(1-alfa))

			adj_p=f/m_m0;
			ind=find(adj_p<=threshold);

		otherwise
			return;
	end;

	c=c(ind);
	p=p(ind);
	adj_p=adj_p(ind);
	index=index(ind);
end;

if strcmp(sort_method,'none')==0
	switch sort_method
		case 'positive'
			ind=find(c>0);
		case 'negative'
			ind=find(c<0);
		case 'all'
			[s,ind]=sort(c,'descend');
	end;

	c=c(ind);
	p=p(ind);
	adj_p=adj_p(ind);
	index=index(ind);
end;
return;

