function [fc,index]=selection1D_fc(data,order,method,ref_class,threshold)

dimension=size(data,1);

if nargin==2
	method='mean';
	ref_class=1;
	threshold=1;
elseif nargin==2
	ref_class=1;
	threshold=1;
elseif nargin==3
	threshold=1;
end;

method=lower(method);

classes=unique(order);
classes_count=length(classes);

if classes_count==2
	m1=get_mean(data(:,find(order==ref_class)),method);
	m2=get_mean(data(:,find(order~=ref_class)),method);
	%fc=m2./m1;
    fc=get_fc(m1,m2);	
			
	if threshold==1
		index=find(fc<1/threshold | fc>=threshold);
	else
		index=find(fc<=1/threshold | fc>=threshold);
	end;
else
	index=zeros(1,size(data,1));
	if ref_class==1
		for i=1:max(order)
			for j=i+1:max(order)
				m1=get_mean(data(:,find(order==i)),method);
				m2=get_mean(data(:,find(order==j)),method);
				%fc=m2./m1;
				fc=get_fc(m1,m2);
				
				index(find(fc<=1/threshold | fc>=threshold))=1;
			end;
		end;
	elseif ref_class==2
		for i=1:max(order)
			m1=get_mean(data(:,find(order==i)),method);
			m2=get_mean(data(:,find(order~=i)),method);
			%fc=m2./m1;
			fc=get_fc(m1,m2);

			index(find(fc<=1/threshold | fc>=threshold))=1;
		end;
	end;
%	if get(MethodCheck_id,'Value')==1 && strcmp(method_string{get(MethodPop_id,'Value')},'anova2')
%		%osobny przypadek dla anova2
%		disp('anova2');
%		for i=1:max(aorder)
%			current_class_index=find(aorder==i);
%			current_class_order=reorder_labels(aorder2(current_class_index));
%			current_class=sel_data(:,current_class_index);
%			for j=i+1:max(current_class_order)
%				for k=j+1:max(current_class_order)
%					switch fc_string{get(FCMethodPop_id,'Value')}
%						case 'median'
%	%						disp('median');
%							m1=median(current_class(:,find(current_class_order==j))');
%							m2=median(current_class(:,find(current_class_order==k))');
%						case 'gmean'
%	%						disp('gmeam');
%							m1=gmean(current_class(:,find(current_class_order==j))');
%							m2=gmean(current_class(:,find(current_class_order==k))');
%						case 'trimmed'
%	%						disp('trimmed');
%							m1=trimmean(current_class(:,find(current_class_order==j))',4);
%							m2=trimmean(current_class(:,find(current_class_order==k))',4);
%						otherwise
%	%						disp('mean');
%							m1=mean(current_class(:,find(current_class_order==j))');
%							m2=mean(current_class(:,find(current_class_order==k))');
%					end;
%					fc=m2./m1;
%					index(find(fc<=1/threshold | fc>=threshold))=1;
%				end;
%			end;
%		end;
%	end;
	index=find(index>0);
end;
fc=fc(index);

return;

function fc=get_fc(m1,m2)

fc=m2./m1;
fc(isnan(m1) & ~isnan(m2))=-Inf;
fc(~isnan(m1) & isnan(m2))=Inf;
fc(isnan(fc))=1.0;

return;

%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function m=get_mean(data,method,trim)

if nargin==1
	method='mean';
elseif nargin==2
	trim=5;
end;

switch method
	case 'median'
%		disp('median');
		m=nan_median(data')';
	case 'gmean'
%		disp('gmeam');
		m=nan_gmean(data')';
	case 'trimmed'
%		disp('trimmed');
		m=nan_trimmean(data',trim)';
	otherwise
%		disp('mean');
		m=nan_mean(data')';
end;
return;
