function cmap=lut(name,levels_nr,nan_level)

if nargin==1
	levels_nr=256;
	nan_level=0;
end;

if nargin==2
	nan_level=0;
end;

switch name
	case 'red'
		cmap=red(levels_nr);
	case 'green'
		cmap=green(levels_nr);
	case 'blue'
		cmap=blue(levels_nr);
	case 'red_green'
		cmap=red_green(levels_nr);
	case 'hot'
		cmap=hot(levels_nr);
	case 'jet'
		cmap=jet(levels_nr);
	otherwise
		cmap=gray(levels_nr);
end;

if nan_level~=0
	cmap(nan_level,:)=0.5;
end;
return;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function cmap=red(levels_nr)

cmap=zeros(levels_nr,3);
cmap(:,1)=[0:1/(levels_nr-1):1]';
return;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function cmap=green(levels_nr)

cmap=zeros(levels_nr,3);
cmap(:,2)=[0:1/(levels_nr-1):1]';
return;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function cmap=blue(levels_nr)

cmap=zeros(levels_nr,3);
cmap(:,3)=[0:1/(levels_nr-1):1]';
return;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function cmap=red_green(levels_nr)

cmap=zeros(levels_nr,3);

%r=0:1/127:1;
%g=1:-1/127:0;
%cmap(1:128,2)=g';
%cmap(129:256,1)=r';

r=0:1/(levels_nr/2-1):1;
g=1:-1/(levels_nr/2-1):0;
cmap(1:levels_nr/2,2)=g';
cmap(levels_nr/2+1:levels_nr,1)=r';

return;

