/* iterated_ars.h: defintions and prototypes for functions to compute
 * a normalising function based on iterated absolute rank selection
 * invariant sets.
 */
/* Rune Lyngs, February 2003 */

#ifndef _ITERATED_ARS_H
#define _ITERATED_ARS_H

/* Minimum fraction of points to retain */
#define _IARS_MINIMUM_FRACTION 0.04

/* Type definitions for functions required as arguments for
 * iterated_ars.
 */
typedef void *(*_IARS_newfunction)(int, double *, double *);
typedef int (*_IARS_threshold)(double, double, double, double, double, double,
			       int, int, int);

typedef struct {
  int index;
  double value;
} _IARS_idpair;

void *iterated_ars(int n, double *x, double *y, _IARS_newfunction new_function,
		   _IARS_threshold threshold);

#endif
