/* reliability.h: defintions and prototypes for functions to compute a
 * normalising function based on reliability fuzzy invariant sets.
 */
/* Rune Lyngs, February 2003 */

#ifndef _RELIABILITY_H
#define _RELIABILITY_H
#include "gmp_interface.h"

/* Type definitions for functions required as arguments for
 * reliability.
 */
typedef void *(*_RELIABILITY_newfunction)(int, double *, double *, double *);
typedef void (*_RELIABILITY_transform)(int, mp_type *);

typedef struct {
  int index;
  double value;
} _RELIABILITY_idpair;

typedef struct {
  double y;
  double x;
  int i;
  mp_type own_value;
  mp_type agr_value;
} _RELIABILITY_treeitem;

void *reliability(int n, double *x, double *y, double p,
		  _RELIABILITY_newfunction new_function,
		  _RELIABILITY_transform transform);

#endif
