function normalize_genes_cb(action);

Array_id=findobj(0,'Tag','ArrayView');
GNorm_id=findobj(0,'Tag','GNorm');
CenterCheck_id=findobj(GNorm_id,'Tag','CenterCheck');
CenterPop_id=findobj(GNorm_id,'Tag','CenterPop');
StdCheck_id=findobj(GNorm_id,'Tag','StdCheck');
StdPop_id=findobj(GNorm_id,'Tag','StdPop');

center_string={'mean','median'};
norm_string={'std','mean','gmean','median','max'};

switch action
	case 'check'
		if gcbo==CenterCheck_id
			if get(CenterCheck_id,'Value')==1
				set(CenterPop_id,'Enable','on');
			else
				set(CenterPop_id,'Enable','off');
			end;
		else
			if get(StdCheck_id,'Value')==1
				set(StdPop_id,'Enable','on');
			else
				set(StdPop_id,'Enable','off');
			end;
		end;

	case 'normalize'
		set(Array_id,'Pointer','watch');
		set(GNorm_id,'Pointer','watch');
		pause(0.01);

		data=get(Array_id,'UserData');

		if get(CenterCheck_id,'Value')==1
			data=data_center(data,center_string{get(CenterPop_id,'Value')});
		end;
		if get(StdCheck_id,'Value')==1
			data=data_normalize(data,norm_string{get(StdPop_id,'Value')});
		end;
	
		set(Array_id,'UserData',data);

		mstat_cb('prepare_data');
		mstat_cb('redraw');
		mstat_cb('do_gui');

		set(Array_id,'Pointer','arrow');
		set(GNorm_id,'Pointer','arrow');
		delete(GNorm_id);
		
	case 'whitening'
		set(Array_id,'Pointer','watch');
		set(GNorm_id,'Pointer','watch');			
		pause(0.01);

		data=get(Array_id,'UserData');
				
		[white_data,t,inv_t,u]=whitening(data');
		data=u*white_data;

		set(Array_id,'UserData',data');
		set(Array_id,'Pointer','arrow');

		mstat_cb('prepare_data');
		mstat_cb('redraw');

		set(Array_id,'Pointer','arrow');
		set(GNorm_id,'Pointer','arrow');
		delete(GNorm_id);
end;
